import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class AirborneDrone here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class AirborneDrone  extends Units
{
    public AirborneDrone(int iniside, int ix, int iy)
    {
        side = iniside;
        maxhitpoints = 75;
        attackimage = 1;
        armortype = 1;
        armorquantity = 0;
        range = 110;
        hitpoints = 75;
        weapontype = 1;
        damage = 3;
        delay = 12;
        canhitground = true;
        canhitair = true;
        flyer = true;
        speed = 3;
        mapX = ix;
        mapY = iy;
        cost = 60;
    }
    public AirborneDrone(int iniside, Player pl, int ix, int iy)
    {
        owner = pl;
        side = iniside;
        maxhitpoints = 75;
        attackimage = 1;
        armortype = 1;
        armorquantity = 0;
        range = 110;
        hitpoints = 75;
        weapontype = 1;
        damage = 3;
        delay = 12;
        canhitground = true;
        canhitair = true;
        flyer = true;
        speed = 3;
        mapX = ix;
        mapY = iy;
    }
    public void addedToWorld(World w)
    {
        genmaches = (Battleground) w;
        wa = genmaches.array;
        needchange = true;
        id = 7;
    }
    /**
     * Act - do whatever the AirborneDrone wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        updateimage();
        attack();
        createHealthBar();
        perish();
    }    
    public void updateimage()
    {
        if(height <= 60)
        {
            height ++;
        }
        if(unitaction == 0)
        {
            if(needchange)
            {
                if(side == 1)
                {
                    needchange = false;
                    setImage("AirborneDrone.png");
                }
                else if(side == 2)
                {
                    needchange = false;
                    setImage("AirborneDrone.png");
                    getImage().mirrorHorizontally();
                }
            }
        }
        if(unitaction != 0)
        {
            if(unitaction == 1)
            {
                if(needchange)
                {
                if(frame > 1)
                {
                    frame = 1;
                }
                if(side == 1)
                {
                    needchange = false;
                    setImage("AirborneDrone.png");
                }
                else if(side == 2)
                {
                    needchange = false;
                    setImage("AirborneDrone.png");
                    getImage().mirrorHorizontally();
                }
                }
            }
            else if(unitaction == 2)
            {
                if(frame > 1)
                {
                    frame = 1;
                }
                if(needchange)
                {
                if(side == 1)
                {
                    setImage("AirborneDrone.png");
                }
                else if(side == 2)
                {
                    setImage("AirborneDrone.png");
                    getImage().mirrorHorizontally();
                }
                needchange = false;
                }
            }
            else if(unitaction == 3)
            {           
                framechange ++;
                if(!enemyInSight())
                {
                    unitaction = prevact;
                    frame = 1;
                    needchange = true;
                }
                if(reload == 1 && enemyInSight() && getX() > -100  && getX() < 900)
                {
                    Greenfoot.playSound("Pistol.wav");
                }
                    if(framechange >= framechangerate)
                    {
                        frame ++;
                        framechange = 0;
                        needchange = true;
                    }
                if(frame > 2)
                {
                    frame = 1;
                }
                if(side == 1)
                {
                    if(needchange)
                    {
                    needchange = false;
                    setImage("AirborneDrone.png");
                    }
                }
                if(side == 2)
                {
                    if(needchange)
                    {
                    needchange = false;
                    setImage("AirborneDrone.png");
                    getImage().mirrorHorizontally();
                    }
                }
            }
        }
    }
}
