import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;

/**
 * Write a description of class Battleground here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Battleground  extends World
{

    /**
     * Constructor for objects of class Battleground.
     * 
     */
    private static final int Human = 1;
    private static final int Computer = 2;
    private static final int EBC = 0;
    private static final int TIA = 1;
    private static final int Posterity = 2;
    private boolean ready;
    public List Destructible;
    public List GLA;
    public List AARGH;
    public List destroyLibertarianism;
    public List apokteinete;
    public List yalala;
    public List chrysos;
    public List Leftfaction;
    public List Rightfaction;
    public boolean left_select_EBC;
    public boolean left_select_TIA;
    public boolean left_select_PoS;
    public boolean left_select_random;
    public int left_controller;
    public int left_AIbehavior;
    public boolean right_select_EBC;
    public boolean right_select_TIA;
    public boolean right_select_PoS;
    public boolean right_select_random;
    public int right_controller;
    public int right_AIbehavior;
    public int camerashift;
    public List players;
    public WorldArray array;
    public int camerachange;
    public Player thePlayer;
    Player AI1;
    Player AI2;
    Player AI3;
    public BattleDummy bd;
    /**
     * Initial settings: Will be replaced by a menu as soon as the game is completed.
     */
    public Battleground()
    {
        // Create a new world with 20x20 cells with a cell size of 10x10 pixels.

        super(800, 600, 1, false); 
        setPaintOrder(Minimap.class, ResourceBar.class, HelpTab.class, Portrait.class, Interface.class, HitPointCheck.class, ProgressBar.class, Flyer.class, Overlay.class, Weapons.class, DestructibleObjects.class, Terrain.class);
        setBackground("PlanetBackground.bmp");
        Menu();
    }

    /**
     * Clears off objects
     */
    public void clear()
    {
        removeObjects(getObjects(Actor.class));
    }

    /**
     * Creates Main Menu
     */
    public void Menu()
    {
        addObject(new Start(1), 300, 200);
        addObject(new Start(2), 300, 250);
        addObject(new Instructions(), 300, 300);
        //addObject(new Credits(), 500, 400);
    }

    /**
     * Creates Instructions page
     */
    public void instructions()
    {
        addObject(new InstructionPanel(1), 350, 300);
        addObject(new Return(), 750, 500);
        addObject(new Proceed(), 750, 400);
    }

    /**
     * Creates the second Instructions page
     */
    public void instructions2()
    {
        addObject(new InstructionPanel(2), 350, 300);
        addObject(new Return(), 750, 500);
    }

    /**
     * Sets up the Skirmish setup.
     */
    public void setSkirmishSetup()
    {
        addObject(new SkirmishMenuPanel(), 350, 200);
        addObject(new Proceed(1), 750, 400);
        for(int h = 0; h < 4; h ++)
        {
            for(int i = 0; i < 5; i++)
            {
                Faction a = new Faction(i, h);
                addObject(a, 200+(i*40), 50 + (h*50));
                if((i == 0 && (h == 1 || h ==3)) || (i == 1 &&(h == 0 || h ==2)))
                {
                    a.select();
                }
            }
        }
        addObject(new Return(), 750, 500);
    }

    /**
     * Learn at your own pace scenario
     */
    public void createOnYourPace()
    {
        array = new WorldArray();
        array.setWidth(4000);
        array.setTutorial(true);
        Player usa = new Player(null, 2);
        AI usaai = new AI(2,1,2,usa);
        usaai.setMainBase(3600, 200);
        usa.giveAI(usaai);
        usa.setResource(500);
        addObject(usaai, 0,250);
        thePlayer = new Player(null, 1);
        thePlayer.setResource(300);
        addObject(thePlayer, 0, 100);
        addObject(usa, 0, 150);
        addObject(usa, 0, 0);
        addObject(new FPS(), 700, 10);
        ButtonCreator artor = new ButtonCreator(array);
        addObject(artor, 0, 50);
        addObject(new Cursor(array, artor), 0, 0);
        addObject(array, 0, 0);
        addObject(new CommandBar(), 400, 520);
        for(int i = 0; i < 100; i++)
        {
            for(int j = 0; j < 12; j++)
            {
                addObject(new Grass(i*40, j*40), i*40, j*40);
            }
        }
        addObject(new VolunteerSphere(1, thePlayer, 120, 40), 120, 40);
        addObject(new VolunteerSphere(1, thePlayer, 120, 80), 120, 80);
        addObject(new VolunteerSphere(1, thePlayer, 120, 120), 120, 120);
        addObject(new VolunteerSphere(1, thePlayer, 80, 40), 80, 40);
        addObject(new VolunteerSphere(1, thePlayer, 80, 80), 80, 80);
        addObject(new VolunteerSphere(1, thePlayer, 80, 120), 80, 120);
        addObject(new OfficerSphere(1, thePlayer, 160, 120), 160, 120);
        addObject(new OfficerSphere(1, thePlayer, 160, 80), 160, 80);
        addObject(new OfficerSphere(1, thePlayer, 160, 40), 160, 40);
        addObject(new RocketSphere(1, thePlayer, 40, 40), 40, 40);
        addObject(new RocketSphere(1, thePlayer, 40, 80), 40, 80);
        addObject(new RocketSphere(1, thePlayer, 40, 120), 40, 120);
        addObject(new StandardArmor(1, thePlayer, 40, 200), 40, 200);
        addObject(new MobileConstructionVehicle(1, thePlayer, 100, 300), 100, 300);
        addObject(new WorkerBaby(2, usa, 3600, 200), 3600, 200);
        addObject(new OreMine(400, 300), 400, 300);
        addObject(new OreMine(1600, 300), 1600, 300);
        addObject(new OreMine(1600, 400), 1600, 400);
        addObject(new OreMine(3000, 300), 3000, 300);
        addObject(new Refinery(1, thePlayer, 200, 400), 200, 400);
        addObject(new WorkerBaby(1, thePlayer, 120, 400), 120, 400);
        //addObject(new MaterialistHub(1, thePlayer, 80, 400, true), 80, 400);
        //Airfield a = new Airfield(1, thePlayer, 80, 400);
        //addObject(a, 80, 400);
        //a.setProduction(8);
    }

    public void act()
    {
        camerachange += camerashift;
        try
        {
            Destructible = (List<DestructibleObjects>) getObjects(DestructibleObjects.class);
            GLA = (List<Units>) getObjects(Units.class);
            AARGH = (List<IngameSprite>) getObjects(IngameSprite.class);
            destroyLibertarianism = (List<Structures>) getObjects(Structures.class);
            apokteinete = (List<Doodad>) getObjects(Doodad.class);
            yalala = (List<Player>) getObjects(Player.class);
            chrysos = (List<OreMine>) getObjects(OreMine.class);
            array.setScreen(camerachange);
            for(java.lang.Object g : Destructible)
            {
                if(g instanceof DestructibleObjects)
                {
                    DestructibleObjects u = (DestructibleObjects) g;
                    if(!u.arraycount)
                    {
                        if(u instanceof VolunteerSphere)
                        {
                            u.arraycount = true;
                            array.TaxeisUniv.get(1).add(u);
                        }
                        if(u instanceof RocketSphere)
                        {
                            u.arraycount = true;
                            array.TaxeisUniv.get(2).add(u);
                        }
                        if(u instanceof Ninja)
                        {
                            u.arraycount = true;
                            array.TaxeisUniv.get(3).add(u);
                        }
                        if(u instanceof StandardArmor)
                        {
                            u.arraycount = true;
                            array.TaxeisUniv.get(4).add(u);
                        }
                        if(u instanceof GunTank)
                        {
                            u.arraycount = true;
                            array.TaxeisUniv.get(5).add(u);
                        }
                        if(u instanceof TankDestroyer)
                        {
                            u.arraycount = true;
                            array.TaxeisUniv.get(6).add(u);
                        }
                        if(u instanceof AirborneDrone)
                        {
                            u.arraycount = true;
                            array.TaxeisUniv.get(7).add(u);
                        }
                        if(u instanceof NapalmBomber)
                        {
                            u.arraycount = true;
                            array.TaxeisUniv.get(8).add(u);
                        }
                        if(u instanceof WorkerSphere)
                        {
                            u.arraycount = true;
                            array.TaxeisUniv.get(9).add(u);
                        }
                    }
                }
            }
            if(array != null)
            {
                array.Actors = Destructible;
                array.Taxeis = GLA;
                array.resterrarum = AARGH;
                array.Aedificium = destroyLibertarianism;
                array.Shrubbery = apokteinete;
                array.Player = yalala;
                array.ResourceSource = chrysos;
            }
            if(Greenfoot.isKeyDown("left"))
            {
                camerashift = 6;
            }
            if(Greenfoot.isKeyDown("right"))
            {
                camerashift = -6;
            }
            if(camerachange > 20)
            {
                camerachange = 20;
            }
            if(camerachange < (array.getWidth() - 820) * -1)
            {
                camerachange = (int)(array.getWidth() - 820) * -1;
            }
            if(!Greenfoot.isKeyDown("left") && !Greenfoot.isKeyDown("right"))
            {
                camerashift = 0;
            }
            if(Greenfoot.isKeyDown("P"))
            {
                System.out.println(array.getx());
                if(players != null)
                {
                    try
                    {
                        for(int i = 0; i < yalala.size(); i++)
                        {
                            Player a = (Player) yalala.get(i);
                            System.out.println(a.resources);
                        }
                    }
                    catch(NullPointerException e)
                    {
                    }
                }
                for(int j = 0; j < getObjects(AI.class).size(); j++)
                {
                    AI b = (AI) getObjects(AI.class).get(j);
                    System.out.println(b.constructor.size());
                }
            }
            //if(Greenfoot.isKeyDown("0"))
            //{
            //    if(ready)
            //    {
            //        ready = false;
            //        addObject(new PistoleerBaby(2, 2500, 40), 1500, 40);
            //        addObject(new PistoleerBaby(2, 2500, 80), 1500, 80);
            //        addObject(new PistoleerBaby(2, 2500, 120), 1500, 120);
            //        for(int i = 0; i < getObjects(PistoleerBaby.class).size(); i++)
            //        {
            //            PistoleerBaby a = (PistoleerBaby) getObjects(PistoleerBaby.class).get(i);
            //            a.setBehavior(1);
            //        }
            //    }
            //}
            //if(Greenfoot.isKeyDown("9"))
            //{
            //    if(ready)
            //    {
            //        ready = false;
            //        addObject(new EBCTank(2, 2500, 40), 2500, 40);
            //        addObject(new EBCTank(2, 2500, 80), 2500, 80);
            //        addObject(new EBCTank(2, 2500, 120), 2500, 120);
            //        for(int i = 0; i < getObjects(EBCTank.class).size(); i++)
            //        {
            //            EBCTank a = (EBCTank) getObjects(EBCTank.class).get(i);
            //            a.setBehavior(1);
            //        }
            //    }
            //}
            //if(!Greenfoot.isKeyDown("9") && !Greenfoot.isKeyDown("0"))
            //{
            //    ready = true;
            //}
        }
        catch(NullPointerException e)
        {
        }
    }

    /**
     * Starts a skirmish game.
     */
    public void startSkirmish()
    {
        int p1 = 0;
        int p2 = 0;
        int p3 = 0;
        int p4 = 0;
        for(java.lang.Object c : getObjects(Faction.class))
        {
            Faction a = (Faction) c;
            if(a.getSelection())
            {
                switch(a.getPlayer())
                {
                    case 0: p1 = a.getFaction(); break;
                    case 1: p2 = a.getFaction(); break;
                    case 2: p3 = a.getFaction(); break;
                    case 3: p4 = a.getFaction(); break;
                }
            }
        }
        runSkirmishgame(p1, p2, p3, p4, 1);
    }

    /**
     * Runs a skirmish game.
     */
    public void runSkirmishgame(int p1, int p2, int p3, int p4, int map)
    {
        clear();
        switch(map)
        {
            case 1:
            for(int i = 0; i < 100; i++)
            {
                for(int j = 0; j < 12; j++)
                {
                    addObject(new Grass(i*40, j*40), i*40, j*40);
                }
            }
            array = new WorldArray();
            array.setWidth(4000);
            addObject(array, 0, 0);
            addObject(new FPS(), 700, 10);
            ButtonCreator artor = new ButtonCreator(array);
            addObject(artor, 0, 50);
            addObject(new Cursor(array, artor), 0, 0);
            addObject(array, 0, 0);
            addObject(new OreMine(250, 50), 250, 50);
            addObject(new OreMine(250, 150), 250, 150);
            addObject(new OreMine(250, 300), 250, 300);
            addObject(new OreMine(250, 400), 250, 400);
            addObject(new OreMine(3750, 50), 3750, 50);
            addObject(new OreMine(3750, 150), 3750, 150);
            addObject(new OreMine(3750, 300), 3750, 300);
            addObject(new OreMine(3750, 400), 3750, 400);
            switch(p1)
            {
                case 1: 
                switch(Greenfoot.getRandomNumber(3))
                {
                    case 0:         
                    thePlayer = new Player(null, 1);
                    thePlayer.setResource(600);
                    addObject(new WorkerBaby(1, thePlayer, 400, 80), 400, 80);
                    addObject(new WorkerBaby(1, thePlayer, 400, 120), 400, 120);
                    addObject(new CommandBar(2), 400, 520);
                    break;
                    case 1:
                    thePlayer = new Player(null, 1);
                    thePlayer.setResource(600);
                    addObject(new MobileConstructionVehicle(1, thePlayer, 400, 100), 400, 100);
                    addObject(new CommandBar(1), 400, 520);
                    break;
                    case 2:
                    thePlayer = new Player(null, 1);
                    thePlayer.setResource(600);
                    addObject(new PosterityConstructionHubCarrier(1, thePlayer, 400, 100), 400, 100);
                    addObject(new CommandBar(3), 400, 520);
                    break;
                }
                break;
                case 2:
                thePlayer = new Player(null, 1);
                thePlayer.setResource(600);
                addObject(new WorkerBaby(1, thePlayer, 400, 80), 400, 80);
                addObject(new WorkerBaby(1, thePlayer, 400, 120), 400, 120);
                addObject(new CommandBar(2), 400, 520);
                break;
                case 3:
                thePlayer = new Player(null, 1);
                thePlayer.setResource(600);
                addObject(new MobileConstructionVehicle(1, thePlayer, 400, 100), 400, 100);
                addObject(new CommandBar(1), 400, 520);
                break;
                case 4:
                thePlayer = new Player(null, 1);
                thePlayer.setResource(600);
                addObject(new PosterityConstructionHubCarrier(1, thePlayer, 400, 100), 400, 100);
                addObject(new CommandBar(3), 400, 520);
                break;
            }
            if(thePlayer != null)
            {
                addObject(thePlayer, 0, 50);
            }
            else
            {
                addObject(new CommandBar(3), 400, 520);
            }
            switch(p2)
            {
                case 1: 
                switch(Greenfoot.getRandomNumber(3))
                {
                    case 0:         
                    AI1 = new Player(null, 1);
                    AI b = new AI(2, 1, 1, AI1);
                    AI1.giveAI(b);
                    AI1.setResource(600);
                    addObject(b, 0, 75);
                    addObject(new WorkerBaby(1, AI1, 400, 280), 400, 280);
                    addObject(new WorkerBaby(1, AI1, 400, 320), 400, 320);
                    break;
                    case 1:
                    AI1 = new Player(null, 1);
                    AI c = new AI(1, Greenfoot.getRandomNumber(2)+1, 1, AI1);
                    AI1.giveAI(c);
                    AI1.setResource(600);
                    addObject(c, 0, 75);
                    addObject(new MobileConstructionVehicle(1, AI1, 400, 300), 400, 300);
                    break;
                    case 2:
                    AI1 = new Player(null, 1);
                    AI d = new AI(3, 1, 1, AI1);
                    AI1.giveAI(d);
                    AI1.setResource(600);
                    addObject(d, 0, 75);
                    addObject(new PosterityConstructionHubCarrier(1, AI1, 400, 300), 400, 300);
                    break;
                }
                break;
                case 2:
                AI1 = new Player(null, 1);
                AI a = new AI(2, 1, 1, AI1);
                AI1.giveAI(a);
                AI1.setResource(600);
                addObject(a, 0, 75);
                addObject(new WorkerBaby(1, AI1, 400, 280), 400, 280);
                addObject(new WorkerBaby(1, AI1, 400, 320), 400, 320);
                break;
                case 3:
                AI1 = new Player(null, 1);
                AI b = new AI(1, Greenfoot.getRandomNumber(2)+1, 1, AI1);
                AI1.giveAI(b);
                AI1.setResource(600);
                addObject(b, 0, 75);
                addObject(new MobileConstructionVehicle(1, AI1, 400, 300), 400, 300);
                break;
                case 4:
                AI1 = new Player(null, 1);
                AI c = new AI(3, 1, 1, AI1);
                AI1.giveAI(c);
                AI1.setResource(600);
                addObject(c, 0, 75);
                addObject(new PosterityConstructionHubCarrier(1, AI1, 400, 300), 400, 300);
                break;
            }
            if(AI1 != null)
            {
                AI1.getAI().setMainBase(400, 300);
                addObject(AI1, 0, 100);
            }
            switch(p3)
            {
                case 1: 
                switch(Greenfoot.getRandomNumber(3))
                {
                    case 0:         
                    AI2 = new Player(null, 2);
                    AI b = new AI(2, 1, 2, AI2);
                    AI2.giveAI(b);
                    AI2.setResource(600);
                    addObject(b, 0, 75);
                    addObject(new WorkerBaby(2, AI2, 3600, 80), 3600, 80);
                    addObject(new WorkerBaby(2, AI2, 3600, 120), 3600, 120);
                    break;
                    case 1:
                    AI2 = new Player(null, 2);
                    AI c = new AI(1, Greenfoot.getRandomNumber(2)+1, 2, AI2);
                    AI2.giveAI(c);
                    AI2.setResource(600);
                    addObject(c, 0, 75);
                    addObject(new MobileConstructionVehicle(2, AI2, 3600, 100), 3600, 300);
                    break;
                    case 2:
                    AI2 = new Player(null, 2);
                    AI d = new AI(3, 1, 2, AI2);
                    AI2.giveAI(d);
                    AI2.setResource(600);
                    addObject(d, 0, 75);
                    addObject(new PosterityConstructionHubCarrier(2, AI2, 3600, 100), 3600, 300);
                    break;
                }
                break;
                case 2:
                AI2 = new Player(null, 2);
                AI a = new AI(2, 1, 2, AI2);
                AI2.giveAI(a);
                AI2.setResource(600);
                addObject(a, 0, 75);
                addObject(new WorkerBaby(2, AI2, 3600, 80), 3600, 80);
                addObject(new WorkerBaby(2, AI2, 3600, 120), 3600, 120);
                break;
                case 3:
                AI2 = new Player(null, 2);
                AI b = new AI(1, Greenfoot.getRandomNumber(2)+1, 2, AI2);
                AI2.giveAI(b);
                AI2.setResource(600);
                addObject(b, 0, 75);
                addObject(new MobileConstructionVehicle(2, AI2, 3600, 100), 3600, 300);
                break;
                case 4:
                AI2 = new Player(null, 2);
                AI c = new AI(3, 1, 2, AI2);
                AI2.giveAI(c);
                AI2.setResource(600);
                addObject(c, 0, 75);
                addObject(new PosterityConstructionHubCarrier(2, AI2, 3600, 100), 3600, 300);
                break;
            }
            if(AI2 != null)
            {
                AI2.getAI().setMainBase(3600, 100);
                addObject(AI2, 0, 100);
            }
            switch(p4)
            {
                case 1: 
                switch(Greenfoot.getRandomNumber(3))
                {
                    case 0:         
                    AI3 = new Player(null, 2);
                    AI b = new AI(2, 1, 2, AI3);
                    AI3.giveAI(b);
                    AI3.setResource(600);
                    addObject(b, 0, 75);
                    addObject(new WorkerBaby(2, AI3, 3600, 280), 3600, 280);
                    addObject(new WorkerBaby(2, AI3, 3600, 320), 3600, 320);
                    break;
                    case 1:
                    AI3 = new Player(null, 2);
                    AI c = new AI(1, Greenfoot.getRandomNumber(2)+1, 2, AI3);
                    AI3.giveAI(c);
                    AI3.setResource(600);
                    addObject(c, 0, 75);
                    addObject(new MobileConstructionVehicle(2, AI3, 3600, 300), 3600, 300);
                    break;
                    case 2:
                    AI3 = new Player(null, 2);
                    AI d = new AI(3, 1, 2, AI3);
                    AI3.giveAI(d);
                    AI3.setResource(600);
                    addObject(d, 0, 75);
                    addObject(new PosterityConstructionHubCarrier(2, AI3, 3600, 300), 3600, 300);
                    break;
                }
                break;
                case 2:
                AI3 = new Player(null, 2);
                AI a = new AI(2, 1, 2, AI3);
                AI3.giveAI(a);
                AI3.setResource(600);
                addObject(a, 0, 75);
                addObject(new WorkerBaby(2, AI3, 3600, 280), 3600, 280);
                addObject(new WorkerBaby(2, AI3, 3600, 320), 3600, 320);
                break;
                case 3:
                AI3 = new Player(null, 2);
                AI b = new AI(1, Greenfoot.getRandomNumber(2)+1, 2, AI3);
                AI3.giveAI(b);
                AI3.setResource(600);
                addObject(b, 0, 75);
                addObject(new MobileConstructionVehicle(2, AI3, 3600, 300), 3600, 300);
                break;
                case 4:
                AI3 = new Player(null, 2);
                AI c = new AI(3, 1, 2, AI3);
                AI3.giveAI(c);
                AI3.setResource(600);
                addObject(c, 0, 75);
                addObject(new PosterityConstructionHubCarrier(2, AI3, 3600, 300), 3600, 300);
                break;
            }
            if(AI3 != null)
            {
                AI3.getAI().setMainBase(3600, 300);
                addObject(AI3, 0, 100);
            }
        }
    }

    public void setOthersFalse(int pl)
    {
        for(java.lang.Object c : getObjects(Faction.class))
        {
            Faction a = (Faction) c;
            if(a.getPlayer() == pl)
            {
                a.deselect();
            }
        }
    }
}
