import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class ConstructionYard here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class ConstructionYard  extends Structures
{
    public ConstructionYard(int iniside, int ix, int iy)
    {
        side = iniside;
        maxhitpoints = 700;
        armortype = 4;
        armorquantity = 4;
        hitpoints = 700;
        mapX = ix;
        mapY = iy;
        deployed = true;
    }
    public ConstructionYard(int iniside, Player pl, int ix, int iy)
    {
        owner = pl;
        side = iniside;
        maxhitpoints = 700;
        armortype = 4;
        armorquantity = 4;
        hitpoints = 700;
        mapX = ix;
        mapY = iy;
        deployed = true;
    }
    public ConstructionYard(int iniside, Player pl, int ix, int iy, MobileConstructionVehicle mcv)
    {
        owner = pl;
        side = iniside;
        maxhitpoints = 700;
        armortype = 4;
        armorquantity = 4;
        hitpoints = mcv.hitpoints;
        mapX = ix;
        mapY = iy;
        deployed = true;
    }
    /**
     * Act - do whatever the ConstructionYard wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        updateImage();
        produce();
        createHealthBar();
        perish();
        createProgressBar();
    }    
    public void updateImage()
    {
        if(frame == 0)
        {
            frame = 1;
        }
        if(prodtype != 0 && getProgress() < 1 && prodtype != 6)
        {
            framechange ++;
            if(framechange >= framechangerate)
            {
                frame ++;
                framechange = 0;
                needchange = true;
            }
            if(frame > 3)
            {
                frame = 1;
            }
            if(needchange)
            {
                needchange = false;
                setImage("ConstructionYard" + frame + ".png");
            }
        }
        if(prodtype == 6)
        {
            framechange ++;
            if(frame == 0)
            {
                frame = 1;
            }
            if(framechange >= framechangerate)
            {
                framechange = 0;
                frame ++;
            }
            if(frame > 3)
            {
                getWorld().addObject(new MobileConstructionVehicle(side, owner, realX(), realY(), this), getX(), getY());
                getWorld().removeObject(this);
            }
            else if(frame <= 3)
            {
                setImage("MobileConVehicleDeploy" + (5 - frame) + ".png");
            }
        }
    }
}
