import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;

/**
 * Write a description of class Cursor here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Cursor  extends Interface
{
    private WorldArray wa;
    private ButtonCreator bc;
    private DestructibleObjects argh;
    private int frame;
    private int framechange;
    private boolean needchange;
    private GreenfootImage image = new GreenfootImage(1,1);
    public Cursor(WorldArray ini, ButtonCreator cfg)
    {
        wa = ini;
        bc = cfg;
    }
    /**
     * Act - do whatever the Cursor wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        MouseInfo ms = Greenfoot.getMouseInfo();
        try
        {
        setLocation(ms.getX(), ms.getY());
        }
        catch(NullPointerException e)
        {
        }
        try
        {
        for(int i = 0; i < wa.Actors.size(); i ++)
        {
        DestructibleObjects a = wa.Actors.get(i);
        List b = getIntersectingObjects(DestructibleObjects.class);
        if(b.contains(a))
        {
            argh = a;
        }
        }
        if(!((ms.getX() >= argh.getX() - Math.abs(argh.getImage().getWidth()/2) && ms.getX() <= argh.getX() + Math.abs(argh.getImage().getWidth()/2)) && (ms.getY() >= argh.getY() - Math.abs(argh.getImage().getHeight()/2) && ms.getY() <= argh.getY() + Math.abs(argh.getImage().getHeight()/2))))
        {
            argh = null;
        }
        if(Greenfoot.mousePressed(null) && argh != null)
        {
            if(ms.getButton() == 1)
            {
                argh.select();
                if(argh instanceof OreMine)
                {
                    Greenfoot.playSound("Mine.wav");
                }
                if(argh.getOwner() == wa.genmaches.thePlayer)
                {
                if(argh instanceof ConstructionYard || argh instanceof PosterityConstructionHub)
                {
                    Greenfoot.playSound("ConstructionYard.wav");
                }
                if(argh instanceof Dojo)
                {
                    Greenfoot.playSound("Dojo.wav");
                }
                if(argh instanceof Airfield)
                {
                    Greenfoot.playSound("Airfield.wav");
                }
                if(argh instanceof Refinery || argh instanceof EBCRefinery || argh instanceof PosterityRefinery)
                {
                    Greenfoot.playSound("Refinery.wav");
                }
                if(argh instanceof TIAWarFactory)
                {
                    Greenfoot.playSound("WarFactory.wav");
                }
                if(argh instanceof StrategyCenter)
                {
                    Greenfoot.playSound("StrategyCenter.wav");
                }
                }
            }
        }
        }
        catch(NullPointerException e)
        {
        }
        updateImage();
    }    
    public void updateImage()
    {
        framechange ++;
        if(argh == null)
        {
            setImage(image);
        }
        if(argh != null)
        {
            if(framechange >= 5)
            {
                framechange = 0;
                frame ++;
                needchange = true;
            }
            if(frame > 9)
            {
                frame = 1;
            }
            try
            {
            if((argh instanceof MobileConstructionVehicle || argh instanceof PosterityConstructionHubCarrier) && argh.selected())
            {
                for(int i = 0; i < wa.Actors.size(); i++)
                {
                    DestructibleObjects a = wa.Actors.get(i);
                    if(a == argh || (a.realX() + a.getImage().getWidth()/2 >= argh.realX() - argh.getImage().getWidth()/2 || a.realX() - a.getImage().getWidth()/2 <= argh.realX() + argh.getImage().getWidth()/2) && (a.realY() + a.getImage().getHeight()/2 >= argh.realY() - argh.getImage().getHeight()/2 || a.realY() - a.getImage().getHeight()/2 <= argh.realY() + argh.getImage().getHeight()/2))
                    {
                        if(needchange)
                        {
                            needchange = false;
                            setImage("Unpack.PNG");
                        }
                        MouseInfo ms = Greenfoot.getMouseInfo();
                        if(Greenfoot.mousePressed(null))
                        {
                            argh.setBehavior(7);
                        }
                    }
                    else
                    {
                        if(needchange)
                        {
                            needchange = false;
                            setImage("UnpackImp.PNG");
                        }
                    }
                }
            }
            else if(argh.getSide() == 1)
            {
                if(needchange)
                {
                    needchange = false;
                    setImage("OverAlly" + frame + ".PNG");
                }
            }
            else if(argh.getSide() == 2)
            {
                if(needchange)
                {
                    needchange = false;
                    setImage("OverEnemy" + frame + ".PNG");
                }
            }
            else if(argh.getSide() == 6)
            {
                if(needchange)
                {
                    needchange = false;
                    setImage("OverNeutral" + frame + ".PNG");
                }
            }
        }
        catch(NullPointerException e)
        {
        }
        }
    }
}
