import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class EBCFactory here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class EBCFactory  extends Structures
{
    private GreenfootImage frame1 = new GreenfootImage("EBCWarFactory.PNG");
    private GreenfootImage build1 = new GreenfootImage("EBCStructureBuilding1.png");
    private GreenfootImage build2 = new GreenfootImage("EBCStructureBuilding2.png");
    private GreenfootImage build3 = new GreenfootImage("EBCStructureBuilding3.png");
    private GreenfootImage build4 = new GreenfootImage("EBCStructureBuilding4.png");
    private GreenfootImage build5 = new GreenfootImage("EBCStructureBuilding5.png");
    public EBCFactory(int iniside, int ix, int iy)
    {
        side = iniside;
        maxhitpoints = 400;
        armortype = 4;
        armorquantity = 2;
        hitpoints = 400;
        mapX = ix;
        mapY = iy;
        cost = 250;
        id = 10;
    }
    public EBCFactory(int iniside, Player pl, int ix, int iy)
    {
        owner = pl;
        side = iniside;
        maxhitpoints = 400;
        armortype = 4;
        armorquantity = 2;
        hitpoints = 400;
        mapX = ix;
        mapY = iy;
        cost = 250;
        id = 10;
    }
    public void addedToWorld(World w)
    {
        id = 10;
        genmaches = (Battleground) w;
        wa = genmaches.array;
        if(side == 1)
        {
            frame1.mirrorHorizontally();
        }
    }
    /**
     * Act - do whatever the EBCFactory wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        if(!deployed)
        {
            if(building >= 1200)
            {
                frame = 1;
                deployed = true;
                progress = 0;
                progressmax = 1;
                progressperc = 0;
                prodtype = 0;
                setImage(frame1);
            }
            else
            {
                if(building % 100 == 0 && getX() > -100 && getX() < 900 && building != 0)
                {
                    Greenfoot.playSound("handsaw2.wav");
                }
                progress = building;
                progressperc = progress/(double)progressmax;
                if(frame < 5)
                {
                    framechange ++;
                    if(framechange >= framechangerate)
                    {
                    frame ++;
                    switch(frame)
                    {
                        case 1: setImage(build1); break;
                        case 2: setImage(build2); break;
                        case 3: setImage(build3); break;
                        case 4: setImage(build4); break;
                        case 5: setImage(build5); break;
                    }
                    }
                }
            }
        }
        createHealthBar();
        createProgressBar();
        perish();
        if(deployed)
        {
            produce();
            createUnit();
        }
    }    
    public void createUnit()
    {
        if(progressperc == 1)
        {
            int dx = 0;
            switch(side)
            {
                case 1: dx = 50; break;
                case 2: dx = -50; break;
            }
            switch(prodtype)
            {
                case 15: getWorld().addObject(new TroopCarrier(side, owner, realX()+dx, realY()), getX()+dx, getY()); break;
                case 16: getWorld().addObject(new AATrack(side, owner, realX()+dx, realY()), getX()+dx, getY()); break;
                case 17: getWorld().addObject(new EBCTank(side, owner, realX()+dx, realY()), getX()+dx, getY()); break;
            }
            clearProduction();
        }
    }
}
