import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Faction here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Faction  extends Buttons
{
    GreenfootImage none = new GreenfootImage("NoFaction.bmp");
    GreenfootImage nonesel = new GreenfootImage("NoFactionSelected.bmp");
    GreenfootImage rand = new GreenfootImage("RandomUnselected.bmp");
    GreenfootImage randsel = new GreenfootImage("RandomSelected.bmp");
    GreenfootImage ebc = new GreenfootImage("EBCUnselected.bmp");
    GreenfootImage ebcsel = new GreenfootImage("EBCInsignia.bmp");
    GreenfootImage tia = new GreenfootImage("TIAUnselected.bmp");
    GreenfootImage tiasel = new GreenfootImage("TIAInsignia.bmp");
    GreenfootImage post = new GreenfootImage("PosterityUnselected.bmp");
    GreenfootImage postsel = new GreenfootImage("PosterityInsignia.bmp");
    private int image;
    private int player;
    private boolean selected;
    private Battleground genmaches;
    public Faction(int ini, int cfg)
    {
        image = ini;
        player = cfg;
    }
    public void addedToWorld(World w)
    {
        genmaches = (Battleground) w;
    }
    /**
     * Act - do whatever the Faction wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        updateImage();
        if(Greenfoot.mousePressed(this))
        {
            genmaches.setOthersFalse(player);
            selected = true;
        }
    }    
    public void updateImage()
    {
        if(!selected)
        {
            switch(image)
            {
                case 0: setImage(none); break;
                case 1: setImage(rand); break;
                case 2: setImage(ebc); break;
                case 3: setImage(tia); break;
                case 4: setImage(post); break;
            }
        }
        if(selected)
        {
            switch(image)
            {
                case 0: setImage(nonesel); break;
                case 1: setImage(randsel); break;
                case 2: setImage(ebcsel); break;
                case 3: setImage(tiasel); break;
                case 4: setImage(postsel); break;
            }
        }
    }
    public int getPlayer()
    {
        return player;
    }
    public int getFaction()
    {
        return image;
    }
    public boolean getSelection()
    {
        return selected;
    }
    public void deselect()
    {
        selected = false;
    }
    public void select()
    {
        selected = true;
    }
}
