import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Helipad here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Helipad  extends Structures
{
    private LightBomber occupant;
    private int rearming;
    public boolean auto;
    public Helipad(int iniside, int ix, int iy)
    {
        side = iniside;
        maxhitpoints = 300;
        armortype = 4;
        armorquantity = 3;
        hitpoints = 300;
        mapX = ix;
        mapY = iy;
        cost = 100;
        id = 14;
    }
    public Helipad(int iniside, Player ini, int ix, int iy)
    {
        owner = ini;
        side = iniside;
        maxhitpoints = 300;
        armortype = 4;
        armorquantity = 3;
        hitpoints = 300;
        mapX = ix;
        mapY = iy;
        cost = 100;
        id = 14;
    }
    public void addedToWorld(World w)
    {
        id = 14;
        deployed = true;
        buttoncooldown.add(0);
        genmaches = (Battleground) w;
        wa = genmaches.array;
        if(side == 1)
        {
            getImage().mirrorHorizontally();
        }
    }
    /**
     * Act - do whatever the Helipad wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        createHealthBar();
        createProgressBar();
        produce();
        createUnit();
        perish();
        if(occupant != null)
        {
            rearm();
            if(auto)
            {
                sendOutAutomatically();
            }
        }
    }    
    public void createUnit()
    {
        if(progressperc == 1)
        {
            switch(prodtype)
            {
                case 24: if(occupant == null){LightBomber a = new LightBomber(side, owner, realX(), realY(), this); occupant = a; getWorld().addObject(a, getX(), getY());} else{getWorld().addObject(new ErrorText("You already have an bomber in this airfield.", 250), 400, 400); getOwner().resources += 250;}; clearProduction(); break;
                case 23: getWorld().addObject(new FloatingDisc(getOwner().getSide(), getOwner(), realX(), realY()), getX(), getY()); clearProduction(); break;
            }
        }
    }
    public void rearm()
    {
        if((int)(Math.sqrt(Math.pow(realX() - occupant.realX(), 2) + Math.pow(realY() - occupant.realY(), 2))) < 5 && occupant.getGameHeight() <= 0)
        {
            rearming ++;
            if(rearming >= 100)
            {
                rearming = 0;
                if(occupant.bombs < 2)
                {
                    occupant.bombs ++;
                }
            }
        }
    }
    public void sendOutAutomatically()
    {
        if(occupant.bombs == 2 || (occupant.bombs > 0 && occupant.getAction() == 7 && occupant.getTarget().hitpoints <= 0))
        {
            for(DestructibleObjects a : wa.Actors)
            {
                if(a.getSide() != getSide() && a.getSide() != 6)
                {
                    occupant.enemy = a;
                    occupant.setBehavior(7);
                }
            }
        }
    }
    public LightBomber getOccupant()
    {
        return occupant;
    }
}
