import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.util.List;

/**
 * Minimap. Special thanks to bourne who provided the source code that I based my Minimap on.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Minimap  extends Interface
{
    private WorldArray data;
    private GreenfootImage bufferImage;
    private GreenfootImage greenDot;
    private GreenfootImage redDot;
    private GreenfootImage yellowDot;
    private GreenfootImage greenBigDot;
    private GreenfootImage redBigDot;
    private GreenfootImage yellowBigDot;
    private GreenfootImage yellowBiggerDot;
    private GreenfootImage[] al = new GreenfootImage[4];
    public Minimap(WorldArray ini)
    {
        bufferImage = new GreenfootImage(300, 100);
        bufferImage.setColor(Color.WHITE);
        bufferImage.fillRect(0, 0, 300, 100);
        bufferImage.setTransparency(120);
        greenDot = new GreenfootImage(2, 2);
        greenDot.setColor(Color.GREEN);
        greenDot.fillRect(0,0,2,2);
        greenBigDot = new GreenfootImage(3, 3);
        greenBigDot.setColor(Color.GREEN);
        greenBigDot.fillRect(0,0,3,3);
        redDot = new GreenfootImage(2, 2);
        redDot.setColor(Color.RED);
        redDot.fillRect(0,0,2,2);
        redBigDot = new GreenfootImage(3, 3);
        redBigDot.setColor(Color.RED);
        redBigDot.fillRect(0,0,3,3);
        yellowDot = new GreenfootImage(2, 2);
        yellowDot.setColor(Color.YELLOW);
        yellowDot.fillRect(0,0,2,2);
        yellowBigDot = new GreenfootImage(3, 3);
        yellowBigDot.setColor(Color.YELLOW);
        yellowBigDot.fillRect(0,0,3,3);
        yellowBiggerDot = new GreenfootImage(4, 4);
        yellowBiggerDot.setColor(Color.YELLOW);
        yellowBiggerDot.fillRect(0,0,4,4);
        for(int i = 0; i < 4; i++)
        {
            al[i] = new GreenfootImage(10 - (2*i), 10 - (2*i));
            al[i].setColor(Color.CYAN);
            al[i].drawRect(0,0, 9 - (2*i), 9 - (2*i)); 
        }
        data = ini;
    }
    /**
     * Act - do whatever the Minimap wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        GreenfootImage a = new GreenfootImage(bufferImage);
        List<Units> taliban = data.Taxeis;
        if(taliban != null)
        {
            for(int i = 0; i < taliban.size(); i++)
            {
                DestructibleObjects activist = (DestructibleObjects) taliban.get(i);
                if(activist.side == 1)
                {
                    a.drawImage(greenDot ,(int) ((float) (taliban.get(i).realX()) / data.getWidth() * 300f), (int) ((float) (taliban.get(i).realY() + 10) / 4.4f));
                }
                if(activist.side == 2)
                {
                    a.drawImage(redDot ,(int) ((float) (taliban.get(i).realX()) / data.getWidth() * 300f), (int) ((float) (taliban.get(i).realY() + 10) / 4.4f));
                }
                if(activist.side == 6)
                {
                    a.drawImage(yellowDot ,(int) ((float) (taliban.get(i).realX()) / data.getWidth() * 300f), (int) ((float) (taliban.get(i).realY() + 10) / 4.4f));
                }
                //a.fillRect((int) ((float) (taliban.get(i).realX()) / data.getWidth() * 300f), (int) ((float) (taliban.get(i).realY() + 10) / 4.4f), 2, 2);
            }
        }
        List<Structures> asty = data.Aedificium;
        if(taliban != null)
        {
            for(int i = 0; i < asty.size(); i++)
            {
                DestructibleObjects activist = (DestructibleObjects) asty.get(i);
                if(activist.side == 1)
                {
                    a.drawImage(greenBigDot ,(int) ((float) (asty.get(i).realX()) / data.getWidth() * 300f), (int) ((float) (asty.get(i).realY() + 10) / 4.4f));
                }
                if(activist.side == 2)
                {
                    a.drawImage(redBigDot ,(int) ((float) (asty.get(i).realX()) / data.getWidth() * 300f), (int) ((float) (asty.get(i).realY() + 10) / 4.4f));
                }
                if(activist.side == 6)
                {
                    a.drawImage(yellowBigDot ,(int) ((float) (asty.get(i).realX()) / data.getWidth() * 300f), (int) ((float) (asty.get(i).realY() + 10) / 4.4f));
                }
                //a.fillRect((int) ((float) (asty.get(i).realX()) / data.getWidth() * 300f), (int) ((float) (asty.get(i).realY() + 10) / 440f * 100f), 3, 3);
            }
        }
        List<OreMine> irishrepublicanarmy = data.ResourceSource;
        if(irishrepublicanarmy != null)
        {
            for(int i = 0; i < irishrepublicanarmy.size(); i++)
            {
                a.drawImage(yellowBiggerDot ,(int) ((float) (irishrepublicanarmy.get(i).realX()) / data.getWidth() * 300f), (int) ((float) (irishrepublicanarmy.get(i).realY() + 10) / 4.4f));
            }
        }
        a.setColor(Color.BLUE);
        a.drawRect((int)(data.getx()/(float)data.getWidth()*300f) * -1, 0, (int)((800)/(float)data.getWidth()*300f), 100);
        List<BattleDummy> alert = (List<BattleDummy>) (getWorld().getObjects(BattleDummy.class));
        if(alert != null)
        {
            for(int i = 0; i < alert.size(); i++)
            {
                BattleDummy b = (BattleDummy) alert.get(i);
                a.setColor(Color.CYAN);
                a.drawImage(al[b.minimapImage()],(int) ((float) (alert.get(i).realX()) / data.getWidth() * 300f), (int) ((float) (alert.get(i).realY() + 10) / 4.4f));
            }
        }
        setImage(a);
        MouseInfo mouse = Greenfoot.getMouseInfo();
        if (Greenfoot.mousePressed(this) && mouse.getButton() == 1)
        {
            float x = ((float)mouse.getX() - (float)getX() + 150f) / 300f * (float)(data.getWidth()) - 400f;
            if (x < 0)
                x = 0;
            else if (x > (data.getWidth()-820))
                x = data.getWidth()-820;
            data.setScreen(((int)x - (int)Math.IEEEremainder((int)x, 10))*-1);
        }
    }    
}
