import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class RocketLaunchPad here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class MissileLaunchPad  extends Structures
{
    public ChemicalWarhead cw;
    public MissileLaunchPad(int iniside, int ix, int iy)
    {
        side = iniside;
        maxhitpoints = 400;
        armortype = 4;
        armorquantity = 3;
        hitpoints = 400;
        mapX = ix;
        mapY = iy;
        cost = 200;
        id = 16;
    }
    public MissileLaunchPad(int iniside, Player ini, int ix, int iy)
    {
        owner = ini;
        side = iniside;
        maxhitpoints = 400;
        armortype = 4;
        armorquantity = 3;
        hitpoints = 400;
        mapX = ix;
        mapY = iy;
        cost = 200;
        id = 16;
    }
    public void addedToWorld(World w)
    {
        id = 16;
        deployed = true;
        genmaches = (Battleground) w;
        buttoncooldown.add(0);
        wa = genmaches.array;
        if(side == 2)
        {
            getImage().mirrorHorizontally();
        }
    }
    /**
     * Act - do whatever the RocketLaunchPad wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        createHealthBar();
        createProgressBar();
        produce();
        perish();
        prepareStrike();
        createUnit();
    }    
    public void createUnit()
    {
        if(getProgress() >= 1)
        {
        switch(prodtype)
            {
                case 30: case 8: if(cw == null){ChemicalWarhead a = new ChemicalWarhead(side, realX(), realY()); cw = a; getWorld().addObject(a, getX(), getY());} else{getWorld().addObject(new ErrorText("You already have a rocket in this launch pad.", 250), 400, 400); getOwner().resources += 200;}; clearProduction(); break;
            }
            clearProduction();
        }
    }
}
