import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
import java.awt.geom.*;

/**
 * Write a description of class Overlay here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Overlay  extends Weapons
{
    private int image;
    private int frame = 1;
    private int framechange;
    private GreenfootImage imageframe;
    private int damage;
    private int damagetype;
    private boolean isvalid;
    private int duration;
    private int cooldown;
    /**
     * Act - do whatever the Overlay wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public Overlay()
    {
    }

    public Overlay(int img, int dam, int dt, int ix, int iy, int ih)
    {
        height = ih;
        image = img;
        damage = dam;
        damagetype = dt;
        mapX = ix;
        mapY = iy;
        if(image == 2)
        {
            duration = 150;
        }
        if(image == 1)
        {
            setImage("GunOverlay1.png");
        }
        if(image == 13)
        {
            setImage("MBTOverlay1.png");
        }
        if(image == 12)
        {
            setImage("PosterityofSentinelGenericExplosion1.png");
        }
        if(image == 2)
        {
            setImage("Napalm1.png");
        }
        if(image == 3)
        {
            setImage("Explosion.png");
        }
        if(image == 4)
        {
            duration = 60;
            setImage("Flak.png");
        }
        if(image == 14)
        {
            duration = 3000;
            setImage("ChemicalOverlay.png");
        }
    }

    public void addedToWorld(World w)
    {
        genmaches = (Battleground) w;
        wa = genmaches.array;
        if(image == 12)
        {
            for(DestructibleObjects a : wa.Actors)
            {
                if((a.realX() >= realX()-getImage().getWidth()/2 && a.realX() <= realX()+getImage().getWidth()/2) && (a.realY() >= realY()-getImage().getHeight()/2 && a.realY() <= realY()+getImage().getHeight()/2) && cooldown <= 0 && a.getGameHeight() < 15)
                {
                    a.takedamage(30, 8);
                }
            }
        }
    }

    public void act() 
    {
        // Add your action code here.
        framechange ++;
        updateimage();
    }    

    public void updateimage()
    {
        if(image == 1)
        {
            if(framechange >= framechangerate)
            {
                frame ++;
                framechange = 0;
                needchange = true;
            }
            if(needchange)
            {
                imageframe = new GreenfootImage("GunOverlay" + frame + ".png");
                setImage(imageframe);
                needchange = false;
            }
            if(frame >= 5)
            {
                getWorld().removeObject(this);
            }
        }
        if(image == 13)
        {
            if(framechange >= framechangerate)
            {
                frame ++;
                framechange = 0;
                needchange = true;
            }
            if(needchange)
            {
                imageframe = new GreenfootImage("MBTOverlay" + frame + ".png");
                setImage(imageframe);
                needchange = false;
            }
            if(frame >= 5)
            {
                getWorld().removeObject(this);
            }
        }
        if(image == 3)
        {
            if(framechange >= framechangerate)
            {
                frame ++;
                framechange = 0;
                needchange = true;
            }
            if(needchange)
            {
                imageframe = new GreenfootImage("Explosion" + frame + ".png");
                setImage(imageframe);
                needchange = false;
            }
            if(frame >= 3)
            {
                getWorld().removeObject(this);
            }
        }
        if(image == 2)
        {
            duration --;
            cooldown --;
            if(duration <= 0)
            {
                getWorld().removeObject(this);
                isvalid = false;
            }
            else
            {
                if(needchange)
                {
                    imageframe = new GreenfootImage("Napalm" + frame + ".png");
                    setImage(imageframe);
                    needchange = false;
                }
                if(framechange >= framechangerate && frame < 5)
                {
                    frame ++;
                    framechange = 0;
                    needchange = true;
                }
                if(frame >= 5)
                {
                    if(framechange >= framechangerate)
                    {
                        frame = Greenfoot.getRandomNumber(3)+4;
                        framechange = 0;
                        needchange = true;
                    }
                }
                try
                {
                    for(DestructibleObjects a : wa.Actors)
                    {
                        if((a.realX() >= realX()-getImage().getWidth()/2 && a.realX() <= realX()+getImage().getWidth()/2) && (a.realY() >= realY()-getImage().getHeight()/2 && a.realY() <= realY()+getImage().getHeight()/2) && cooldown <= 0 && a.getGameHeight() < 15)
                        {
                            cooldown = 10;
                            a.takedamage(damage, damagetype);
                        }
                    }
                }
                catch(NullPointerException e)
                {
                }
            }

        }
        if(image == 12)
        {
            framechange ++;
            cooldown --;
            if(cooldown < 0)
            {
                cooldown = framechangerate - 1;
            }
            if(frame > 7)
            {
                getWorld().removeObject(this);
                isvalid = false;
            }
            else
            {
                if(needchange)
                {
                    imageframe = new GreenfootImage("PosterityofSentinelGenericExplosion" + frame + ".png");
                    setImage(imageframe);
                    needchange = false;
                }
                if(framechange >= framechangerate)
                {
                    frame ++;
                    framechange = 0;
                    needchange = true;
                }
                try
                {
                    for(DestructibleObjects a : wa.Actors)
                    {
                        Point2D.Double argh = new Point2D.Double(a.realX(), a.realY());
                        if(collisionBox().contains(argh) && cooldown <= 0 && a.getGameHeight() < 15)
                        {
                            if(a instanceof Structures)
                            {
                                Structures b = (Structures) a;
                            }
                            a.takedamage(3, 7);
                        }
                    }
                }
                catch(NullPointerException e)
                {
                }

            }
        }
        if(image == 4)
        {
            duration --;
            if(duration <= 0)
            {
                getWorld().removeObject(this);
                isvalid = false;
            }
            int xx = Greenfoot.getRandomNumber(3);
            int yy = Greenfoot.getRandomNumber(3);
            xx -= Greenfoot.getRandomNumber(3); 
            yy -= Greenfoot.getRandomNumber(3); 
            mapX += xx;
            mapY += yy;
        }
        if(image == 14)
        {
            duration --;
            cooldown --;
            if(cooldown < 0)
            {
                cooldown = 5;
            }
            if(duration <= 0)
            {
                getWorld().removeObject(this);
                isvalid = false;
            }
            int xx = Greenfoot.getRandomNumber(3);
            int yy = Greenfoot.getRandomNumber(3);
            xx -= Greenfoot.getRandomNumber(3); 
            yy -= Greenfoot.getRandomNumber(3); 
            mapX += xx;
            mapY += yy;
            try
            {
                for(DestructibleObjects a : wa.Actors)
                {
                    if((a.realX() >= realX()-getImage().getWidth()/2 && a.realX() <= realX()+getImage().getWidth()/2) && (a.realY() >= realY()-getImage().getHeight()/2 && a.realY() <= realY()+getImage().getHeight()/2) && cooldown <= 0 && a.getGameHeight() < 15)
                    {
                        a.takedamage(10, 5);
                    }
                }
            }
            catch(NullPointerException e)
            {
            }
        }
    }
}