import greenfoot.*;
/**
 * Write a description of class Player here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Player  extends Actor
{
    // instance variables - replace the example below with your own
    public double resources;
    public Battleground bg;
    public AI ai;
    public int side;
    private ResourceBar rb;
    public WorldArray wa;
    /**
     * Array of number of buildings of type per player. Used for AI and tech tree purposes.
     * 1- Refinery 2-Dojo 3-War Factory 4-Airfield 5-Strategy Center (TIA)
     * 6- Refinery 7-Baby Camp 8-Capitalist Lodge 9-Materialist Hub 10-Factory (EBC)
     * 11- Refinery 12-Airstrip 13-Radome 14-Helipad 15-Nanoassembly Mainframe 16-Missile Launch Pad (Posterity)
     */
    public int[] Requirements = new int[40];
    /**
     * Array that stores the upgrades that applies to the player.
     * 1- Genetically Engineered Regeneration 2- AP rockets 3-Placeholder for Upgrade
     * 4- Basic Training 5-Basic Weapons 6-Improved Weapons 7-Vulcan Gun
     * 8- HE Shells 8- Advanced Technology 10-Placeholder for Upgrade
     */
    public int[] Upgrades = new int[20];
    /**
     * Constructor for objects of class Player
     */
    public Player()
    {
    }
    public Player(AI ini, int cfg)
    {
        ai = ini;
        side = cfg;
    }
    public void addedToWorld(World w)
    {
        bg = (Battleground) w;
    }
    public void act()
    {
        if(wa == null)
        {
            wa = bg.array;
        }
        if(rb == null && ai == null)
        {
            rb = new ResourceBar(this);
            getWorld().addObject(rb, 100, 450);
        }
        for(Structures a : wa.Aedificium)
        {
            if(!a.techtreecount && a.hitpoints > 0 && a.getOperational() && a.getOwner() == this)
            {
                a.techtreecount = true;
                Requirements[a.id] ++;
            }
        }
    }
    public int getSide()
    {
        return side;
    }
    public void setResource(int ini)
    {
        resources = ini;
    }
    public void giveAI(AI a)
    {
        ai = a;
    }
    public AI getAI()
    {
        return ai;
    }
}
