import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Obsolete Object due to the outlay of the Command Bar.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Portrait  extends Actor
{
    public boolean onfield = true;
    private boolean createtext;
    private int helptext;
    private WorldArray wa;
    public void addedToWorld(World w)
    {
        wa = ((Battleground) w).array;
    }
    /**
     * Constructor Portait: Sets image.
     * input (integer) faction: The faction of the player, which determines the Image.
     */
    public Portrait(int faction)
    {
        switch(faction)
        {
            case 0: setImage("Kakistoargyrion.bmp"); break;
            case 1: setImage("CyanSphereofDoom.bmp"); break;
            case 2: setImage("Aristokrates.bmp"); break;
        }
    }
    /**
     * For tutorial.
     */
    public Portrait(int faction, int advise)
    {
        helptext = advise;
        switch(faction)
        {
            case 0: setImage("Kakistoargyrion.bmp"); break;
            case 1: setImage("CyanSphereofDoom.bmp"); break;
            case 2: setImage("Aristokrates.bmp"); break;
        }
        getImage().setTransparency(170);
    }
    public void act() 
    {
        // Add your action code here.
        if(Greenfoot.mousePressed(this))
        {
            if(!createtext && helptext != 0)
            {
                switch(helptext)
                {
                    case 1: getWorld().addObject(new AdviseText(this, "Greetings, commander! The Cyan Sphere of", "Doom salutes you. This is one of","our forward bases, and it is","near an EBC camp. In this scenario,", "I shall teach you the basic mechanics of the", "game. Press me to proceed."), 230, 50); createtext = true; break;
                    case 2: getWorld().addObject(new AdviseText(this, "Select units by clicking on the unit","desired. To select multiple units","Hold the left mouse button and drag", "to make a rectangle that selects all the", "units inside the rectangle,", "allowing you to command multiple units."), 230, 50); createtext = true; break;
                    case 3: getWorld().addObject(new AdviseText(this, "You may notice that some units have","special buttons that you don't normally","get with a group of units. To see", "what it does, put your mouse over the button", "and a tooltip will appear.", "Look at a Volunteer Sphere."), 230, 50); createtext = true; break;
                    case 4: getWorld().addObject(new AdviseText(this, "There is a refinery in the lower side","of your base. Worker Spheres","will travel back and forth between it and ", "the refinery, generating funds.", "Having a solid economy is essential to your", "success as a commander."), 230, 50); createtext = true; break;
                    case 5: getWorld().addObject(new AdviseText(this, "If you have noticed the large vehicle,","that is the Construction Hub Carrier.","Clicking on it will automatically unpack it,", "allowing you to build structures.", "To move it, drag a rectangle and issue a move", "order."), 230, 50); createtext = true; break;
                    case 6: getWorld().addObject(new AdviseText(this, "Yes, we have captured an Worker Baby,","and as such, feel free to see the EBC arsenal","as well. EBC's building mechanics are much", "different than ours, and as such it", "has its advantages and disadvantages.",""), 230, 50); createtext = true; break;
                    case 8: getWorld().addObject(new AdviseText(this, "If you think you are ready, take on","the EBC camp.","", "", "", ""), 205, 50); createtext = true; break;
                    case 7: getWorld().addObject(new AdviseText(this, "The EBC has sent a expeditionary force.","Keep in mind that all segment of ","the formation should be filled", "to avoid getting our critical", "infrastructures in risk.", ""), 205, 50); createtext = true; break;
                }
            }
            else if(createtext)
            {
                if(helptext != 3 && helptext != 6)
                {
                    wa.addtut();
                }
                onfield = false;
                wa.aa = null;
                getWorld().removeObject(this);
            }
        }
    }    
}
