import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class SphereHoverCycle here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class SphereHoverCycle  extends Units
{
    private GreenfootImage frame1 = new GreenfootImage("SphereHoverCycle.png");
    private GreenfootImage frame2 = new GreenfootImage("SphereHoverCycle2.png");
    private GreenfootImage frame3 = new GreenfootImage("SphereHoverCycle3.png");
    private GreenfootImage frame4 = new GreenfootImage("SphereHoverCycle4.png");
    private GreenfootImage frame5 = new GreenfootImage("SphereHoverCycle5.png");
    private GreenfootImage frame1l = new GreenfootImage("SphereHoverCycle.png");
    private GreenfootImage frame2l = new GreenfootImage("SphereHoverCycle2.png");
    private GreenfootImage frame3l = new GreenfootImage("SphereHoverCycle3.png");
    private GreenfootImage frame4l = new GreenfootImage("SphereHoverCycle4.png");
    private GreenfootImage frame5l = new GreenfootImage("SphereHoverCycle5.png");
    private GreenfootImage frame1r = new GreenfootImage("SphereHoverCycle.png");
    private GreenfootImage frame2r = new GreenfootImage("SphereHoverCycle2.png");
    private GreenfootImage frame3r = new GreenfootImage("SphereHoverCycle3.png");
    private GreenfootImage frame4r = new GreenfootImage("SphereHoverCycle4.png");
    private GreenfootImage frame5r = new GreenfootImage("SphereHoverCycle5.png");
    public SphereHoverCycle(int iniside, int ix, int iy)
    {
        side = iniside;
        maxhitpoints = 90;
        attackimage = 5;
        armortype = 2;
        armorquantity = 0;
        range = 120;
        hitpoints = 90;
        weapontype = 3;
        damage = 8;
        delay = 70;
        canhitground = true;
        speed = 4;
        mapX = ix;
        mapY = iy;
        cost = 30;
    }
    public SphereHoverCycle(int iniside, Player pl, int ix, int iy)
    {
        owner = pl;
        side = iniside;
        maxhitpoints = 90;
        attackimage = 5;
        armortype = 2;
        armorquantity = 0;
        range = 120;
        hitpoints = 90;
        weapontype = 3;
        damage = 8;
        delay = 70;
        canhitground = true;
        speed = 4;
        mapX = ix;
        mapY = iy;
        cost = 30;
    }
    public void addedToWorld(World w)
    {
        mechanical = true;
        id = 19;
        genmaches = (Battleground) w;
        wa = genmaches.array;
        if(side == 2)
        {
            frame1.mirrorHorizontally();
            frame2.mirrorHorizontally();
            frame3.mirrorHorizontally();
            frame4.mirrorHorizontally();
            frame5.mirrorHorizontally();
            setImage(frame1);
        }
        frame1l.mirrorHorizontally();
        frame2l.mirrorHorizontally();
        frame3l.mirrorHorizontally();
        frame4l.mirrorHorizontally();
        frame5l.mirrorHorizontally();
    }
    /**
     * Act - do whatever the SphereHoverCycle wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        updateimage();
        attack();
        createHealthBar();
        perish();
        collisionReact();
        alignImage();
        flipimage();
    }    
    public void updateimage()
    {
        if(unitaction == 0)
        {
            if(needchange)
            {
                setImage(frame1);
            }
        }
        if(unitaction != 0)
        {
            framechange++;
            if(unitaction == 1)
            {
                if(framechange <= framechangerate)
                {
                    needchange = true;
                    framechange = 0;
                    frame ++;
                }
                if(realX() <= 0 || realX() >= wa.getWidth())
                {
                    unitaction = 0;
                }
                if(frame > 1)
                {
                    frame = 1;
                }
                if(needchange)
                    {
                        needchange = false;
                        switch(frame)
                        {
                            case 1: setImage(frame2); break;
                        }
                    }
            }
            else if(unitaction == 2 || unitaction == 4 || unitaction == 5)
            {
                if(framechange <= framechangerate)
                {
                    needchange = true;
                    framechange = 0;
                    frame ++;
                }
                if(realX() <= 0 || realX() >= wa.getWidth())
                {
                    unitaction = 0;
                }
                else
                {
                if(frame > 1)
                {
                    frame = 1;
                }
                if(needchange)
                    {
                        needchange = false;
                        switch(frame)
                        {
                            case 1: setImage(frame2); break;
                        }
                    }
                }
            }
            else if(unitaction == 3)
            {
                if(!enemyInSight())
                {
                    unitaction = prevact;
                    frame = 1;
                    needchange = true;
                }
                    if(framechange >= reload - 3)
                    {
                        needchange = true;
                        if(frame > 2)
                        {
                            framechange = 0;
                        }
                        frame ++;
                    }
                    if(needchange)
                    {
                        needchange = false;
                        switch(frame)
                        {
                            case 1: setImage(frame3); break;
                            case 2: setImage(frame4); break;
                            case 3: setImage(frame5); break;
                        }
                    }
                if(frame > 3)
                {
                    frame = 1;
                    needchange = true;
                }
            }
        }
    }
    @Override public void flipimage()
    {
        if(dir == LEFT)
        {
            if(frame1 != frame1l)
            {
                frame1 = frame1l;
            }
            if(frame2 != frame2l)
            {
                frame2 = frame2l;
            }
            if(frame3 != frame3l)
            {
                frame3 = frame3l;
            }
            if(frame4 != frame4l)
            {
                frame4 = frame4l;
            }
            if(frame5 != frame5l)
            {
                frame5 = frame5l;
            }
        }
        if(dir == RIGHT)
        {
            if(frame1 != frame1r)
            {
                frame1 = frame1r;
            }
            if(frame2 != frame2r)
            {
                frame2 = frame2r;
            }
            if(frame3 != frame3r)
            {
                frame3 = frame3r;
            }
            if(frame4 != frame4r)
            {
                frame4 = frame4r;
            }
            if(frame5 != frame5r)
            {
                frame5 = frame5r;
            }
        }
    }
    @Override public void playSound()
    {
        if(getX() > -200 && getX() < 1000)
        {
            Greenfoot.playSound("Hovercycle.wav");
        }
    }
}
