import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.ArrayList;

/**
 * Write a description of class Structures here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Structures  extends DestructibleObjects
{
    protected int progress;
    protected int progressmax = 1;
    protected int prodtype;
    protected double progressperc;
    protected ProgressBar pb;
    protected Units attacker;
    public ArrayList<Integer> buttoncooldown = new ArrayList<Integer>();
    /**
     * Stores a boolean value pertinent to tech tree of the owner: true if the it does contribute to tech tree
     */
    public boolean techtreecount;
    /**
     * Stores the boolean value: true if it is done.
     */
    protected boolean deployed;
    /**
     * Stores # act of construction on unit.
     */
    protected int building;
    public Structures()
    {
    }
    public void act() 
    {
        // Add your action code here.
    }    
    public double getProgress()
    {
        return progressperc;
    }
    public void setProduction(int i)
    {
        prodtype = i;
    }
    public void setProdMax(int i)
    {
        progressmax = i;
    }
    public void createProgressBar()
    {
        if(pb == null && meteron)
        {
                pb = new ProgressBar(this);
                getWorld().addObject(pb, getX(), getY());
                hasmeter = true;
        }
        try
        {
            if(pb.getWorld() == null && meteron)
            {
                getWorld().addObject(pb, getX(), getY());
                hasmeter = true;
            }
        }
        catch(NullPointerException e)
        {
        }
    }
    public int getProduction()
    {
        return prodtype;
    }
    public void clearProduction()
    {
        progressperc = 0;
        progressmax = 1;
        progress = 0;
        prodtype = 0;
    }
    public void produce()
    {
        if(prodtype != 0)
        {
            if(progress < progressmax)
            {
                progress ++;
                progressperc = (double) progress/progressmax;
            }
        }
    }
    @Override public void perish()
    {
        if(hitpoints <= 0)
        {
            getWorld().removeObject(this);
            if(getX() > - 700 && getX() < 1500)
            {
                Greenfoot.playSound("StructureLost.wav");
            }
            if(techtreecount)
            {
                owner.Requirements[id] --;
                if(ai != null)
                {
                    ai.Structures[id] --;
                }
            }
        }
    }
    public void prepareStrike()
    {
        for(int i = 0; i < buttoncooldown.size(); i++)
        {
            Integer a = buttoncooldown.get(i);
            if(a.intValue() > 0)
            {
                 Integer b = new Integer(a.intValue() - 1);
                 buttoncooldown.set(i, b);
            }
        }
    }
    public boolean getOperational()
    {
        return deployed;
    }
    public int getSelfProgress()
    {
        return building;
    }
    public void addBuild(int i)
    {
        building += i;
    }
    /**
     * Essentially set production, but also sets production time.
     */
    public void setAIProduction(int type)
    {
        prodtype = type;
        switch(type)
        {
            case 1: setProdMax(35); break;
            case 2: setProdMax(55); break;
            case 3: setProdMax(130); break;
            case 4: setProdMax(230); break;
            case 5: setProdMax(200); break;
            case 6: setProdMax(250); break;
            case 7: setProdMax(90); break;
            case 8: setProdMax(650); break;
            case 9: setProdMax(70); break;
            case 10: setProdMax(70); break;
            case 11: setProdMax(60); break;
            case 12: setProdMax(50); break;
            case 13: setProdMax(110); break;
            case 14: setProdMax(140); break;
            case 15: setProdMax(95); break;
            case 16: setProdMax(180); break;
            case 17: setProdMax(120); break;
            case 18: setProdMax(60); break;
            case 19: setProdMax(100); break;
        }
    }
    /**
     * For EBC structures, checks if an worker baby is building this structure.
     */
    public boolean isBeingBuilt()
    {
        boolean o = false;
        for(Units a : wa.Taxeis)
        {
            if(a instanceof WorkerBaby)
            {
                if(a.getAction() == 6 && a.realX() >= realX()-getImage().getWidth()/2 && a.realX() <= realX()+getImage().getWidth()/2 && a.realY() >= realY()-getImage().getHeight()/2 && a.realY() <= realY()+getImage().getHeight()/2)
                {
                    o = true;
                }
            }
        }
        return o;
    }
    /**
     * Certain attacks are not done by the unit itself: For example, the Floating Disc's laser or the Flamethrower baby. To make sure the AI defends against those, this method exists to give the victims the attacker.
     */
    public void giveAttacker(Units a)
    {
        attacker = a;
    }
    public Units getAttacker()
    {
        return attacker;
    }
}
