import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class TankDestroyer here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class TankDestroyer  extends Units
{
    private GreenfootImage frame1 = new GreenfootImage("TankDestroyer1.png");
    private GreenfootImage frame2 = new GreenfootImage("TankDestroyer2.png");
    private GreenfootImage frame1l = new GreenfootImage("TankDestroyer1.png");
    private GreenfootImage frame2l = new GreenfootImage("TankDestroyer2.png");
    private GreenfootImage frame1r = new GreenfootImage("TankDestroyer1.png");
    private GreenfootImage frame2r = new GreenfootImage("TankDestroyer2.png");
    public TankDestroyer(int iniside, int ix, int iy)
    {
        side = iniside;
        maxhitpoints = 300;
        attackimage = 2;
        armortype = 2;
        armorquantity = 1;
        range = 160;
        hitpoints = 300;
        weapontype = 6;
        damage = 10;
        delay = 30;
        canhitground = true;
        canhitair = false;
        speed = 4;
        mapX = ix;
        mapY = iy;
        cost = 130;
    }
    public TankDestroyer(int iniside, Player pl, int ix, int iy)
    {
        side = iniside;
        maxhitpoints = 300;
        attackimage = 2;
        armortype = 2;
        armorquantity = 1;
        range = 170;
        hitpoints = 300;
        weapontype = 6;
        damage = 10;
        delay = 30;
        canhitground = true;
        canhitair = false;
        speed = 4;
        mapX = ix;
        mapY = iy;
        owner = pl;
        cost = 130;
    }
    public void addedToWorld(World w)
    {
        mechanical = true;
        id = 6;
        genmaches = (Battleground) w;
        wa = genmaches.array;
        if(side == 1)
        {
            frame1.mirrorHorizontally();
            frame2.mirrorHorizontally();
            setImage(frame1);
        }
        frame1r.mirrorHorizontally();
        frame2r.mirrorHorizontally();
    }
    /**
     * Act - do whatever the TankDestroyer wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        updateimage();
        attack();
        createHealthBar();
        perish();
        collisionReact();
        alignImage();
    }    
    public void updateimage()
    {
        if(unitaction == 0 && needchange)
        {
            needchange = false;
            setImage(frame1);
        }
        if(unitaction == 3)
        {
            if(!enemyInSight())
                {
                    unitaction = prevact;
                    frame = 1;
                    needchange = true;
                }
                if(frame == 1)
                {
                    if(framechange >= reload - 3)
                    {
                        needchange = true;
                        framechange = 0;
                        frame ++;
                    }
                }
                if(frame == 2)
                {
                    if(framechange >= framechangerate)
                    {
                        needchange = true;
                        framechange = 0;
                        frame ++;
                    }
                }
                    if(needchange)
                    {
                        needchange = false;
                        switch(frame)
                        {
                            case 1: setImage(frame1); break;
                            case 2: setImage(frame2); break;
                        }
                    }
                if(frame > 2)
                {
                    frame = 1;
                    needchange = true;
                }
        }
    }
    @Override public void flipimage()
    {
        if(dir == LEFT)
        {
            if(frame1 != frame1l)
            {
                frame1 = frame1l;
            }
            if(frame2 != frame2l)
            {
                frame2 = frame2l;
            }
        }
        if(dir == RIGHT)
        {
            if(frame1 != frame1r)
            {
                frame1 = frame1r;
            }
            if(frame2 != frame2r)
            {
                frame2 = frame2r;
            }
        }
    }
}
