import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Unit here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Unit  extends InGame
{
    public Structures base;
    private int id;
    public Unit(Structures ini, int cfg)
    {
        base = ini;
        id = cfg;
        switch(id)
        {
            case 1: setImage("VolunteerSphere.bmp"); techsufficient = true; break;
            case 2: setImage("RocketSphere.bmp"); techsufficient = true; break;
            case 3: setImage("Ninja.bmp"); techsufficient = true; break;
            case 4: setImage("ArmoredVehicle.bmp"); techsufficient = true; break;
            case 5: setImage("GunTank.bmp"); techsufficient = true; break;
            case 6: setImage("TankDestroyer.bmp"); if(base.getOwner().Requirements[5] > 0){techsufficient = true;} else{getImage().setTransparency(100);}; break;
            case 7: setImage("AirborneDrone.bmp"); techsufficient = true; break;
            case 8: setImage("NapalmBomber.bmp"); if(base.getOwner().Requirements[5] > 0){techsufficient = true;} else{getImage().setTransparency(100);}; break;
            case 9: setImage("WorkerSphere.bmp"); techsufficient = true; break;
            case 10: setImage("PistolSquad.bmp"); techsufficient = true; break;
            case 11: setImage("GrenadierBaby.bmp"); techsufficient = true; break;
            case 12: setImage("ExplosiveBaby.bmp"); if(base.getOwner().Requirements[8] > 0){techsufficient = true;} else{getImage().setTransparency(100);}; break;
            case 13: setImage("ExplosiveBabyTeam.bmp"); if(base.getOwner().Requirements[8] > 0 && base.getOwner().Requirements[9] > 0){techsufficient = true;} else{getImage().setTransparency(100);}; break;
            case 14: setImage("FlamethrowerBaby.bmp"); if(base.getOwner().Requirements[9] > 0){techsufficient = true;} else{getImage().setTransparency(100);}; break;
            case 15: setImage("TroopCarrier.bmp"); techsufficient = true; break;
            case 16: setImage("AATrack.bmp"); techsufficient = true; break;
            case 17: setImage("LightTank.bmp"); techsufficient = true; break;
            case 18: setImage("WorkerBaby.bmp"); techsufficient = true; break;
            case 19: setImage("SphereHoverCycle.bmp"); techsufficient = true; break;
            case 20: setImage("MBT.bmp"); techsufficient = true; break;
            case 21: setImage("ChemicalTank.bmp"); techsufficient = true; break;
            case 22: setImage("Artillery.bmp"); if(base.getOwner().Requirements[13] > 0){techsufficient = true;} else{getImage().setTransparency(100);}; break;
            case 24: setImage("LightBomber.bmp"); techsufficient = true; break;
            case 23: setImage("FloatingDisc.bmp"); if(base.getOwner().Requirements[15] > 0){techsufficient = true;} else{getImage().setTransparency(100);}; break;
            case 25: setImage("MechaHoplite.bmp"); if(base.getOwner().Requirements[15] > 0){techsufficient = true;} else{getImage().setTransparency(100);}; break;
            case 26: setImage("Gunship.bmp"); if(base.getOwner().Requirements[15] > 0){techsufficient = true;} else{getImage().setTransparency(100);}; break;
            case 27: setImage("Harvester.bmp"); techsufficient = true; break;
            case 30: setImage("BuildChemicalWarhead.bmp"); techsufficient = true; break;
            case 31: setImage("ConstructionHubCarrier.bmp"); techsufficient = true; break;
            case 32: setImage("ConstructionHubCarrierPost.bmp"); techsufficient = true; break;
            case 33: setImage("SphereOfficer.bmp"); techsufficient = true; break;
        }
    }
    /**
     * Act - do whatever the Unit wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        if(Greenfoot.mousePressed(this))
        {
            if(base != null && base.getWorld() != null && techsufficient)
            {
                if(base.getProduction() == 0)
                {
                    switch(id)
                    {
                        case 1: if(base.getOwner().resources >= 25){base.setProdMax(35); base.getOwner().resources -= 25; base.setProduction(id);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 250), 400, 400);}; break;
                        case 2: if(base.getOwner().resources >= 40){base.setProdMax(55); base.getOwner().resources -= 40; base.setProduction(id);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 250), 400, 400);}; break;
                        case 3: if(base.getOwner().resources >= 110){base.setProdMax(130); base.getOwner().resources -= 110; base.setProduction(id);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 250), 400, 400);};; break;
                        case 4: if(base.getOwner().resources >= 130){base.setProdMax(230); base.getOwner().resources -= 130; base.setProduction(id);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 250), 400, 400);}; break;
                        case 5: if(base.getOwner().resources >= 110){base.setProdMax(200); base.getOwner().resources -= 110; base.setProduction(id);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 250), 400, 400);}; break;
                        case 6: if(base.getOwner().resources >= 150){base.setProdMax(250); base.getOwner().resources -= 150; base.setProduction(id);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 250), 400, 400);}; break;
                        case 7: if(base.getOwner().resources >= 60){base.setProdMax(90); base.getOwner().resources -= 60; base.setProduction(id);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 250), 400, 400);}; break;
                        case 8: if(base.getOwner().resources >= 250){base.setProdMax(650); base.getOwner().resources -= 250; base.setProduction(id);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 250), 400, 400);}; break;
                        case 9: if(base.getOwner().resources >= 50){base.setProdMax(70); base.getOwner().resources -= 50; base.setProduction(id);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 250), 400, 400);}; break;
                        case 10: if(base.getOwner().resources >= 40){base.setProdMax(70); base.getOwner().resources -= 40; base.setProduction(id);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 250), 400, 400);}; break;
                        case 11: if(base.getOwner().resources >= 25){base.setProdMax(60); base.getOwner().resources -= 25; base.setProduction(id);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 250), 400, 400);}; break;
                        case 12: if(base.getOwner().resources >= 20){base.setProdMax(50); base.getOwner().resources -= 20; base.setProduction(id);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 250), 400, 400);}; break;
                        case 13: if(base.getOwner().resources >= 55){base.setProdMax(110); base.getOwner().resources -= 55; base.setProduction(id);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 250), 400, 400);}; break;
                        case 14: if(base.getOwner().resources >= 55){base.setProdMax(80); base.getOwner().resources -= 55; base.setProduction(id);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 250), 400, 400);}; break;
                        case 15: if(base.getOwner().resources >= 100){base.setProdMax(140); base.getOwner().resources -= 100; base.setProduction(id);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 250), 400, 400);}; break;
                        case 16: if(base.getOwner().resources >= 85){base.setProdMax(100); base.getOwner().resources -= 85; base.setProduction(id);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 250), 400, 400);}; break;
                        case 17: if(base.getOwner().resources >= 120){base.setProdMax(180); base.getOwner().resources -= 120; base.setProduction(id);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 250), 400, 400);}; break;
                        case 18: if(base.getOwner().resources >= 40){base.setProdMax(60); base.getOwner().resources -= 40; base.setProduction(id);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 250), 400, 400);}; break;
                        case 19: if(base.getOwner().resources >= 70){base.setProdMax(100); base.getOwner().resources -= 70; base.setProduction(id);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 250), 400, 400);}; break;
                        case 20: if(base.getOwner().resources >= 200){base.setProdMax(280); base.getOwner().resources -= 200; base.setProduction(id);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 250), 400, 400);}; break;
                        case 21: if(base.getOwner().resources >= 150){base.setProdMax(225); base.getOwner().resources -= 150; base.setProduction(id);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 250), 400, 400);}; break;
                        case 22: if(base.getOwner().resources >= 200){base.setProdMax(300); base.getOwner().resources -= 200; base.setProduction(id);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 250), 400, 400);}; break;
                        case 24: if(base.getOwner().resources >= 100){base.setProdMax(350); base.getOwner().resources -= 100; base.setProduction(id);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 250), 400, 400);}; break;
                        case 23: if(base.getOwner().resources >= 400){base.setProdMax(800); base.getOwner().resources -= 400; base.setProduction(id);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 250), 400, 400);}; break;
                        case 25: if(base.getOwner().resources >= 400){base.setProdMax(600); base.getOwner().resources -= 400; base.setProduction(id);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 250), 400, 400);}; break;
                        case 26: if(base.getOwner().resources >= 350){base.setProdMax(675); base.getOwner().resources -= 350; base.setProduction(id);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 250), 400, 400);}; break;
                        case 27: if(base.getOwner().resources >= 100){base.setProdMax(100); base.getOwner().resources -= 100; base.setProduction(id);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 250), 400, 400);}; break;
                        case 30: if(base.getOwner().resources >= 200){base.setProdMax(5000); base.getOwner().resources -= 200; base.setProduction(id);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 250), 400, 400);}; break;
                        case 31: if(base.getOwner().resources >= 300){base.setProdMax(1000); base.getOwner().resources -= 300; base.setProduction(id);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 250), 400, 400);}; break;
                        case 32: if(base.getOwner().resources >= 300){base.setProdMax(1000); base.getOwner().resources -= 300; base.setProduction(id);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 250), 400, 400);}; break;
                        case 33: if(base.getOwner().resources >= 180){base.setProdMax(240); base.getOwner().resources -= 180; base.setProduction(id);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 250), 400, 400);}; break;
                    }
                }
            }
        }
        else
        {
            checkDependency();
        }
        if(!hasbar)
        {
            makeHelpbar();
        }
    }    
    public void makeHelpbar()
    {
        if(!hasbar)
        {
            if(intersect())
            {
            switch(id)
            {
                case 1: getWorld().addObject(new HelpTab(this, "Volunteer Sphere", "Basic Anti-Infantry Infantry", "Cost: 25 ore", "Strong against infantry"), 650, 400); break;
                case 2: getWorld().addObject(new HelpTab(this, "Rocket Sphere", "Basic Anti-Armor/Air Infantry", "Cost: 40 ore", "Strong against vehicles. Can attack air"), 650, 400); break;
                case 3: getWorld().addObject(new HelpTab(this, "Ninja", "Advanced Specialist Infantry", "Cost: 110 ore", "Strong againts infantry"), 650, 400); break;
                case 4: getWorld().addObject(new HelpTab(this, "Standard Armored Vehicle", "Basic Anti-Armor Vehicle", "Cost: 130 ore", "Strong againt vehicles"), 650, 400); break;
                case 5: getWorld().addObject(new HelpTab(this, "Gun Tank", "Basic Anti-Infantry/Air Vehicle", "Cost: 110 ore", "Strong against air and infantry"), 650, 400); break;
                case 6: getWorld().addObject(new HelpTab(this, "Tank Destroyer", "Specialized Anti-Armor Vehicle", "Cost: 150 ore, Requires Strategy Center", "Strong against heavily armored units"), 650, 400); break;
                case 7: getWorld().addObject(new HelpTab(this, "Airborne Drone", "Basic Scout Air Unit", "Cost: 60 ore", "Strong against infantry. Can attack air"), 650, 400); break;
                case 8: getWorld().addObject(new HelpTab(this, "Napalm Bomber", "Heavy Bomber", "Cost: 250 ore, Requires Strategy Center", "Strong against most ground units and structures"), 650, 400); break;
                case 9: getWorld().addObject(new HelpTab(this, "Worker Sphere", "Resource Gatherer", "Cost: 50 ore", "Has limited combat value"), 650, 400); break;
                case 10: getWorld().addObject(new HelpTab(this, "Pistol Squad", "Basic Anti-Infantry Infantry", "Cost: 40 ore, 3 produced", "Strong against infantry"), 650, 400); break;
                case 11: getWorld().addObject(new HelpTab(this, "Grenadier Baby", "Basic Support Infantry", "Cost: 25 ore", "Strong against lighter ground troops"), 650, 400); break;
                case 12: getWorld().addObject(new HelpTab(this, "Explosive Baby", "Suicidal Anti-Surface Infantry", "Cost: 20 ore, Requires Capitalist Lodge", "Strong against ground troops"), 650, 400); break;
                case 13: getWorld().addObject(new HelpTab(this, "Explosive Baby Squad", "Suicidal Anti-Surface Infantry", "Cost: 55 ore, Requires both tech structures", "Strong against ground troops, 3 individuals"), 650, 400); break;
                case 14: getWorld().addObject(new HelpTab(this, "Flamethrower Baby", "Advanced Anti-Infantry Infantry", "Cost: 55 ore, Requires Materialist Hub", "Strong against structures/infantry, clears garrison"), 650, 400); break;
                case 15: getWorld().addObject(new HelpTab(this, "Troop Carrier", "Antipersonnel vehicle", "Cost: 100 ore", "Strong against infantry. Can carry troops."), 650, 400); break;
                case 16: getWorld().addObject(new HelpTab(this, "AA Track", "Anti-Air vehicle", "Cost: 85 ore", "Can only attack air units"), 650, 400); break;
                case 17: getWorld().addObject(new HelpTab(this, "Light Tank", "Anti-Armor vehicle", "Cost: 120 ore", "Effective against vehicles"), 650, 400); break;
                case 18: getWorld().addObject(new HelpTab(this, "Worker Baby", "Resource Gatherer/Construction", "Cost: 40 ore", "Limited combat value"), 650, 400); break;
                case 19: getWorld().addObject(new HelpTab(this, "Sphere Hovercycle", "Anti-Surface Recon Vehicle", "Cost: 70 ore", "Strong against lighter ground units"), 650, 400); break;
                case 20: getWorld().addObject(new HelpTab(this, "Main Battle Tank", "Basic anti-surface Vehicle", "Cost: 200 ore", "Strong against lighter ground forces"), 650, 400); break;
                case 21: getWorld().addObject(new HelpTab(this, "Chem Tank", "Basic anti-personnel Vehicle", "Cost: 150 ore", "Strong against infantry"), 650, 400); break;
                case 22: getWorld().addObject(new HelpTab(this, "Artillery", "Long-range Bombarbment", "Cost: 200 ore, Requires Command Post", "Strong against structures"), 650, 400); break;
                case 24: getWorld().addObject(new HelpTab(this, "Light Bomber", "Ground Support Aircraft", "Cost: 100 ore", "Strong against most ground forces"), 650, 400); break;
                case 23: getWorld().addObject(new HelpTab(this, "Floating Disc", "Heavy Close-Range Aircraft", "Cost: 400 ore, Requires Nano Mainframe", "Strong against ground forces"), 650, 400); break;
                case 25: getWorld().addObject(new HelpTab(this, "Mecha Hoplite", "Heavy Assault Mech - very Durable", "Cost: 400 ore, Requires Nano Mainframe", "Strong against ground forces"), 650, 400); break;
                case 26: getWorld().addObject(new HelpTab(this, "Heavy Gunship", "Heavy Ground Support Aircraft", "Cost: 350 ore, Requires Nano Mainframe", "Strong against heavier ground forces"), 650, 400); break;
                case 27: getWorld().addObject(new HelpTab(this, "Harvester", "Resource Gatherer", "Cost: 100 ore", "Has no combat value"), 650, 400); break;
                case 30: getWorld().addObject(new HelpTab(this, "Chemical Warhead", "One-time weapon", "Cost: 200 ore", "Required to use the Launch Pad"), 650, 400); break;
                case 31: getWorld().addObject(new HelpTab(this, "Construction Hub Carrier", "Construction Vehicle", "Cost: 300 ore", "Can be deployed to a Construction Hub"), 650, 400); break;
                case 32: getWorld().addObject(new HelpTab(this, "Construction Hub Carrier", "Construction Vehicle", "Cost: 300 ore", "Can be deployed to a Construction Hub"), 650, 400); break;
                case 33: getWorld().addObject(new HelpTab(this, "Sphere Officer", "Heavy Assault Infantry", "Cost: 180 ore", "Has various support abilities"), 650, 400); break;
            }
            hasbar = true;
        }
        }
    }
    public void checkDependency()
    {
        switch(id)
        {
            case 6: if(base.getOwner().Requirements[5] >0){techsufficient = true; getImage().setTransparency(255);} else{techsufficient = false; getImage().setTransparency(100);}; break;
            case 8: if(base.getOwner().Requirements[5] >0){techsufficient = true; getImage().setTransparency(255);} else{techsufficient = false; getImage().setTransparency(100);}; break;
            case 12: if(base.getOwner().Requirements[8] >0){techsufficient = true; getImage().setTransparency(255);} else{techsufficient = false; getImage().setTransparency(100);}; break;
            case 13: if(base.getOwner().Requirements[8] >0 && base.getOwner().Requirements[9] > 0){techsufficient = true; getImage().setTransparency(255);} else{techsufficient = false; getImage().setTransparency(100);}; break;
            case 14: if(base.getOwner().Requirements[9] >0){techsufficient = true; getImage().setTransparency(255);} else{techsufficient = false; getImage().setTransparency(100);}; break;
            case 22: if(base.getOwner().Requirements[13] >0){techsufficient = true; getImage().setTransparency(255);} else{techsufficient = false; getImage().setTransparency(100);}; break;
            case 23: if(base.getOwner().Requirements[15] >0){techsufficient = true; getImage().setTransparency(255);} else{techsufficient = false; getImage().setTransparency(100);}; break;
            case 25: if(base.getOwner().Requirements[15] >0){techsufficient = true; getImage().setTransparency(255);} else{techsufficient = false; getImage().setTransparency(100);}; break;
            case 26: if(base.getOwner().Requirements[15] >0){techsufficient = true; getImage().setTransparency(255);} else{techsufficient = false; getImage().setTransparency(100);}; break;
        }
    }
}
