import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;
import java.awt.geom.*;

/**
 * Write a description of class Units here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Units  extends DestructibleObjects
{
    /**
     * The int that stores the image when the object is to attack.
     */
    public int attackimage;
    /**
     * The point value of the unit. Gets important as AI is implemented.
     */
    public int value;
    /**
     * Holds for collision directions.
     */
    private boolean[] checkcol = new boolean[4];
    /**
     * Holds the boolean value that is true if the unit is mechanic
     */
    protected boolean mechanical;
    /**
     * checks for previous direction to determine if image should be flipped
     */
    public int prevdir;
    public static final int LEFT = 1;
    public static final int RIGHT = 2;
    /**
     * for Garrison units.
     */
    public Units intendedtarget;
    /**
     * Row position assigned. Used by AI
     */
    private int assign = 12;
    public void act() 
    {
        // Add your action code here.
        createHealthBar();
    }    
    /**attack image
     * 1 = Gun overlay
     * 2 = Generic Shell
     * 3 = Rocket
     * 4 = Flak
     * 5 = Grenade
     * 6 = Chemical Stream
     * 7 = Flamethrower
     * 8 = Bomb (Bombers)
     * 9 = Mecha Hoplite
     * 10 = Gunship
     * 11 = Ninja Knife
     * 12 = Posterity Explosion
     * 13 =
     * 14
     * 15 = Napalm (Bomber)
     */
    /**
     * Gets target. First draws the list from the World Array, then if the object is not of the same team and is inside the attack parameter, then it attacks by creating an object, either overlay or weapon.
     */
    public void attack()
    {
        try
        {
            if(intendedtarget.getWorld() == null)
            {
                intendedtarget = null;
            }
        }
        catch(NullPointerException e)
        {
        }
        if(getAction() == 2 || getAction() == 4  || getAction() == 5)
        {
            target = null;
        }
        try
        {
        for(Buff a : buffs)
        {
            if(a.dur <= 0)
            {
                buffs.remove(a);
            }
            else
            {
                a.apply();
                a.dur --;
            }
        }
        }
        catch(ConcurrentModificationException e)
        {
        }
        List pot = wa.Actors;
        for(int i = 0; i < pot.size(); i++)
        {
            DestructibleObjects a = (DestructibleObjects) pot.get(i);
            if(a.hitpoints > 0 && unitaction != 8 && target == null && (a.side != 6) && (a.getX() > attackParameter().getX() && a.getX() <= attackParameter().getX()+attackParameter().getWidth()) && (a.realY() > attackParameter().getY() && a.realY() <= attackParameter().getY()+attackParameter().getHeight()))
            {
                if((side == 1 && a.side == 2) || (side == 2 && a.side == 1) && ((canhitair && a.flyer)||(canhitground && !a.flyer)))
                {
                    target = a;
                }
            }
            if(a.hitpoints > 0 && unitaction == 8 && target == null && (a.side != 6) && (a.getX() > attackParameterFlank().getX() && a.getX() <= attackParameterFlank().getX()+attackParameterFlank().getWidth()) && (a.realY() > attackParameterFlank().getY() && a.realY() <= attackParameterFlank().getY()+attackParameterFlank().getHeight()))
            {
                if((side == 1 && a.side == 2) || (side == 2 && a.side == 1) && ((canhitair && a.flyer)||(canhitground && !a.flyer)))
                {
                    target = a;
                }
            }
        }
        if(target != null)
        {
            if(unitaction != 3 && !(this instanceof Flyer) && ((target.getX() > attackParameter().getX() && target.getX() <= attackParameter().getX()+attackParameter().getWidth()) && (target.realY() > attackParameter().getY() && target.realY() <= attackParameter().getY()+attackParameter().getHeight()) ||(target.getX() > attackParameterFlank().getX() && target.getX() <= attackParameterFlank().getX()+attackParameterFlank().getWidth()) && (target.realY() > attackParameterFlank().getY() && target.realY() <= attackParameterFlank().getY()+attackParameterFlank().getHeight())))
            {
                if(unitaction != 2 && unitaction != 4 && unitaction != 5)
                {
                    prevact = unitaction;
                    unitaction = 3;
                    frame = 1;
                }
            }
            if(unitaction == 3 && !((target.getX() > attackParameter().getX() && target.getX() <= attackParameter().getX()+attackParameter().getWidth()) && (target.realY() > attackParameter().getY() && target.realY() <= attackParameter().getY()+attackParameter().getHeight())) && !((target.getX() > attackParameterFlank().getX() && target.getX() <= attackParameterFlank().getX()+attackParameterFlank().getWidth()) && (target.realY() > attackParameterFlank().getY() && target.realY() <= attackParameterFlank().getY()+attackParameterFlank().getHeight())))
            {
                unitaction = prevact;
                frame = 1;
                target = null;
            }
        }
        if(target == null && unitaction == 3)
        {
            unitaction = prevact;
            frame = 1;
        }
        if(reload > 0)
        {
            reload --;
        }
        try
        {
            //attack
        if(target.hitpoints > 0 && reload <= 0 && (unitaction == 3 || (this instanceof Flyer)) && (((target.realX() > attackParameter().getX() - wa.getx() && target.realX() <= attackParameter().getX()+attackParameter().getWidth() - wa.getx())) || ((target.realY() > attackParameterFlank().getY() && target.realY() <= attackParameterFlank().getY()+attackParameterFlank().getHeight()) || (target.realX() > attackParameter().getX() - wa.getx() && target.realX() <= attackParameter().getX()+attackParameter().getWidth() - wa.getx()) && (target.realY() > attackParameterFlank().getY() && target.realY() <= attackParameterFlank().getY()+attackParameterFlank().getHeight()))) && ((target.flyer && canhitair) || (!target.flyer && canhitground)))
        {
            if(unitaction != 3 && !(this instanceof Flyer))
            {
                if(unitaction != 2 && unitaction != 7 && unitaction != 4 && unitaction != 5)
                {
                    prevact = unitaction;
                    unitaction = 3;
                    frame = 1;
                }
            }
            Point2D.Double enemyp = new Point2D.Double(target.getX(), target.getY());
            switch(side)
            {
                case 1:
                switch(dir)
                {
                    case LEFT:
                    if(!attackParameterFlank().contains(enemyp))
                    {
                        target = null;
                        unitaction = prevact;
                    }
                    break;
                    case RIGHT:
                    if(!attackParameter().contains(enemyp))
                    {
                        target = null;
                        unitaction = prevact;
                    }
                    break;
                }
                break;
                case 2:
                switch(dir)
                {
                    case LEFT:
                    if(!attackParameter().contains(enemyp))
                    {
                        target = null;
                        unitaction = prevact;
                    }
                    break;
                    case RIGHT:
                    if(!attackParameterFlank().contains(enemyp))
                    {
                        target = null;
                        unitaction = prevact;
                    }
                    break;
                }
                break;
            }
            //Randomly generates a randomization of position for overlays (e.g. bullets.) artilleries have separate and greater randomization.
            int xx = Greenfoot.getRandomNumber(22);
            xx -= Greenfoot.getRandomNumber(22);
            int yy = Greenfoot.getRandomNumber(22);
            yy -= Greenfoot.getRandomNumber(22);
            int xx2 = Greenfoot.getRandomNumber(22);
            xx2 -= Greenfoot.getRandomNumber(160);
            int yy2 = Greenfoot.getRandomNumber(160);
            yy2 -= Greenfoot.getRandomNumber(160);
            if(this instanceof NapalmBomber)
            {
                NapalmBomber a = (NapalmBomber) this;
                a.bombs --;
            }
            if(this instanceof LightBomber)
            {
                LightBomber a = (LightBomber) this;
                a.bombs --;
            }
            int xt = 0;
            if(target.realX() > realX())
            {
                xt = 1;
                prevdir = dir;
                dir = RIGHT;
            }
            if(target.realX() < realX())
            {
                xt = 2;
                prevdir = dir;
                dir = LEFT;
            }
            switch(attackimage)
            {
                case 1: getWorld().addObject(new Overlay(attackimage, damage, weapontype, target.realX() + xx, target.realY() + yy, target.getGameHeight()), target.getX() + xx, target.getY() + yy); reload = delay; target.takedamage(damage, weapontype); break;
                case 2: getWorld().addObject(new Weapons(2, damage, realX(), realY(), side, xt, weapontype), getX(), getY()); reload = delay; if(getX() > -300 && getX() < 1100){Greenfoot.playSound("Shell.wav");}; break;
                case 3: getWorld().addObject(new Weapons(1, damage, realX(), realY(), side, weapontype, target), getX(), getY()); reload = delay; if(getX() > -300 && getX() < 1100){Greenfoot.playSound("RocketBlast.wav");};; break;
                case 4: getWorld().addObject(new Overlay(attackimage, damage, weapontype, target.realX() + xx, target.realY() + yy, target.getGameHeight()), target.getX() + xx, target.getY() + yy); reload = delay; target.takedamage(damage, weapontype); break;
                case 6: getWorld().addObject(new Weapons(8, damage, realX(), realY(), side, xt, weapontype), getX(), getY()); reload = delay; break;
                case 5: getWorld().addObject(new Weapons(7, damage, realX(), realY(), side, weapontype, target), getX(), getY()); reload = delay; break;
                case 11: getWorld().addObject(new Weapons(4, damage, realX(), realY(), side, xt, weapontype), getX(), getY()); reload = delay; break;
                case 12: getWorld().addObject(new Overlay(attackimage, damage, weapontype, target.realX() + xx2, target.realY() + yy2, target.getGameHeight()), target.getX() + xx2, target.getY() + yy2); reload = delay; break;
                case 13: getWorld().addObject(new Overlay(attackimage, damage, weapontype, target.realX() + xx, target.realY() + yy, target.getGameHeight()), target.getX() + xx, target.getY() + yy); reload = delay; target.takedamage(damage, weapontype); break;
                case 15: getWorld().addObject(new Weapons(5, damage, realX(), realY(), side, xt, weapontype), getX(), getY()); reload = delay; break;
            }
            if(getX() >= -100 && getX() <= 900)
            {
                playSound();
            }
            if(this instanceof RocketSphere && getOwner().Upgrades[2] > 0)
            {
                getWorld().addObject(new Weapons(3, 10, realX(), realY(), side, 2, target), getX(), getY());
            }
            if(this instanceof SuicideBaby)
            {
                getWorld().addObject(new Overlay(3, 0, 0, realX(), realY(), target.getGameHeight()), getX(), getY());
                takedamage(100, 1);
            }
        }
        if(target.hitpoints <= 0 || target == null || (target.flyer && !canhitair) || (!target.flyer && !canhitground))
        {
            //removes the target IF target is elimnated.
            if(unitaction != 0)
            {
                unitaction = prevact;
                needchange = true;
            }
            target = null;
        }
    }
                catch(NullPointerException e)
        {
        }
    }
    /**
     * Not implemented yet, but it will return true if certain number of doodads or some overlay covers the unit in question.
     */
    public boolean inCover()
    {
        return false;
    }
    /**
     * Checks if a valid enemy is in the attack parameter.
     */
    public boolean enemyInSight()
    {
        boolean a = false;
        if(target == null)
        {
            a = false;
        }
        else
        {
        List pot = wa.Actors;
        for(int i = 0; i < pot.size(); i++)
        {
        DestructibleObjects b = (DestructibleObjects) pot.get(i);
        if(b.hitpoints > 0 && (b.side != 6) && (b.getX() > attackParameter().getX() && b.getX() <= attackParameter().getX()+attackParameter().getWidth()) && (b.realY() > attackParameter().getY() && b.realY() <= attackParameter().getY()+attackParameter().getHeight()))
        {
            if((side == 1 && b.side == 2) || (side == 2 && b.side == 1) && ((canhitair && b.flyer)||(canhitground && !b.flyer)))
            {    
                 a = true;
            }
        }
        }
    }
        return a;
    }
    /**
     * Checks if a valid enemy is in the flanking attack parameter.
     */
    public boolean enemyInSightFlank()
    {
        boolean a = false;
        if(target == null)
        {
            a = false;
        }
        else
        {
        List pot = wa.Actors;
        for(int i = 0; i < pot.size(); i++)
        {
        DestructibleObjects b = (DestructibleObjects) pot.get(i);
        if(b.hitpoints > 0 && (b.side != 6) && (b.getX() > attackParameter().getX() && b.getX() <= attackParameterFlank().getX()+attackParameterFlank().getWidth()) && (b.realY() > attackParameterFlank().getY() && b.realY() <= attackParameterFlank().getY()+attackParameterFlank().getHeight()))
        {
            if((side == 1 && b.side == 2) || (side == 2 && b.side == 1) && ((canhitair && b.flyer)||(canhitground && !b.flyer)))
            {    
                 a = true;
            }
        }
    }
    }
        return a;
    }
    /**
     * returns reload time. For Buffs.
     */ 
    public int getReload()
    {
        return reload;
    }
    /**
     * returns the cooldown time. For Buffs.
     */ 
    public int getDelay()
    {
        return delay;
    }
    public void setReload(int i)
    {
        reload = i;
    }
    public void giveTarget(DestructibleObjects d)
    {
        target = d;
    }
    /**
     * Prevents complete overlapping of one unit over another. (Ground units only)
     */
    public void collisionReact()
    {
        if(!flyer)
        {
            for(DestructibleObjects a : wa.Actors)
            {
                if(!a.flyer && a instanceof Units)
                {
                    if(a.realX() <= (realX()+getImage().getWidth()/2) && a.realX() > realX() && realY() > a.realY()-a.getImage().getHeight()/2-15 && realY() < a.realY()+a.getImage().getHeight()/2+15)
                    {
                        checkcol[0] = true;
                        mapX -= getSpeed();
                        prevdir = dir;
                        dir = LEFT;
                        if(ai != null && getTrans() <= 0)
                        {
                            setVerticalTranslation(getImage().getHeight());
                            if(Greenfoot.getRandomNumber(2) == 0)
                            {
                                setBehavior(5);
                            }
                            else
                            {
                                setBehavior(4);
                            }
                        }
                        if(unitaction != 0 && unitaction != 3 && unitaction != 4  && unitaction != 5)
                        {
                            unitaction = 0;
                        }
                    }
                    else if(a.realX() >= (realX()-getImage().getWidth()/2) && a.realX() < realX() && realY() > a.realY()-a.getImage().getHeight()/2-15 && realY() < a.realY()+a.getImage().getHeight()/2+15)
                    {
                        checkcol[1] = true;
                        mapX += getSpeed();
                        prevdir = dir;
                        dir = RIGHT;
                        if(ai != null)
                        {
                            setVerticalTranslation(getImage().getHeight());
                            if(Greenfoot.getRandomNumber(2) == 0)
                            {
                                setBehavior(5);
                            }
                            else
                            {
                                setBehavior(4);
                            }
                        }
                        if(unitaction != 0 && unitaction != 3 && unitaction != 4  && unitaction != 5)
                        {
                            unitaction = 0;
                        }
                    }
                    //else if(a.realX() == realX() && realY() > a.realY()-a.getImage().getHeight()/2-15 && realY() < a.realY()+a.getImage().getHeight()/2+15)
                    //{
                    //    if(Greenfoot.getRandomNumber(2) == 0)
                    //    {
                    //        mapX -= getSpeed();
                    //        if(unitaction != 0 || unitaction != 3)
                    //        {
                    //            unitaction = 0;
                    //        }
                    //    }
                    //    else
                    //    {
                    //        mapX += getSpeed();
                    //        if(unitaction != 0 || unitaction != 3)
                    //        {
                    //            unitaction = 0;
                    //        }
                    //    }
                    //}
                }
                if(a instanceof Structures && !((a instanceof OreMine) && ((this instanceof WorkerBaby) || (this instanceof WorkerSphere))))
                {
                    if(realX() < a.realX()+a.getImage().getWidth()/2 && realX() > a.realX()-a.getImage().getWidth()/2 && realY() > a.realY()-a.getImage().getHeight()/2+5 && realY() < a.realY()+a.getImage().getHeight()/2-5)
                    {
                        if(realY() > a.realY())
                        {
                            checkcol[2] = true;
                            mapY += getSpeed();
                        }
                        else if(realY() < a.realY())
                        {
                            checkcol[3] = true;
                            mapY -= getSpeed();
                        }
                        else if(realY() == a.realY() && getTrans() <= 0)
                        {
                            setVerticalTranslation(getImage().getHeight());
                            if(Greenfoot.getRandomNumber(2) == 0)
                            {
                                setBehavior(5);
                            }
                            else
                            {
                                setBehavior(4);
                            }
                        }
                    }
                }
                else if(!(a.realX() <= (realX()+getImage().getWidth()/2)) && !(a.realX() >= (realX()-getImage().getWidth()/2)) && !(realY() > a.realY()-a.getImage().getHeight()/2-15 && realY() < a.realY()+a.getImage().getHeight()/2+15))
                {
                    checkcol[0] = false;
                    checkcol[1] = false;
                    checkcol[2] = false;
                    checkcol[3] = false;
                }
            }
        }
    }
    /**
     * Checks if the image needs flipping.
     */
    public void alignImage()
    {
        if(prevdir != dir && prevdir != 0)
        {
            needchange = true;
        }
    }
    /**
     * Empty method: Override it.
     */
    public void flipimage()
    {
    }
    /**
     * Empty method for sound: Override it.
     */
    public void playSound()
    {
    }
    public int getAssignedRow()
    {
        return assign;
    }
    public void assignRow(int ini)
    {
        assign = ini;
    }
    public boolean isMechanical()
    {
        return mechanical;
    }
}