import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Volunteer Sphere: A basic Anti-Infantry unit of the Territorial Independence Army.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class VolunteerSphere  extends Units
{
    private GreenfootImage frame1 = new GreenfootImage("VolunteerSphere1.png");
    private GreenfootImage frame2 = new GreenfootImage("VolunteerSphere2.png");
    private GreenfootImage frame3 = new GreenfootImage("VolunteerSphere3.png");
    private GreenfootImage frame4 = new GreenfootImage("VolunteerSphere4.png");
    private GreenfootImage frame5 = new GreenfootImage("VolunteerSphere5.png");
    private GreenfootImage frame6 = new GreenfootImage("VolunteerSphere6.png");
    private GreenfootImage frame1l = new GreenfootImage("VolunteerSphere1.png");
    private GreenfootImage frame2l = new GreenfootImage("VolunteerSphere2.png");
    private GreenfootImage frame3l = new GreenfootImage("VolunteerSphere3.png");
    private GreenfootImage frame4l = new GreenfootImage("VolunteerSphere4.png");
    private GreenfootImage frame5l = new GreenfootImage("VolunteerSphere5.png");
    private GreenfootImage frame6l = new GreenfootImage("VolunteerSphere6.png");
    private GreenfootImage frame1r = new GreenfootImage("VolunteerSphere1.png");
    private GreenfootImage frame2r = new GreenfootImage("VolunteerSphere2.png");
    private GreenfootImage frame3r = new GreenfootImage("VolunteerSphere3.png");
    private GreenfootImage frame4r = new GreenfootImage("VolunteerSphere4.png");
    private GreenfootImage frame5r = new GreenfootImage("VolunteerSphere5.png");
    private GreenfootImage frame6r = new GreenfootImage("VolunteerSphere6.png");
    private int reg;
    public int molotov;
    public VolunteerSphere(int iniside, int ix, int iy)
    {
        side = iniside;
        maxhitpoints = 50;
        attackimage = 1;
        armortype = 1;
        armorquantity = 0;
        range = 120;
        hitpoints = 50;
        weapontype = 1;
        damage = 3;
        delay = 15;
        canhitground = true;
        speed = 2;
        mapX = ix;
        mapY = iy;
        cost = 25;
    }
    public VolunteerSphere(int iniside, Player pl, int ix, int iy)
    {
        owner = pl;
        side = iniside;
        maxhitpoints = 50;
        attackimage = 1;
        armortype = 1;
        armorquantity = 0;
        range = 120;
        hitpoints = 50;
        weapontype = 1;
        damage = 3;
        delay = 15;
        canhitground = true;
        speed = 2;
        mapX = ix;
        mapY = iy;
        cost = 25;
    }
    public void addedToWorld(World w)
    {
        id = 1;
        genmaches = (Battleground) w;
        wa = genmaches.array;
        if(side == 1)
        {
            frame1.mirrorHorizontally();
            frame2.mirrorHorizontally();
            frame3.mirrorHorizontally();
            frame4.mirrorHorizontally();
            frame5.mirrorHorizontally();
            frame6.mirrorHorizontally();
            setImage(frame1);
        }
        frame1r.mirrorHorizontally();
        frame2r.mirrorHorizontally();
        frame3r.mirrorHorizontally();
        frame4r.mirrorHorizontally();
        frame5r.mirrorHorizontally();
        frame6r.mirrorHorizontally();
    }
    public void act() 
    {
        // Add your action code here.
        updateimage();
        attack();
        createHealthBar();
        perish();
        collisionReact();
        alignImage();
        flipimage();
        if(molotov > 0)
        {
            molotov --;
        }
    }    
    /**
     * updates image for the unit. All generic units have two action id (move = 1, stand = 0) (2 is retreat) and most units have attack id (3)
     */
    public void updateimage()
    {
        if(getOwner().Upgrades[1] > 0)
        {
            reg++;
            if(reg >= 40)
            {
                reg = 0;
                if(hitpoints < maxhitpoints)
                {
                    if((double)(maxhitpoints - hitpoints) < 1)
                    {
                        hitpoints = maxhitpoints;
                    }
                    else
                    {
                    hitpoints ++;
                    }
                }
            }
        }
        if(unitaction == 0)
        {
            if(needchange)
            {
                needchange = false;
                setImage(frame1);
            }
        }
        if(unitaction != 0)
        {
            framechange++;
            if(unitaction == 1)
            {
                if(framechange >= 3)
                {
                    needchange = true;
                    framechange = 0;
                    frame ++;
                }
                if(realX() <= 0 || realX() >= wa.getWidth())
                {
                    unitaction = 0;
                }
                if(frame > 4)
                {
                    frame = 1;
                }
                if(needchange)
                    {
                        needchange = false;
                        switch(frame)
                        {
                            case 1: setImage(frame1); break;
                            case 2: setImage(frame2); break;
                            case 3: setImage(frame3); break;
                            case 4: setImage(frame4); break;
                        }
                    }
            }
            else if(unitaction == 2 || unitaction == 4 || unitaction == 5)
            {
                if(framechange >= 3)
                {
                    needchange = true;
                    framechange = 0;
                    frame ++;
                }
                if(realX() <= 0 || realX() >= wa.getWidth())
                {
                    unitaction = 0;
                }
                else
                {
                if(frame > 4)
                {
                    frame = 1;
                }
                if(needchange)
                    {
                        needchange = false;
                        switch(frame)
                        {
                            case 1: setImage(frame1); break;
                            case 2: setImage(frame2); break;
                            case 3: setImage(frame3); break;
                            case 4: setImage(frame4); break;
                        }
                    }
                }
            }
            else if(unitaction == 3)
            {
                if(!enemyInSight())
                {
                    unitaction = prevact;
                    frame = 1;
                    needchange = true;
                }
                if(ai != null)
                {
                    if(molotov <= 0)
                    {
                        getWorld().addObject(new Weapons(6, 3, realX(), realY(), getSide(), getSide(), 3), getX(), getY());
                        molotov = 200;
                    }
                }
                if(frame == 1)
                {
                    if(framechange >= reload - 3)
                    {
                        needchange = true;
                        framechange = 0;
                        frame ++;
                    }
                }
                if(frame == 2)
                {
                    if(framechange >= framechangerate)
                    {
                        needchange = true;
                        framechange = 0;
                        frame ++;
                    }
                }
                    if(needchange)
                    {
                        needchange = false;
                        switch(frame)
                        {
                            case 1: setImage(frame5); break;
                            case 2: setImage(frame6); break;
                        }
                    }
                if(frame > 2)
                {
                    frame = 1;
                    needchange = true;
                }
            }
        }
    }
    @Override public void flipimage()
    {
        if(dir == LEFT)
        {
            if(frame1 != frame1l)
            {
                frame1 = frame1l;
            }
            if(frame2 != frame2l)
            {
                frame2 = frame2l;
            }
            if(frame3 != frame3l)
            {
                frame3 = frame3l;
            }
            if(frame4 != frame4l)
            {
                frame4 = frame4l;
            }
            if(frame5 != frame5l)
            {
                frame5 = frame5l;
            }
            if(frame6 != frame6l)
            {
                frame6 = frame6l;
            }
        }
        if(dir == RIGHT)
        {
            if(frame1 != frame1r)
            {
                frame1 = frame1r;
            }
            if(frame2 != frame2r)
            {
                frame2 = frame2r;
            }
            if(frame3 != frame3r)
            {
                frame3 = frame3r;
            }
            if(frame4 != frame4r)
            {
                frame4 = frame4r;
            }
            if(frame5 != frame5r)
            {
                frame5 = frame5r;
            }
            if(frame6 != frame6r)
            {
                frame6 = frame6r;
            }
        }
    }
    @Override public void playSound()
    {
        if(getX() > -200 && getX() < 1000)
        {
            if(Greenfoot.getRandomNumber(2) == 1)
            {
                Greenfoot.playSound("SMG.wav");
            }
            else
            {
                Greenfoot.playSound("SMG2.wav");
            }
        }
    }
}
