import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
import java.awt.geom.*;

/**
 * Write a description of class Weapons here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Weapons  extends IngameSprite
{
    /**
     * Act - do whatever the Weapons wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    protected int image;
    protected int damage;
    protected int frame;
    protected int type;
    private int s;
    private int si;
    private DestructibleObjects target;
    private double angle;
    private int changeheight;
    private int dy;
    public Weapons(int ini, int syn, int ix, int iy, int xs, int i, int cfg)
    {
        image = ini;
        damage = syn;
        mapX = ix;
        mapY = iy;
        si = xs;
        s = i;
        type = cfg;
        switch(ini)
        {
            case 1: setImage("RPGRocket.png"); break;
            case 2: setImage("Bullet.png"); break;
            case 3: setImage("StingerMissile.png"); break;
            case 4: setImage("Shuriken1.png"); break;
            case 5: setImage("bomb.png"); height = 80; break;
            case 6: setImage("Molotov.png"); changeheight = 10; break;
            case 7: setImage("Grenade.png"); changeheight = 10; break;
            case 8: setImage("ChemicalWeapon.png"); break;
        }
        switch(s)
        {
            case 2: getImage().mirrorHorizontally(); break;
        }
    }

    public Weapons(int ini, int syn, int ix, int iy, int i, int cfg, DestructibleObjects argh)
    {
        image = ini;
        damage = syn;
        mapX = ix;
        mapY = iy;
        si = i;
        type = cfg;
        target = argh;
        switch(ini)
        {
            case 1: setImage("RPGRocket.png"); break;
            case 2: setImage("Bullet.png"); break;
            case 3: setImage("StingerMissile.png"); break;
            case 4: setImage("Shuriken.png"); break;
            case 7: setImage("Grenade.png"); changeheight = (int)(Math.abs(ix - argh.realX())/12); if(target.realX() > realX()){s = 1;}else if(target.realX() < realX()){s = 2;}; break;
        }
        switch(s)
        {
            case 2: getImage().mirrorHorizontally(); break;
        }
    }

    public Weapons(int ini, int syn, int ix, int iy, int xs, int i, int cfg, int yd)
    {
        image = ini;
        damage = syn;
        mapX = ix;
        mapY = iy;
        si = xs;
        s = i;
        type = cfg;
        switch(ini)
        {
            case 1: setImage("RPGRocket.png"); break;
            case 2: setImage("Bullet.png"); break;
            case 3: setImage("StingerMissile.png"); break;
            case 4: setImage("Shuriken1.png"); break;
            case 5: setImage("bomb.png"); height = 80; break;
            case 6: setImage("Molotov.png"); changeheight = 10; break;
            case 7: setImage("Grenade.png"); changeheight = 10; break;
            case 8: setImage("ChemicalWeapon.png"); break;
        }
        switch(s)
        {
            case 2: getImage().mirrorHorizontally(); break;
        }
        dy = yd;
    }

    public Weapons()
    {
    }

    public void act() 
    {
        // Add your action code here.
        basic();
        collide();
    }    

    public void basic()
    {
        if(realX() <= 0 || realX() >= wa.getWidth())
        {
            getWorld().removeObject(this);
        }
        if(target == null && image != 5)
        {
            if(s == 1)
            {
                mapX += 6;
            }
            else if(s == 2)
            {
                mapX -= 6;
            }
            if(image == 4 || image == 6)
            {
                angle += 6/Math.PI*180;
                setRotation((int)angle);
            }
        }
        if(image == 5)
        {
            height -= 5;
            if(height <= 0)
            {
                getWorld().addObject(new Overlay(2, 3, 4, realX(), realY(), 0), getX(), getY());
                getWorld().removeObject(this);
            }
        }
        if(image == 6 || image == 7)
        {
            height += changeheight;
            changeheight --;
            if(height <= 0 && changeheight <= 0 && image == 6)
            {
                getWorld().addObject(new Overlay(2, 1, 4, realX(), realY(), 0), getX(), getY());
                getWorld().removeObject(this);
            }
            if(height <= 0 && changeheight <= 0 && image == 7)
            {
                getWorld().addObject(new Overlay(3, 0, 0, realX(), realY(), 0), getX(), getY());
                getWorld().removeObject(this);
            }
            if(image == 7)
            {
                if(s == 1)
                {
                    mapX += 6;
                }
                else if(s == 2)
                {
                    mapX -= 6;
                }
                angle += 6/Math.PI*180;
                setRotation((int)angle);
            }
        }
        //For homing weapons, e.g. rockets
        if(target != null && image != 7)
        {
            try
            {
                if(target.realX() > realX())
                {
                    mapX += 6;
                }
                if(target.realX() < realX())
                {
                    mapX -= 6;
                }
                if(target.realY() > realY())
                {
                    mapY += 3;
                }
                if(target.realY() < realY())
                {
                    mapY -= 3;
                }
                if(target.getGameHeight() > getGameHeight())
                {
                    if(target.getGameHeight() - getGameHeight() > 8)
                    {
                        height += 3;
                    }
                    else
                    {
                        height ++;
                    }
                }
                if(target.getGameHeight() < getGameHeight())
                {
                    if(getGameHeight() - target.getGameHeight() > 8)
                    {
                        height -= 3;
                    }
                    else
                    {
                        height --;
                    }
                }
                if(target.getWorld() == null)
                {
                    getWorld().removeObject(this);
                }
            }
            catch(NullPointerException e)
            {
                getWorld().removeObject(this);
            }
        }
    }

    public void collide()
    {
        List pot = wa.Actors;
        for(int i = 0; i < pot.size(); i++)
        {
            DestructibleObjects b = (DestructibleObjects) pot.get(i);
            if((b.side != 6) && (b.realX()+b.getImage().getWidth()/2 >= realX()-getImage().getWidth()/2 && b.realX()-b.getImage().getWidth()/2 <= realX()+getImage().getWidth()/2) && (b.realY()+b.getImage().getHeight()/2 >= realY()-getImage().getHeight()/2 && b.realY()-b.getImage().getHeight()/2 <= realY()+getImage().getHeight()/2) && Math.abs(height-b.height) <= 1 && image != 5)
            {
                if((si == 1 && b.getSide() == 2) || (si == 2 && b.getSide() == 1))
                {    
                    b.takedamage(damage, type);
                    try
                    {
                        if(image == 7)
                        {
                            getWorld().addObject(new Overlay(3, 0, 0, realX(), realY(), 0), getX(), getY());
                        }
                        if(image == 8)
                        {
                            if(Greenfoot.getRandomNumber(40) == 39)
                            {
                                getWorld().addObject(new Overlay(14, 0, 0, realX(), realY(), 0), getX(), getY());
                            }
                        }
                        getWorld().removeObject(this);
                    }
                    catch(NullPointerException e)
                    {
                    }
                }
            }
        }
    }

    /**
     * The collision box
     */
    public Rectangle2D.Double collisionBox()
    {
        return new Rectangle2D.Double(realX() - getImage().getWidth()/2, realY() - getImage().getHeight()/2, getImage().getWidth(), getImage().getHeight());
    }
}
