import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.ArrayList;

/**
 * Worker Baby: Enough said.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class WorkerBaby  extends Units
{
    public Structures targetbuilding;
    private GreenfootImage frame1 = new GreenfootImage("WorkerBaby.png");
    private GreenfootImage frame2 = new GreenfootImage("WorkerBaby2.png");
    public int bag;
    public int maxbag = 25;
    private OreMine targ;
    private EBCRefinery returnsite;
    private ArrayList<OreMine> nearest = new ArrayList<OreMine>();
    private ArrayList<EBCRefinery> nearestreturn = new ArrayList<EBCRefinery>();
    public WorkerBaby(int iniside, int ix, int iy)
    {
        side = iniside;
        maxhitpoints = 40;
        attackimage = 1;
        armortype = 1;
        armorquantity = 0;
        range = 15;
        hitpoints = 40;
        weapontype = 1;
        damage = 3;
        delay = 40;
        canhitground = true;
        speed = 2;
        mapX = ix;
        mapY = iy;
        cost = 70;
    }
    public WorkerBaby(int iniside, Player pl, int ix, int iy)
    {
        owner = pl;
        side = iniside;
        maxhitpoints = 40;
        attackimage = 1;
        armortype = 1;
        armorquantity = 0;
        range = 15;
        hitpoints = 40;
        weapontype = 1;
        damage = 3;
        delay = 40;
        canhitground = true;
        speed = 2;
        mapX = ix;
        mapY = iy;
        cost = 70;
    }
    public WorkerBaby(int iniside, Player pl, int ix, int iy, int beh)
    {
        owner = pl;
        side = iniside;
        maxhitpoints = 40;
        attackimage = 1;
        armortype = 1;
        armorquantity = 0;
        range = 15;
        hitpoints = 40;
        weapontype = 1;
        damage = 3;
        delay = 40;
        canhitground = true;
        speed = 2;
        mapX = ix;
        mapY = iy;
        cost = 70;
        unitaction = beh;
    }
    public void addedToWorld(World w)
    {
        id = 18;
        genmaches = (Battleground) w;
        wa = genmaches.array;
        if(side == 1)
        {
            frame1.mirrorHorizontally();
            frame2.mirrorHorizontally();
        }
    }
    /**
     * Act - do whatever the WorkerBaby wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        updateimage();
        attack();
        createHealthBar();
        perish();
        getMine();
        alignImage();
    }    
    public void getMine()
    {
        
        for(DestructibleObjects n : wa.Actors)
        {
            if(n instanceof EBCRefinery)
            {
                nearest.clear();
                EBCRefinery m = (EBCRefinery) n;
                if(returnsite == null)
                {
                    returnsite = m;
                }
                try
                {
                    if((Math.sqrt(Math.pow(m.realX() - realX(), 2) + Math.pow(m.realY() - realY(), 2)) < Math.sqrt(Math.pow(returnsite.realX() - realX(), 2) + Math.pow(returnsite.realY() - realY(), 2))) && m.getOperational())
                    {
                        returnsite = m;
                    }
                }
                catch(NullPointerException e)
                {
                }
            }
        }
        if(bag == 0)
        {
        for(OreMine a : wa.ResourceSource)
        {
            if(targ == null)
            {
                targ = a;
            }
            try
            {
                if(Math.sqrt(Math.pow(a.realX() - realX(), 2) + Math.pow(a.realY() - realY(), 2)) < Math.sqrt(Math.pow(targ.realX() - realX(), 2) + Math.pow(targ.realY() - realY(), 2)))
                {
                    nearest.add(a);
                    if(nearest.size() == 1)
                    {
                        targ = a;
                    }
                    else
                        {
                            int min = 0;
                            int slot = 0;
                            for(int i = 0; i < nearest.size(); i++)
                            {
                                OreMine p = nearest.get(i);
                                int distance = (int)(Math.sqrt(Math.pow(p.realX() - returnsite.realX(), 2) + Math.pow(p.realY() - returnsite.realY(), 2)));
                                if(min == 0 || distance < min)
                                {
                                    slot = i;
                                    min = distance;
                                }
                            }
                            targ = nearest.get(slot);
                        }
                }
            }
            catch(NullPointerException e)
            {
            }
        }
    }
}
    public void updateimage()
    {
        if(unitaction == 0 && needchange)
        {
            needchange = false;
            setImage(frame1);
            if(touchIncompleteBuilding())
            {
                build();
                unitaction = 6;
            }
        }
        if(targetbuilding != null)
            {
                unitaction = 6;
            }
        if(unitaction == 6 && targetbuilding != null)
        {
            if((targetbuilding.realX() >= realX()-getImage().getWidth()/2 && targetbuilding.realX() <= realX()+getImage().getWidth()/2) && (targetbuilding.realY() >= realY()-getImage().getHeight()/2 && targetbuilding.realY() <= realY()+getImage().getHeight()/2))
            {
                build();
            }
            else if(targetbuilding != null && !targetbuilding.getOperational())
            {
                try
                {
                if(targetbuilding.realX() > realX() && targetbuilding.realY() >  realY())
                {
                mapX += 1;
                mapY += 1;
                }
                else if(targetbuilding.realX() > realX() && targetbuilding.realY() <  realY())
                {
                mapX += 1;
                mapY -= 1;
                }
                else if(targetbuilding.realX() < realX() && targetbuilding.realY() >  realY())
                {
                mapX -= 1;
                mapY += 1;
                }
                else if(targetbuilding.realX() < realX() && targetbuilding.realY() <  realY())
                {
                mapX -= 1;
                mapY -= 1;
                }
                else if(targetbuilding.realX() > realX())
                {
                    mapX += 2;
                }
                else if(targetbuilding.realX() < realX())
                {
                    mapX -= 2;
                }
                else if(targetbuilding.realY() > realY())
                {
                    mapY += 2;
                }
                else if(targetbuilding.realY() < realY())
                {
                    mapY -= 2;
                }
            }
            catch(NullPointerException e)
            {
            }
            }
        }
        if(unitaction == 7)
        {
            if(bag < maxbag)
            {
            try
                {
                if(targ.realX() > realX() && targ.realY() >  realY())
                {
                mapX += 1;
                mapY += 1;
                }
                else if(targ.realX() > realX() && targ.realY() <  realY())
                {
                mapX += 1;
                mapY -= 1;
                }
                else if(targ.realX() < realX() && targ.realY() >  realY())
                {
                mapX -= 1;
                mapY += 1;
                }
                else if(targ.realX() < realX() && targ.realY() <  realY())
                {
                mapX -= 1;
                mapY -= 1;
                }
                else if(targ.realX() > realX())
                {
                    mapX += 2;
                }
                else if(targ.realX() < realX())
                {
                    mapX -= 2;
                }
                else if(targ.realY() > realY())
                {
                    mapY += 2;
                }
                else if(targ.realY() < realY())
                {
                    mapY -= 2;
                }
            }
            catch(NullPointerException e)
            {
            }
            }
            if(bag >= maxbag)
            {
            try
                {
                if(returnsite.realX() > realX() && returnsite.realY() >  realY())
                {
                mapX += 1;
                mapY += 1;
                }
                else if(returnsite.realX() > realX() && returnsite.realY() <  realY())
                {
                mapX += 1;
                mapY -= 1;
                }
                else if(returnsite.realX() < realX() && returnsite.realY() >  realY())
                {
                mapX -= 1;
                mapY += 1;
                }
                else if(returnsite.realX() < realX() && returnsite.realY() <  realY())
                {
                mapX -= 1;
                mapY -= 1;
                }
                else if(returnsite.realX() > realX())
                {
                    mapX += 2;
                }
                else if(returnsite.realX() < realX())
                {
                    mapX -= 2;
                }
                else if(returnsite.realY() > realY())
                {
                    mapY += 2;
                }
                else if(returnsite.realY() < realY())
                {
                    mapY -= 2;
                }
            }
            catch(NullPointerException e)
            {
            }
            }
            try
        {   
            if(!((targ.realX() > realX() && targ.realX() <= realX()+getImage().getWidth()) && (targ.realY() > realY() && targ.realY() <= realY()+getImage().getHeight())))
            {
                targ.clear();
            }
        }
            catch(NullPointerException e)
            {
            }
        }
    }
    public void build()
    {
        if(touchIncompleteBuilding() && unitaction != 7)
        {
            for(Structures a : wa.Aedificium)
            {
                if((a instanceof BabyCamp || a instanceof EBCRefinery) && !a.getOperational() && (a.realX() >= realX()-getImage().getWidth()/2 && a.realX() <= realX()+getImage().getWidth()/2) && (a.realY() >= realY()-getImage().getHeight()/2 && a.realY() <= realY()+getImage().getHeight()/2))
                {
                    targetbuilding = a;
                }
            }
        }
        if(targetbuilding != null && (targetbuilding.realX() >= realX()-getImage().getWidth()/2 && targetbuilding.realX() <= realX()+getImage().getWidth()/2) && (targetbuilding.realY() >= realY()-getImage().getHeight()/2 && targetbuilding.realY() <= realY()+getImage().getHeight()/2))
        {
            try
            {
                if(!targetbuilding.getOperational())
                {
                targetbuilding.addBuild(1);
                framechange ++;
                    if(framechange >= 6)
                    {
                        frame ++;
                        switch(frame)
                        {
                            case 1: setImage(frame1); break;
                            case 2: setImage(frame2); break;
                        }
                        if(frame > 2)
                        {
                            frame = 1;
                            setImage(frame1);
                        }
                    }
                }
                else
                {
                    targetbuilding = null;
                }
            }
            catch(NullPointerException e)
            {
            }
        }
    }
    /**
     *  Returns true if the Worker Baby touches a building of its owner.
     */
    public boolean touchIncompleteBuilding()
    {
        boolean b = false;
        for(Structures a : wa.Aedificium)
        {
            if((a instanceof BabyCamp || a instanceof EBCRefinery) && !a.getOperational())
            {
                b = true;
            }
        }
        return b;
    }
    @Override public void flipimage()
    {
        frame1.mirrorHorizontally();
        frame2.mirrorHorizontally();
    }
}
