import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.ArrayList;

/**
 * Write a description of class WorkerSphere here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class WorkerSphere  extends Units
{
    GreenfootImage frame1 = new GreenfootImage("WorkerSphere1.png");
    GreenfootImage frame2 = new GreenfootImage("WorkerSphere2.png");
    GreenfootImage frame3 = new GreenfootImage("WorkerSphere3.png");
    GreenfootImage frame4 = new GreenfootImage("WorkerSphere4.png");
    GreenfootImage frame5 = new GreenfootImage("WorkerSphere5.png");
    GreenfootImage frame6 = new GreenfootImage("WorkerSphere6.png");
    GreenfootImage frame7 = new GreenfootImage("WorkerSphere7.png");
    GreenfootImage frame8 = new GreenfootImage("WorkerSphere8.png");
    GreenfootImage frame1l = new GreenfootImage("WorkerSphere1.png");
    GreenfootImage frame2l = new GreenfootImage("WorkerSphere2.png");
    GreenfootImage frame3l = new GreenfootImage("WorkerSphere3.png");
    GreenfootImage frame4l = new GreenfootImage("WorkerSphere4.png");
    GreenfootImage frame5l = new GreenfootImage("WorkerSphere5.png");
    GreenfootImage frame6l = new GreenfootImage("WorkerSphere6.png");
    GreenfootImage frame7l = new GreenfootImage("WorkerSphere7.png");
    GreenfootImage frame8l = new GreenfootImage("WorkerSphere8.png");
    GreenfootImage frame1r = new GreenfootImage("WorkerSphere1.png");
    GreenfootImage frame2r = new GreenfootImage("WorkerSphere2.png");
    GreenfootImage frame3r = new GreenfootImage("WorkerSphere3.png");
    GreenfootImage frame4r = new GreenfootImage("WorkerSphere4.png");
    GreenfootImage frame5r = new GreenfootImage("WorkerSphere5.png");
    GreenfootImage frame6r = new GreenfootImage("WorkerSphere6.png");
    GreenfootImage frame7r = new GreenfootImage("WorkerSphere7.png");
    GreenfootImage frame8r = new GreenfootImage("WorkerSphere8.png");
    public int maxbag = 50;
    public int bag;
    private OreMine targ;
    private Refinery returnsite;
    private ArrayList<OreMine> nearest = new ArrayList<OreMine>();
    private ArrayList<Refinery> nearestreturn = new ArrayList<Refinery>();
    private int reg;
    public WorkerSphere(int iniside, int ix, int iy)
    {
        side = iniside;
        maxhitpoints = 100;
        attackimage = 1;
        armortype = 2;
        armorquantity = 1;
        range = 30;
        hitpoints = 100;
        weapontype = 7;
        damage = 2;
        delay = 15;
        canhitground = true;
        speed = 2;
        mapX = ix;
        mapY = iy;
        id = 9;
    }
    public WorkerSphere(int iniside, Player pl, int ix, int iy)
    {
        owner = pl;
        side = iniside;
        maxhitpoints = 100;
        attackimage = 1;
        armortype = 2;
        armorquantity = 1;
        range = 30;
        hitpoints = 100;
        weapontype = 7;
        damage = 2;
        delay = 15;
        canhitground = true;
        speed = 2;
        mapX = ix;
        mapY = iy;
        id = 9;
    }
    public WorkerSphere(int iniside, Player pl, int ix, int iy, int cfg)
    {
        bag = cfg;
        owner = pl;
        side = iniside;
        maxhitpoints = 100;
        attackimage = 1;
        armortype = 2;
        armorquantity = 1;
        range = 30;
        hitpoints = 100;
        weapontype = 7;
        damage = 2;
        delay = 15;
        canhitground = true;
        speed = 2;
        mapX = ix;
        mapY = iy;
        id = 9;
    }
    public void addedToWorld(World w)
    {
        id = 9;
        genmaches = (Battleground) w;
        wa = genmaches.array;
        frame1l.mirrorHorizontally();
        frame2l.mirrorHorizontally();
        frame3l.mirrorHorizontally();
        frame4l.mirrorHorizontally();
        frame5l.mirrorHorizontally();
        frame6l.mirrorHorizontally();
        frame7l.mirrorHorizontally();
        frame8l.mirrorHorizontally();
    }
    /**
     * Act - do whatever the WorkerSphere wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        updateImage();
        //attack(); Not implemented Yet
        createHealthBar();
        perish();
        getMine();
        flipimage();
        alignImage();
    }    
    public void updateImage()
    {
        if(getOwner().Upgrades[1] > 0)
        {
            reg++;
            if(reg >= 40)
            {
                reg = 0;
                if(hitpoints < maxhitpoints)
                {
                    if((double)(maxhitpoints - hitpoints) < 1)
                    {
                        hitpoints = maxhitpoints;
                    }
                    else
                    {
                    hitpoints ++;
                    }
                }
            }
        }
        framechange ++;
        if(framechange >= framechangerate)
        {
            framechange = 0;
            frame++;
            needchange = true;
        }
        if(frame > 4)
        {
            frame = 1;
        }
        if(needchange)
        {
            if(bag == 0)
            {
                switch(frame)
                {
                    case 1: setImage(frame1); break;
                    case 2: setImage(frame2); break;
                    case 3: setImage(frame3); break;
                    case 4: setImage(frame4); break; 
                }
            }
            else
            {
                switch(frame)
                {
                    case 1: setImage(frame5); break;
                    case 2: setImage(frame6); break;
                    case 3: setImage(frame7); break;
                    case 4: setImage(frame8); break; 
                }
            }
            needchange = false;
        }
    }
    /**
     * gets the nearest mine and sets the sphere working.
     */
    public void getMine()
    {
        for(DestructibleObjects n : wa.Actors)
        {
            if(n instanceof Refinery)
            {
                Refinery m = (Refinery) n;
                try
                {
                    if((Math.sqrt(Math.pow(m.realX() - realX(), 2) + Math.pow(m.realY() - realY(), 2)) < Math.sqrt(Math.pow(returnsite.realX() - realX(), 2) + Math.pow(returnsite.realY() - realY(), 2))) || returnsite == null)
                    {
                        returnsite = m;
                    }
                }
                catch(NullPointerException e)
                {
                    returnsite = m;
                }
            }
        }
        if(bag == 0)
        {
        for(OreMine a : wa.ResourceSource)
        {
            try
            {
                if((Math.sqrt(Math.pow(a.realX() - realX(), 2) + Math.pow(a.realY() - realY(), 2)) < Math.sqrt(Math.pow(targ.realX() - realX(), 2) + Math.pow(targ.realY() - realY(), 2))) || targ == null)
                {
                    nearest.add(a);
                    if(nearest.size() == 1)
                    {
                        targ = a;
                    }
                    else
                        {
                            int min = 0;
                            int slot = 0;
                            for(int i = 0; i < nearest.size(); i++)
                            {
                                OreMine p = nearest.get(i);
                                int distance = (int)(Math.sqrt(Math.pow(p.realX() - returnsite.realX(), 2) + Math.pow(p.realY() - returnsite.realY(), 2)));
                                if(min == 0 || distance < min)
                                {
                                    slot = i;
                                    min = distance;
                                }
                            }
                            targ = nearest.get(slot);
                        }
                }
            }
            catch(NullPointerException e)
            {
                targ = a;
            }
        }
        }
        if(bag == 0)
        {
        if(targ != null)
        {
            if((targ.realX() > realX() && targ.getX() <= realX()+getImage().getWidth()) && (targ.realY() > realY() && targ.realY() <= realY()+getImage().getHeight()) && bag < maxbag)
            {
                targ.occupant = this;
                targ.needchange = true;
            }
            try
            {
                if(targ.realX() > realX() && targ.realY() >  realY())
                {
                mapX += 1;
                mapY += 1;
                dir = RIGHT;
                }
                else if(targ.realX() > realX() && targ.realY() <  realY())
                {
                mapX += 1;
                mapY -= 1;
                dir = RIGHT;
                }
                else if(targ.realX() < realX() && targ.realY() >  realY())
                {
                mapX -= 1;
                mapY += 1;
                dir = LEFT;
                }
                else if(targ.realX() < realX() && targ.realY() <  realY())
                {
                mapX -= 1;
                mapY -= 1;
                dir = LEFT;
                }
                else if(targ.realX() > realX())
                {
                    mapX += 2;
                    dir = RIGHT;
                }
                else if(targ.realX() < realX())
                {
                    mapX -= 2;
                    dir = LEFT;
                }
                else if(targ.realY() > realY())
                {
                    mapY += 2;
                }
                else if(targ.realY() < realY())
                {
                    mapY -= 2;
                }
            }
            catch(NullPointerException e)
            {
            }
        }
        }
        if(bag >= maxbag)
        {
            if(bag > maxbag)
            {
                bag = maxbag;
            }
            try
            {
                if(returnsite.realX() > realX() && returnsite.realY() >  realY())
                {
                mapX += 1;
                mapY += 1;
                dir = RIGHT;
                }
                else if(returnsite.realX() > realX() && returnsite.realY() <  realY())
                {
                mapX += 1;
                mapY -= 1;
                dir = RIGHT;
                }
                else if(returnsite.realX() < realX() && returnsite.realY() >  realY())
                {
                mapX -= 1;
                mapY += 1;
                dir = LEFT;
                }
                else if(returnsite.realX() < realX() && returnsite.realY() <  realY())
                {
                mapX -= 1;
                mapY -= 1;
                dir = LEFT;
                }
                else if(returnsite.realX() > realX())
                {
                    mapX += 2;
                    dir = RIGHT;
                }
                else if(returnsite.realX() < realX())
                {
                    mapX -= 2;
                    dir = LEFT;
                }
                else if(returnsite.realY() > realY())
                {
                    mapY += 2;
                }
                else if(returnsite.realY() < realY())
                {
                    mapY -= 2;
                }
            }
            catch(NullPointerException e)
            {
            }
        }
        try
        {   
            if(!((targ.realX() > realX() && targ.realX() <= realX()+getImage().getWidth()) && (targ.realY() > realY() && targ.realY() <= realY()+getImage().getHeight())))
            {
                targ.clear();
            }
        }
            catch(NullPointerException e)
            {
            }
    }
        @Override public void flipimage()
    {
        if(dir == LEFT)
        {
            if(frame1 != frame1l)
            {
                frame1 = frame1l;
            }
            if(frame2 != frame2l)
            {
                frame2 = frame2l;
            }
            if(frame3 != frame3l)
            {
                frame3 = frame3l;
            }
            if(frame4 != frame4l)
            {
                frame4 = frame4l;
            }
            if(frame5 != frame5l)
            {
                frame5 = frame5l;
            }
            if(frame6 != frame6l)
            {
                frame6 = frame6l;
            }
            if(frame7 != frame7l)
            {
                frame7 = frame7l;
            }
            if(frame8 != frame8l)
            {
                frame8 = frame8l;
            }
        }
        if(dir == RIGHT)
        {
            if(frame1 != frame1r)
            {
                frame1 = frame1r;
            }
            if(frame2 != frame2r)
            {
                frame2 = frame2r;
            }
            if(frame3 != frame3r)
            {
                frame3 = frame3r;
            }
            if(frame4 != frame4r)
            {
                frame4 = frame4r;
            }
            if(frame5 != frame5r)
            {
                frame5 = frame5r;
            }
            if(frame6 != frame6r)
            {
                frame6 = frame6r;
            }
            if(frame7 != frame7r)
            {
                frame7 = frame7r;
            }
            if(frame8 != frame8r)
            {
                frame8 = frame8r;
            }
        }
    }
}
