import greenfoot.*;
/**
 * World Array: Controls objects, moves and translates pertinent objects in game, and stores such units in multiple array lists.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
import java.util.List;
import java.util.ArrayList;
public class WorldArray  extends Actor
{
    // instance variables - replace the example below with your own
    public List<IngameSprite> resterrarum;
    public List<DestructibleObjects> Actors;
    public List<Units> Taxeis;
    public List<Structures> Aedificium;
    public List<Doodad> Shrubbery;
    public List<Player> Player;
    public List<OreMine> ResourceSource;
    private int worldwidth;
    private int x;
    public Battleground genmaches;
    private boolean map;
    private boolean initialized;
    private SelectionBox autorgos;
    private int xx;
    private int yy;
    public FieldSupportArea fsa;
    private boolean showtuttext;
    private int tuttext;
    public Portrait aa;
    public ArrayList<ArrayList<DestructibleObjects>> TaxeisUniv = new ArrayList<ArrayList<DestructibleObjects>>();
    /**
     * Constructor for objects of class WorldArray
     */
    public WorldArray()
    {
        for(int i = 0; i < 51; i++)
        {
            TaxeisUniv.add(new ArrayList<DestructibleObjects>());
        }
    }
    /**
     * Act - It first compiles the list of pertinent sprite objects in the game.
     * Moving and attacking code is implemented in the sprites themselves.
     */
    public void act()
    {
        if(showtuttext)
        {
            if(aa == null && tuttext <= 8)
            {
                aa = new Portrait(1, tuttext + 1);
                getWorld().addObject(aa, 40, 40);
            }
        }
        for(int b = 1; b < 50; b ++)
        {
            for(int w = 0; w < (TaxeisUniv.get(b)).size(); w++)
            {
                if((TaxeisUniv.get(b)).get(w).hitpoints <= 0)
                {
                    (TaxeisUniv.get(b)).remove((TaxeisUniv.get(b)).get(w));
                }
            }
        }
        if(!map)
        {
            map = true;
            getWorld().addObject(new Minimap(this), 445, 525);
        }
        for(int i = 0; i < Taxeis.size(); i ++)
        {
            Units a = Taxeis.get(i);
            if(a.selected && tuttext == 2)
            {
                addtut();
            }
            if(a.getSide() == 1)
            {
                switch(a.getAction())
                {
                    case 1: if(a.realX() > 0 && a.realX() < getWidth()){a.setRealLocation(a.realX() + a.getSpeed(), a.realY());} else if (a.realX() <= 0){a.setRealLocation(1, a.realY());} else if(a.realX() >= getWidth()){a.setRealLocation((int)(getWidth()-1), a.realY());}; a.prevdir = a.dir; a.dir = a.RIGHT; break;
                    case 2: if(a.realX() > 0 && a.realX() < getWidth()){a.setRealLocation(a.realX() - a.getSpeed(), a.realY());} else if (a.realX() <= 0){a.setRealLocation(1, a.realY());} else if(a.realX() >= getWidth()){a.setRealLocation((int)(getWidth()-1), a.realY());}; a.prevdir = a.dir; a.dir = a.LEFT; break;
                    case 4: if(a.getTrans() > 0){a.setRealLocation(a.realX(), a.realY()-a.getSpeed()); a.setVerticalTranslation(a.getTrans()-a.getSpeed());} else{a.setBehavior(0);}; break;
                    case 5: if(a.getTrans() > 0){a.setRealLocation(a.realX(), a.realY()+a.getSpeed()); a.setVerticalTranslation(a.getTrans()-a.getSpeed());} else{a.setBehavior(0);}; break;
                    case 8: if(a.realX() > 0 && a.realX() < getWidth()){a.setRealLocation(a.realX() - a.getSpeed(), a.realY());} else if (a.realX() <= 0){a.setRealLocation(1, a.realY());} else if(a.realX() >= getWidth()){a.setRealLocation((int)(getWidth()-1), a.realY());}; a.prevdir = a.dir; a.dir = a.LEFT; break;
                }
            }
            if(a.getSide() == 2)
            {
                switch(a.getAction())
                {
                    case 1: if(a.realX() > 0 && a.realX() < getWidth()){a.setRealLocation(a.realX() - a.getSpeed(), a.realY());} else if (a.realX() <= 0){a.setRealLocation(1, a.realY());} else if(a.realX() >= getWidth()){a.setRealLocation((int)(getWidth()-1), a.realY());}; a.prevdir = a.dir; a.dir = a.LEFT; break;
                    case 2: if(a.realX() > 0 && a.realX() < getWidth()){a.setRealLocation(a.realX() + a.getSpeed(), a.realY());} else if (a.realX() <= 0){a.setRealLocation(1, a.realY());} else if(a.realX() >= getWidth()){a.setRealLocation((int)(getWidth()-1), a.realY());}; a.prevdir = a.dir; a.dir = a.RIGHT; break;
                    case 4: if(a.getTrans() > 0){a.setRealLocation(a.realX(), a.realY()-a.getSpeed()); a.setVerticalTranslation(a.getTrans()-a.getSpeed());} else{a.setBehavior(0);}; break;
                    case 5: if(a.getTrans() > 0){a.setRealLocation(a.realX(), a.realY()+a.getSpeed()); a.setVerticalTranslation(a.getTrans()-a.getSpeed());} else{a.setBehavior(0);}; break;
                    case 8: if(a.realX() > 0 && a.realX() < getWidth()){a.setRealLocation(a.realX() + a.getSpeed(), a.realY());} else if (a.realX() <= 0){a.setRealLocation(1, a.realY());} else if(a.realX() >= getWidth()){a.setRealLocation((int)(getWidth()-1), a.realY());}; a.prevdir = a.dir; a.dir = a.RIGHT; break;
                }
            }
        }
        MouseInfo ms = Greenfoot.getMouseInfo();
        if (Greenfoot.mousePressed(null) && ms.getX() > 5 && ms.getX() < 795 && ms.getY() > 5 && ms.getY() < 480 && ms.getButton() == 1)
        {
            xx = ms.getX();
            yy = ms.getY();
            initialized = true;
        }
        if(Greenfoot.mouseDragged(null) && initialized)
        {
            if(autorgos == null)
            {
                autorgos = new SelectionBox(ms.getX(), ms.getY());
                getWorld().addObject(autorgos, ms.getX(), ms.getY());
            }
            else
            {
                autorgos.contmakebox(ms.getX(), ms.getY());
            }
        }
        if (Greenfoot.mouseDragEnded(null) && autorgos != null)
        {
            if(initialized)
            {
                initialized = false;
                for(DestructibleObjects b : Actors)
                {
                    b.deselect();
                }
            }
            if(!initialized)
            {
                for(Units a : Taxeis)
                {
                    if(a.getOwner() == genmaches.thePlayer && a.getX() > autorgos.getX() - autorgos.getWidth() / 2 && a.getX() < autorgos.getX() + autorgos.getWidth() / 2 && a.getY() > autorgos.getY() - autorgos.getHeight() / 2 && a.getY() < autorgos.getY() + autorgos.getHeight() / 2 && !(a instanceof WorkerSphere))
                    {
                        a.select();
                    }
                }
                getWorld().removeObject(autorgos);
                autorgos = null;
            }
        }
        if(Greenfoot.mousePressed(null) && ms.getButton() == 1 && fsa != null)
        {
            try
            {
                if(fsa.getID() == 1)
                {
                    List o = fsa.getPotentialTargets(Units.class);
                    for(Units a : Taxeis)
                    {
                        if(o.contains(a) && a.getX() > 0 && a.getX() < 800 && a.getSide() == fsa.getOwner().getSide())
                        {
                            a.addBuff(new Buff(1, 600, a));
                        }
                    }
                }
                else if(fsa.getID() == 3)
                {
                    if(Greenfoot.getRandomNumber(5) == 0)
                    {
                        for(int i = 0; i < 12; i ++)
                        {
                            int xx2 = Greenfoot.getRandomNumber(150);
                            int yy = Greenfoot.getRandomNumber(100);
                            xx2 -= Greenfoot.getRandomNumber(150);
                            yy -= Greenfoot.getRandomNumber(100);
                            getWorld().addObject(new PistoleerBaby(fsa.getOwner().getSide(), fsa.getOwner(), (fsa.getX() - genmaches.camerachange + xx2), fsa.getY() + yy), getX() - genmaches.camerachange + xx2, getY() + yy);
                        }
                    }
                    if(Greenfoot.getRandomNumber(5) == 1)
                    {
                        for(int i = 0; i < 6; i ++)
                        {
                            int xx2 = Greenfoot.getRandomNumber(150);
                            int yy = Greenfoot.getRandomNumber(100);
                            xx2 -= Greenfoot.getRandomNumber(150);
                            yy -= Greenfoot.getRandomNumber(100);
                            getWorld().addObject(new PistoleerBaby(fsa.getOwner().getSide(), fsa.getOwner(), (fsa.getX() - genmaches.camerachange + xx2), fsa.getY() + yy), getX() - genmaches.camerachange + xx2, getY() + yy);
                        }
                        for(int i = 0; i < 4; i ++)
                        {
                            int xx2 = Greenfoot.getRandomNumber(150);
                            int yy = Greenfoot.getRandomNumber(100);
                            xx2 -= Greenfoot.getRandomNumber(150);
                            yy -= Greenfoot.getRandomNumber(100);
                            getWorld().addObject(new GrenadierBaby(fsa.getOwner().getSide(), fsa.getOwner(), (fsa.getX() - genmaches.camerachange + xx2), fsa.getY() + yy), getX() - genmaches.camerachange + xx2, getY() + yy);
                        }
                    }
                    if(Greenfoot.getRandomNumber(5) == 2)
                    {
                        for(int i = 0; i < 5; i ++)
                        {
                            int xx2 = Greenfoot.getRandomNumber(150);
                            int yy = Greenfoot.getRandomNumber(100);
                            xx2 -= Greenfoot.getRandomNumber(150);
                            yy -= Greenfoot.getRandomNumber(100);
                            getWorld().addObject(new FlamethrowerBaby(fsa.getOwner().getSide(), fsa.getOwner(), (fsa.getX() - genmaches.camerachange + xx2), fsa.getY() + yy), getX() - genmaches.camerachange + xx2, getY() + yy);
                        }
                    }
                    if(Greenfoot.getRandomNumber(5) == 3)
                    {
                        for(int i = 0; i < 2; i ++)
                        {
                            int xx2 = Greenfoot.getRandomNumber(150);
                            int yy2 = Greenfoot.getRandomNumber(100);
                            xx2 -= Greenfoot.getRandomNumber(150);
                            yy2 -= Greenfoot.getRandomNumber(100);
                            getWorld().addObject(new FlamethrowerBaby(fsa.getOwner().getSide(), fsa.getOwner(), (fsa.getX() - genmaches.camerachange + xx2), fsa.getY() + yy2), getX() - genmaches.camerachange + xx2, getY() + yy2);
                        }
                        for(int i = 0; i < 5; i ++)
                        {
                            int xx2 = Greenfoot.getRandomNumber(150);
                            int yy2 = Greenfoot.getRandomNumber(100);
                            xx2 -= Greenfoot.getRandomNumber(150);
                            yy2 -= Greenfoot.getRandomNumber(100);
                            getWorld().addObject(new SuicideBaby(fsa.getOwner().getSide(), fsa.getOwner(), (fsa.getX() - genmaches.camerachange + xx2), fsa.getY() + yy2), getX() - genmaches.camerachange + xx2, getY() + yy2);
                        }
                    }
                    if(Greenfoot.getRandomNumber(5) == 4)
                    {
                        for(int i = 0; i < 3; i ++)
                        {
                            int xx2 = Greenfoot.getRandomNumber(150);
                            int yy2 = Greenfoot.getRandomNumber(100);
                            xx2 -= Greenfoot.getRandomNumber(150);
                            yy2 -= Greenfoot.getRandomNumber(100);
                            getWorld().addObject(new PistoleerBaby(fsa.getOwner().getSide(), fsa.getOwner(), (fsa.getX() - genmaches.camerachange + xx2), fsa.getY() + yy2), getX() - genmaches.camerachange + xx2, getY() + yy2);
                        }
                        for(int i = 0; i < 3; i ++)
                        {
                            int xx2 = Greenfoot.getRandomNumber(150);
                            int yy2 = Greenfoot.getRandomNumber(100);
                            xx2 -= Greenfoot.getRandomNumber(150);
                            yy2 -= Greenfoot.getRandomNumber(100);
                            getWorld().addObject(new SuicideBaby(fsa.getOwner().getSide(), fsa.getOwner(), (fsa.getX() - genmaches.camerachange + xx2), fsa.getY() + yy2), getX() - genmaches.camerachange + xx2, getY() + yy2);
                        }
                        for(int i = 0; i < 2; i ++)
                        {
                            int xx2 = Greenfoot.getRandomNumber(150);
                            int yy2 = Greenfoot.getRandomNumber(100);
                            xx2 -= Greenfoot.getRandomNumber(150);
                            yy2 -= Greenfoot.getRandomNumber(100);
                            getWorld().addObject(new GrenadierBaby(fsa.getOwner().getSide(), fsa.getOwner(), (fsa.getX() - genmaches.camerachange + xx2), fsa.getY() + yy2), getX() - genmaches.camerachange + xx2, getY() + yy2);
                        }
                    }
                }
                else if(fsa.getID() == 8)
                {
                    MissileLaunchPad a = (MissileLaunchPad) fsa.getBase();
                    if(a.cw != null)
                    {
                        if(ms.getY() < 450)
                        {
                            a.cw.launch(ms.getX() - getx(), ms.getY());
                        }
                        else
                        {
                            a.cw.launch(ms.getX() - getx(), 450);
                        }
                        a.cw = null;
                    }
                }
                else if(fsa.getID() == 9)
                {
                    CommandPost a = (CommandPost) fsa.getBase();
                        if(ms.getY() < 430)
                        {
                            switch(genmaches.thePlayer.getSide())
                            {
                                case 1: getWorld().addObject(new Fighter(1, 2, fsa.getY() - 10), 2, fsa.getY() - 10); getWorld().addObject(new Fighter(1, 2, fsa.getY() + 10), 2, fsa.getY() + 10); break;
                                case 2: getWorld().addObject(new Fighter(2, (int) getWidth() - 2, fsa.getY() - 10), (int) getWidth() - 2, fsa.getY() - 10); getWorld().addObject(new Fighter(2, (int) getWidth() - 2, fsa.getY() + 10), (int) getWidth() - 2, fsa.getY() + 10); break;
                            }
                        }
                        else
                        {
                            switch(genmaches.thePlayer.getSide())
                            {
                                case 1: getWorld().addObject(new Fighter(1, 2, 420), 2, fsa.getY() - 10); getWorld().addObject(new Fighter(1, 2, fsa.getY() + 440), 2, fsa.getY() + 10); break;
                                case 2: getWorld().addObject(new Fighter(2, (int) getWidth() - 2, 420), (int) getWidth() - 2, fsa.getY() - 10); getWorld().addObject(new Fighter(2, (int) getWidth() - 2, 440), (int) getWidth() - 2, fsa.getY() + 10); break;
                            }
                        }
                }
                fsa.getBase().buttoncooldown.set(fsa.occupyslot, fsa.cooldown);
                getWorld().removeObject(fsa);
                fsa = null;
            }
            catch(NullPointerException e)
            {
            }
        }
        if(Greenfoot.mousePressed(null) && ms.getButton() == 3 && fsa != null)
        {
            try
            {
                getWorld().removeObject(fsa);
                fsa = null;
            }
            catch(NullPointerException e)
            {
            }
        }
    }
    public void addedToWorld(World w)
    {
        genmaches = (Battleground) w;
    }
    /**
     * sets the screen and orients the object to the screen every act.
     */
    public void setScreen(int x)
    {
        genmaches.camerachange = x;
        if(x != genmaches.camerachange)
        {
            moveObjects(x);
            x = x;
        }
        else
        {
            moveActors(x);
        }
    }
    public void setWidth(int x)
    {
        worldwidth = x;
    }
    /**
     * Returns the width of the battle map. It is float for calculation in minimap.
     */
    public float getWidth()
    {
        return worldwidth;
    }
    /**
     * gets the delta x.
     */
    public int getx()
    {
        return x;
    }
    /**
     * MOVE!
     */
    private void moveObjects(int x)
    {
         List<IngameSprite> resterrarum = (List<IngameSprite>)getWorld().getObjects(IngameSprite.class);
         for(int i = 0; i < resterrarum.size(); i ++)
            {
                if((resterrarum.get(i).getX() + getImage().getWidth() <= 800) || (resterrarum.get(i).getX() - getImage().getWidth() > 0))
                resterrarum.get(i).setLocation(resterrarum.get(i).realX() + x, resterrarum.get(i).realY());
            }
    }
    /**
     * or not...
     */
    private void moveActors(int x)
    {
         List<DestructibleObjects> Actors = (List<DestructibleObjects>)getWorld().getObjects(DestructibleObjects.class);
         for(int i = 0; i < Actors.size(); i ++)
            {
                if((Actors.get(i).getX() + getImage().getWidth() <= 800) || (Actors.get(i).getX() - getImage().getWidth() > 0))
                {
                Actors.get(i).setLocation(Actors.get(i).realX() + x, Actors.get(i).realY());
                }
            }
         List<Weapons> wp = (List<Weapons>)getWorld().getObjects(Weapons.class);
         for(int i = 0; i < wp.size(); i++)
         {
             if((wp.get(i).getX() + getImage().getWidth() <= 800) || (wp.get(i).getX() - getImage().getWidth() > 0))
             {
             wp.get(i).setLocation(wp.get(i).realX() + x, wp.get(i).realY());
             }
         }
    }
    public void setTutorial(boolean a)
    {
        showtuttext = true;
    }
    public void addtut()
    {
        tuttext ++;
    }
    public int gettut()
    {
        return tuttext;
    }
}
