import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class AATrack here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class AATrack  extends Units
{
    GreenfootImage frame1 = new GreenfootImage("AATrack.png");
    GreenfootImage frame2 = new GreenfootImage("AATrack2.png");
    GreenfootImage frame3 = new GreenfootImage("AATrack3.png");
    GreenfootImage frame1l = new GreenfootImage("AATrack.png");
    GreenfootImage frame2l = new GreenfootImage("AATrack2.png");
    GreenfootImage frame3l = new GreenfootImage("AATrack3.png");
    GreenfootImage frame1r = new GreenfootImage("AATrack.png");
    GreenfootImage frame2r = new GreenfootImage("AATrack2.png");
    GreenfootImage frame3r = new GreenfootImage("AATrack3.png");
    public AATrack(int iniside, int ix, int iy)
    {
        side = iniside;
        maxhitpoints = 150;
        attackimage = 4;
        armortype = 2;
        armorquantity = 0;
        range = 170;
        hitpoints = 150;
        weapontype = 1;
        damage = 6;
        delay = 12;
        canhitair = true;
        speed = 3;
        mapX = ix;
        mapY = iy;
        cost = 75;
        id = 16;
        mechanical = true;
    }
    public AATrack(int iniside, Player pl, int ix, int iy)
    {
        side = iniside;
        maxhitpoints = 150;
        attackimage = 4;
        armortype = 2;
        armorquantity = 0;
        range = 170;
        hitpoints = 150;
        weapontype = 1;
        damage = 6;
        delay = 12;
        canhitair = true;
        speed = 3;
        mapX = ix;
        mapY = iy;
        owner = pl;
        cost = 75;
        id = 16;
        mechanical = true;
    }
    public void addedToWorld(World w)
    {
        id = 16;
        genmaches = (Battleground) w;
        wa = genmaches.array;
        if(side == 1)
        {
            frame1.mirrorHorizontally();
            frame2.mirrorHorizontally();
            frame3.mirrorHorizontally();
        }
        frame1r.mirrorHorizontally();
        frame2r.mirrorHorizontally();
        frame3r.mirrorHorizontally();
    }
    /**
     * Act - do whatever the AATrack wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        collisionReact();
        attack();
        createHealthBar();
        perish();
        updateimage();
        flipimage();
        alignImage();
    }    
    public void updateimage()
    {
        if(unitaction == 0)
        {
            if(needchange)
            {
                frame = 1;
                setImage(frame1);
                needchange = false;
            }
        }
        if(unitaction != 0)
        {
            if(unitaction == 1)
            {
                if(realX() <= 0 || realX() >= wa.getWidth())
                {
                    unitaction = 0;
                }
                if(framechange <= framechangerate)
                {
                    needchange = true;
                    framechange = 0;
                    frame ++;
                }
                if(needchange)
                {
                    setImage(frame1);
                    needchange = false;
                }
            }
            else if(unitaction == 2 || unitaction == 4 || unitaction == 5)
            {
                if(realX() <= 0 || realX() >= wa.getWidth())
                {
                    unitaction = 0;
                }
                else
                {
                if(needchange)
                {
                    setImage(frame1);
                    needchange = false;
                }
                }
            }
            else if(unitaction == 3)
            {
                if(framechange <= framechangerate)
                {
                    needchange = true;
                    framechange = 0;
                    frame ++;
                }
                if(!enemyInSight())
                {
                    unitaction = prevact;
                    frame = 1;
                    needchange = true;
                }
                if(needchange)
                {
                    switch(frame)
                    {
                        case 1: setImage(frame1); break;
                        case 2: setImage(frame2); break;
                        case 3: setImage(frame3); break;
                    }
                    needchange = false;
                }
                if(frame > 3)
                {
                    frame = 1;
                }
            }
        }
    }
    @Override public void flipimage()
    {
        if(dir == LEFT)
        {
            if(frame1 != frame1l)
            {
                frame1 = frame1l;
            }
            if(frame2 != frame2l)
            {
                frame2 = frame2l;
            }
            if(frame3 != frame3l)
            {
                frame3 = frame3l;
            }
        }
        if(dir == RIGHT)
        {
            if(frame1 != frame1r)
            {
                frame1 = frame1r;
            }
            if(frame2 != frame2r)
            {
                frame2 = frame2r;
            }
            if(frame3 != frame3r)
            {
                frame3 = frame3r;
            }
        }
    }
    @Override public void playSound()
    {
        Greenfoot.playSound("Flak.wav");
    }
}
