import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;

/**
 * Write a description of class Airfield here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Airfield  extends Structures
{
    private NapalmBomber occupant;
    private int rearming;
    public boolean auto;
    public Airfield(int iniside, int ix, int iy)
    {
        side = iniside;
        maxhitpoints = 400;
        armortype = 4;
        armorquantity = 2;
        hitpoints = 400;
        mapX = ix;
        mapY = iy;
        cost = 75;
        deployed = true;
        id = 4;
    }
    public Airfield(int iniside, Player pl, int ix, int iy)
    {
        owner = pl;
        side = iniside;
        maxhitpoints = 400;
        armortype = 4;
        armorquantity = 2;
        hitpoints = 400;
        mapX = ix;
        mapY = iy;
        cost = 75;
        deployed = true;
        id = 4;
    }
    /**
     * Act - do whatever the Airfield wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        createHealthBar();
        createProgressBar();
        produce();
        createUnit();
        perish();
        if(occupant != null)
        {
            rearm();
            if(auto)
            {
                sendOutAutomatically();
            }
        }
    }    
    public void createUnit()
    {
        if(progressperc == 1)
        {
            switch(prodtype)
            {
                case 7: getWorld().addObject(new AirborneDrone(side, owner, realX(), realY()), getX(), getY()); clearProduction(); break;
                case 8: if(occupant == null){NapalmBomber a = new NapalmBomber(side, owner, realX(), realY(), this); occupant = a; getWorld().addObject(a, getX(), getY());} else{getWorld().addObject(new ErrorText("You already have an bomber in this airfield.", 250), 400, 400); getOwner().resources += 250;}; clearProduction(); break;
            }
        }
    }
    public void rearm()
    {
        if((int)(Math.sqrt(Math.pow(realX() - occupant.realX(), 2) + Math.pow(realY() - occupant.realY(), 2))) < 5 && occupant.getGameHeight() <= 0)
        {
            rearming ++;
            if(rearming >= 100)
            {
                rearming = 0;
                if(occupant.bombs < 8)
                {
                    occupant.bombs ++;
                }
            }
        }
    }
    public void sendOutAutomatically()
    {
        if(occupant.bombs == 8 || (occupant.bombs > 0 && occupant.getAction() == 7 && occupant.getTarget().hitpoints <= 0))
        {
            for(DestructibleObjects a : wa.Actors)
            {
                if(a.getSide() != getSide() && a.getSide() != 6)
                {
                    occupant.enemy = a;
                    occupant.setBehavior(7);
                }
            }
        }
    }
    public NapalmBomber getOccupant()
    {
        return occupant;
    }
}
