import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Airstrip here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Airstrip  extends Structures
{
    public Airstrip(int iniside, int ix, int iy)
    {
        side = iniside;
        maxhitpoints = 400;
        armortype = 4;
        armorquantity = 2;
        hitpoints = 400;
        mapX = ix;
        mapY = iy;
        cost = 200;
        id = 12;
    }
    public Airstrip(int iniside, Player pl, int ix, int iy)
    {
        owner = pl;
        side = iniside;
        maxhitpoints = 400;
        armortype = 4;
        armorquantity = 2;
        hitpoints = 400;
        mapX = ix;
        mapY = iy;
        cost = 200;
        id = 12;
    }
    public void addedToWorld(World w)
    {
        deployed = true;
        genmaches = (Battleground) w;
        wa = genmaches.array;
        if(side == 1)
        {
            getImage().mirrorHorizontally();
        }
    }
    /**
     * Act - do whatever the Airstrip wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        createHealthBar();
        createProgressBar();
        produce();
        createUnit();
        perish();
    }    
     public void createUnit()
    {
        if(progressperc == 1)
        {
            getWorld().addObject(new ReinforcementAirlift(prodtype, this, realX(), realY()), getX(), getY());
            clearProduction();
        }
        for(java.lang.Object a : genmaches.getObjects(Units.class))
        {
            if(a instanceof ReinforcementAirlift)
            {
                ReinforcementAirlift b = (ReinforcementAirlift) a;
                if(b.realX() >= realX()-getImage().getWidth()/2 && b.realX() <= realX()+getImage().getWidth()/2 && b.realY() >= realY()-getImage().getHeight()/2 && b.realY() <= realY()+getImage().getHeight()/2 && b.getGameHeight() <= 10 && !b.unloaded())
                {
                    int dx = 0;
                    switch(side)
                    {
                        case 1: dx = 80; break;
                        case 2: dx = -80; break;
                    }
                    switch(b.getCargo())
                    {
                        case 20: getWorld().addObject(new PosterityMBT(side, owner, realX()+dx, realY()), getX()+dx, getY()); break;
                        case 21: getWorld().addObject(new ChemTank(side, owner, realX()+dx, realY()), getX()+dx, getY()); break;
                        case 22: getWorld().addObject(new Artillery(side, owner, realX()+dx, realY()), getX()+dx, getY()); break;
                        case 25: getWorld().addObject(new MechaHoplite(side, owner, realX()+dx, realY()), getX()+dx, getY()); break;
                        case 32: getWorld().addObject(new PosterityConstructionHubCarrier(side, owner, realX()+dx, realY()), getX()+dx, getY()); break;
                    }
                    b.unload();
                }
            }
        }
    }
}
