import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.geom.*;

/**
 * Write a description of class Artillery here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Artillery  extends Units
{
    GreenfootImage frame1 = new GreenfootImage("Artillery.png");
    GreenfootImage frame2 = new GreenfootImage("Artillery3.png");
    GreenfootImage frame3 = new GreenfootImage("Artillery4.png");
    GreenfootImage frame4 = new GreenfootImage("Artillery5.png");
    GreenfootImage frame5 = new GreenfootImage("Artillery6.png");
    GreenfootImage frame6 = new GreenfootImage("Artillery7.png");
    GreenfootImage frame7 = new GreenfootImage("Artillery8.png");
    GreenfootImage frame1l = new GreenfootImage("Artillery.png");
    GreenfootImage frame2l = new GreenfootImage("Artillery3.png");
    GreenfootImage frame3l = new GreenfootImage("Artillery4.png");
    GreenfootImage frame4l = new GreenfootImage("Artillery5.png");
    GreenfootImage frame5l = new GreenfootImage("Artillery6.png");
    GreenfootImage frame6l = new GreenfootImage("Artillery7.png");
    GreenfootImage frame7l = new GreenfootImage("Artillery8.png");
    GreenfootImage frame1r = new GreenfootImage("Artillery.png");
    GreenfootImage frame2r = new GreenfootImage("Artillery3.png");
    GreenfootImage frame3r = new GreenfootImage("Artillery4.png");
    GreenfootImage frame4r = new GreenfootImage("Artillery5.png");
    GreenfootImage frame5r = new GreenfootImage("Artillery6.png");
    GreenfootImage frame6r = new GreenfootImage("Artillery7.png");
    GreenfootImage frame7r = new GreenfootImage("Artillery8.png");
    public Artillery(int iniside, int ix, int iy)
    {
        side = iniside;
        maxhitpoints = 150;
        attackimage = 12;
        armortype = 2;
        armorquantity = 1;
        range = 600;
        hitpoints = 150;
        weapontype = 3;
        damage = 30;
        delay = 160;
        canhitground = true;
        canhitair = false;
        speed = 1;
        mapX = ix;
        mapY = iy;
        cost = 200;
        id = 22;
        mechanical = true;
    }
    public Artillery(int iniside, Player pl, int ix, int iy)
    {
        side = iniside;
        maxhitpoints = 150;
        attackimage = 12;
        armortype = 2;
        armorquantity = 1;
        range = 600;
        hitpoints = 150;
        weapontype = 3;
        damage = 30;
        delay = 160;
        canhitground = true;
        canhitair = false;
        speed = 1;
        mapX = ix;
        mapY = iy;
        owner = pl;
        cost = 200;
        id = 22;
        mechanical = true;
    }
    public void addedToWorld(World w)
    {
        id = 22;
        genmaches = (Battleground) w;
        wa = genmaches.array;
        frame1l.mirrorHorizontally();
        frame2l.mirrorHorizontally();
        frame3l.mirrorHorizontally();
        frame4l.mirrorHorizontally();
        frame5l.mirrorHorizontally();
        frame6l.mirrorHorizontally();
        frame7l.mirrorHorizontally();
    }
    /**
     * Act - do whatever the Artillery wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        updateimage();
        flipimage();
        alignImage();
        attack();
        createHealthBar();
        perish();
        collisionReact();
    }    
    /**
     * Overrides attack parameter to implement minimum range.
     */
    @Override public Rectangle2D.Double attackParameter()
    {
        Rectangle2D.Double a = new Rectangle2D.Double(0,0,0,0);
        if(side == 1)
        {
            a = new Rectangle2D.Double(getX() + 100, getY() - 120, range, 240);
        }
        else
        {

            a = new Rectangle2D.Double(getX()-range - 100, getY() - 120, range, 240);
        }
        return a;
    }
    public void updateimage()
    {
        if(unitaction == 0)
        {
            if(needchange)
            {
                setImage(frame1);
            }
        }
        if(unitaction != 0)
        {
            framechange++;
            if(unitaction == 1)
            {
                if(framechange <= framechangerate)
                {
                    needchange = true;
                    framechange = 0;
                    frame ++;
                }
                if(realX() <= 0 || realX() >= wa.getWidth())
                {
                    unitaction = 0;
                }
                if(frame > 1)
                {
                    frame = 1;
                }
                if(needchange)
                    {
                        needchange = false;
                        switch(frame)
                        {
                            case 1: setImage(frame1); break;
                        }
                    }
            }
            else if(unitaction == 2 || unitaction == 4 || unitaction == 5)
            {
                if(framechange <= framechangerate)
                {
                    needchange = true;
                    framechange = 0;
                    frame ++;
                }
                if(realX() <= 0 || realX() >= wa.getWidth())
                {
                    unitaction = 0;
                }
                else
                {
                if(frame > 1)
                {
                    frame = 1;
                }
                if(needchange)
                    {
                        needchange = false;
                        switch(frame)
                        {
                            case 1: setImage(frame1); break;
                        }
                    }
                }
            }
            else if(unitaction == 3)
            {
                if(!enemyInSight())
                {
                    unitaction = prevact;
                    frame = 1;
                    needchange = true;
                }
                    if(framechange >= reload - 6)
                    {
                        needchange = true;
                        frame ++;
                    }
                    if(needchange)
                    {
                        needchange = false;
                        switch(frame)
                        {
                            case 1: setImage(frame2); break;
                            case 2: setImage(frame3); break;
                            case 3: setImage(frame4); break;
                            case 4: setImage(frame5); break;
                            case 5: setImage(frame6); break;
                            case 6: setImage(frame7); break;
                        }
                    }
                if(frame > 6)
                {
                    frame = 1;
                    framechange = 0;
                    needchange = true;
                }
            }
        }
    }
    @Override public void flipimage()
    {
        if(dir == LEFT)
        {
            if(frame1 != frame1l)
            {
                frame1 = frame1l;
            }
            if(frame2 != frame2l)
            {
                frame2 = frame2l;
            }
            if(frame3 != frame3l)
            {
                frame3 = frame3l;
            }
            if(frame4 != frame4l)
            {
                frame4 = frame4l;
            }
            if(frame5 != frame5l)
            {
                frame5 = frame5l;
            }
            if(frame6 != frame6l)
            {
                frame6 = frame6l;
            }
            if(frame7 != frame7l)
            {
                frame7 = frame7l;
            }
        }
        if(dir == RIGHT)
        {
            if(frame1 != frame1r)
            {
                frame1 = frame1r;
            }
            if(frame2 != frame2r)
            {
                frame2 = frame2r;
            }
            if(frame3 != frame3r)
            {
                frame3 = frame3r;
            }
            if(frame4 != frame4r)
            {
                frame4 = frame4r;
            }
            if(frame5 != frame5r)
            {
                frame5 = frame5r;
            }
            if(frame6 != frame6r)
            {
                frame6 = frame6r;
            }
            if(frame7 != frame7r)
            {
                frame7 = frame7r;
            }
        }
    }
}
