import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class BabyCamp here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class BabyCamp  extends Structures
{
    private GreenfootImage frame1 = new GreenfootImage("BabyCamp.PNG");
    private GreenfootImage build1 = new GreenfootImage("EBCStructureBuilding1.png");
    private GreenfootImage build2 = new GreenfootImage("EBCStructureBuilding2.png");
    private GreenfootImage build3 = new GreenfootImage("EBCStructureBuilding3.png");
    private GreenfootImage build4 = new GreenfootImage("EBCStructureBuilding4.png");
    private GreenfootImage build5 = new GreenfootImage("EBCStructureBuilding5.png");
    public BabyCamp(int iniside, int ix, int iy)
    {
        side = iniside;
        maxhitpoints = 300;
        armortype = 3;
        armorquantity = 1;
        hitpoints = 300;
        mapX = ix;
        mapY = iy;
        cost = 100;
        progressmax = 7500;
        id = 7;
    }
    public BabyCamp(int iniside, Player pl, int ix, int iy)
    {
        owner = pl;
        side = iniside;
        maxhitpoints = 300;
        armortype = 3;
        armorquantity = 1;
        hitpoints = 300;
        mapX = ix;
        mapY = iy;
        cost = 100;
        progressmax = 1000;
        id = 7;
    }
    /**
     * Act - do whatever the BabyCamp wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        if(!deployed)
        {
            if(building >= 750)
            {
                frame = 1;
                deployed = true;
                progress = 0;
                progressmax = 1;
                progressperc = 0;
                prodtype = 0;
                setImage(frame1);
            }
            else
            {
                if(building % 100 == 0 && getX() > -100 && getX() < 900 && building != 0)
                {
                    Greenfoot.playSound("handsaw2.wav");
                }
                progress = building;
                progressperc = progress/(double)progressmax;
                if(frame < 5)
                {
                    framechange ++;
                    if(framechange >= framechangerate)
                    {
                    frame ++;
                    switch(frame)
                    {
                        case 1: setImage(build1); break;
                        case 2: setImage(build2); break;
                        case 3: setImage(build3); break;
                        case 4: setImage(build4); break;
                        case 5: setImage(build5); break;
                    }
                    }
                }
            }
        }
        createHealthBar();
        createProgressBar();
        perish();
        if(deployed)
        {
            createUnit();
            produce();
        }
    }    
    public void createUnit()
    {
        if(progressperc == 1)
        {
            int dx = 0;
            switch(side)
            {
                case 1: dx = 50; break;
                case 2: dx = -50; break;
            }
            switch(prodtype)
            {
                case 10: getWorld().addObject(new PistoleerBaby(side, owner, realX()+dx, realY()), getX()+dx, getY()); getWorld().addObject(new PistoleerBaby(side, owner, realX()+dx+20, realY()), getX()+dx+20, getY()); getWorld().addObject(new PistoleerBaby(side, owner, realX()+dx-20, realY()), getX()+dx-20, getY()); break;
                case 11: getWorld().addObject(new GrenadierBaby(side, owner, realX()+dx, realY()), getX()+dx, getY()); break;
                case 13: getWorld().addObject(new SuicideBaby(side, owner, realX()+dx, realY()), getX()+dx, getY()); getWorld().addObject(new SuicideBaby(side, owner, realX()+dx+20, realY()), getX()+dx+20, getY()); getWorld().addObject(new SuicideBaby(side, owner, realX()+dx-20, realY()), getX()+dx-20, getY()); break;
                case 12: getWorld().addObject(new SuicideBaby(side, owner, realX()+dx, realY()), getX()+dx, getY()); break;
                case 14: getWorld().addObject(new FlamethrowerBaby(side, owner, realX()+dx, realY()), getX()+dx, getY()); break;
                case 18: getWorld().addObject(new WorkerBaby(side, owner, realX()+dx, realY()), getX()+dx, getY()); break;
            }
            clearProduction();
        }
    }
}
