import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * A marker unit that is used by the AI to order its troops to move to the position.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class BattleDummy  extends Units
{
    private int dur;
    public BattleDummy(int ix, int iy)
    {
        mapX = ix;
        mapY = iy;
        GreenfootImage image = new GreenfootImage(1,1);
        setImage(image);
        dur = 200;
    }
    public void addedToWorld(World w)
    {
        genmaches = (Battleground) w;
        wa = genmaches.array;
        Greenfoot.playSound("Attack.wav");
    }
    /**
     * Act - do whatever the BattleDummy wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        if(dur <= 0)
        {
            getWorld().removeObject(this);
        }
        else
        {
            dur --;
        }
    }   
    public int minimapImage()
    {
        int a = 0;
        if(dur >= 150)
        {
            a = 0;
        }
        else if(dur >= 100)
        {
            a = 1;
        }
        else if(dur >= 50)
        {
            a = 2;
        }
        else
        {
            a = 3;
        }
        return a;
    }
    public int minimapImageWidth()
    {
        int a = 0;
        if(dur >= 150)
        {
            a = 10;
        }
        else if(dur >= 100)
        {
            a = 8;
        }
        else if(dur >= 50)
        {
            a = 6;
        }
        else
        {
            a = 4;
        }
        return a;
    }
}
