import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class EBCRefinery here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class EBCRefinery  extends Structures
{
    private GreenfootImage frame1 = new GreenfootImage("Refinery1.png");
    private GreenfootImage frame2 = new GreenfootImage("Refinery2.png");
    private GreenfootImage frame3 = new GreenfootImage("Refinery3.png");
    private GreenfootImage frame4 = new GreenfootImage("Refinery4.png");
    private GreenfootImage frame5 = new GreenfootImage("Refinery5.png");
    private GreenfootImage frame6 = new GreenfootImage("Refinery6.png");
    private GreenfootImage frame7 = new GreenfootImage("Refinery7.png");
    private GreenfootImage frame8 = new GreenfootImage("Refinery8.png");
    private GreenfootImage build1 = new GreenfootImage("EBCStructureBuilding1.png");
    private GreenfootImage build2 = new GreenfootImage("EBCStructureBuilding2.png");
    private GreenfootImage build3 = new GreenfootImage("EBCStructureBuilding3.png");
    private GreenfootImage build4 = new GreenfootImage("EBCStructureBuilding4.png");
    private GreenfootImage build5 = new GreenfootImage("EBCStructureBuilding5.png");
    public EBCRefinery(int iniside, int ix, int iy)
    {
        side = iniside;
        maxhitpoints = 400;
        armortype = 4;
        armorquantity = 2;
        hitpoints = 400;
        mapX = ix;
        mapY = iy;
        cost = 175;
        progressmax = 1200;
        id = 6;
    }
    public EBCRefinery(int iniside, Player pl, int ix, int iy)
    {
        owner = pl;
        side = iniside;
        maxhitpoints = 400;
        armortype = 4;
        armorquantity = 2;
        hitpoints = 400;
        mapX = ix;
        mapY = iy;
        cost = 175;
        progressmax = 1200;
        id = 6;
    }
    /**
     * Act - do whatever the Refinery wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        if(!deployed)
        {
            if(building >= 1200)
            {
                frame = 1;
                deployed = true;
                progress = 0;
                progressmax = 1;
                progressperc = 0;
                prodtype = 0;
                setImage(frame1);
                getWorld().addObject(new WorkerBaby(side, owner, realX(), realY(), 7), getX(), getY());
                if(owner.getAI() != null)
                {
                    owner.getAI().advance();
                }
            }
            else
            {
                if(building % 100 == 0 && getX() > -100 && getX() < 900 && building != 0)
                {
                    Greenfoot.playSound("handsaw2.wav");
                }
                progress = building;
                progressperc = progress/(double)progressmax;
                if(frame < 5)
                {
                    framechange ++;
                    if(framechange >= framechangerate)
                    {
                    frame ++;
                    switch(frame)
                    {
                        case 1: setImage(build1); break;
                        case 2: setImage(build2); break;
                        case 3: setImage(build3); break;
                        case 4: setImage(build4); break;
                        case 5: setImage(build5); break;
                    }
                    }
                }
            }
        }
        createHealthBar();
        createProgressBar();
        if(deployed)
        {
        returnGood();
        produce();
        updateImage();
        perish();
        }
    }    
    public void updateImage()
    {
        if(deployed)
        {
        if(prodtype == 0)
        {
            if(frame != 1)
            {
                frame = 1;
                setImage(frame1);
            }
        }
        if(prodtype != 0)
        {
            framechange ++;
            if(framechange >= framechangerate)
            {
                frame ++;
                framechange = 0;
                switch(frame)
                {
                    case 1: setImage(frame1); break;
                    case 2: setImage(frame2); break;
                    case 3: setImage(frame3); break;
                    case 4: setImage(frame4); break;
                    case 5: setImage(frame5); break;
                    case 6: setImage(frame6); break;
                    case 7: setImage(frame7); break;
                    case 8: setImage(frame8); break;
                }
                if(frame > 7)
                {
                    frame = 1;
                }
            }
        }
        }
    }
    public void returnGood()
    {
        for(DestructibleObjects a : wa.Actors)
        {
            if(a instanceof WorkerBaby)
            {
                WorkerBaby b = (WorkerBaby) a;
                if((b.realX() >= realX() && b.realX() <= realX()+getImage().getWidth()) && (b.realY() >= realY() && b.realY() <= realY()+getImage().getHeight()))
                {
                    if(prodtype == 0 && b.bag > 0)
                    {
                        progressmax = b.bag * 2;
                        b.bag = 0;
                        b.needchange = true;
                        prodtype = 1;
                    }
                }
            }
        }
    }
    @Override public void produce()
    {
        if(prodtype == 1)
        {
            if(progress < progressmax)
            {
                progress ++;
                progressperc = (double) progress/progressmax;
                if(progress % 2 == 0)
                {
                    switch(prodtype)
                    {
                        case 1: owner.resources ++;
                    }
                }
            }
        }
        if(prodtype != 0 && progress >= progressmax)
        {
            progressperc = 0;
            prodtype = 0;
            progress = 0;
            progressmax = 1;
        }
        if(prodtype == 18)
        {
            if(progress < progressmax)
            {
                progress ++;
                progressperc = (double) progress/progressmax;
                if(progressperc >= 1)
                {
                    getWorld().addObject(new WorkerBaby(side, owner, realX(), realY(), 7), getX(), getY());
                }
            }
        }
    }   
}
