import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Class of Light tank (EBC)
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class EBCTank  extends Units
{
    private GreenfootImage frame1 = new GreenfootImage("LightTank.png");
    private GreenfootImage frame1l = new GreenfootImage("LightTank.png");
    private GreenfootImage frame1r = new GreenfootImage("LightTank.png");
    public EBCTank(int iniside, int ix, int iy)
    {
        side = iniside;
        maxhitpoints = 180;
        attackimage = 2;
        armortype = 2;
        armorquantity = 1;
        range = 150;
        hitpoints = 180;
        weapontype = 2;
        damage = 8;
        delay = 30;
        canhitground = true;
        canhitair = false;
        speed = 2;
        mapX = ix;
        mapY = iy;
        cost = 90;
    }
    public EBCTank(int iniside, Player pl, int ix, int iy)
    {
        side = iniside;
        maxhitpoints = 180;
        attackimage = 2;
        armortype = 2;
        armorquantity = 0;
        range = 120;
        hitpoints = 180;
        weapontype = 2;
        damage = 8;
        delay = 30;
        canhitground = true;
        canhitair = false;
        speed = 2;
        mapX = ix;
        mapY = iy;
        owner = pl;
        cost = 90;
    }
    public void addedToWorld(World w)
    {
        id = 17;
        genmaches = (Battleground) w;
        wa = genmaches.array;
        if(side == 1)
        {
            frame1.mirrorHorizontally();
        }
        frame1r.mirrorHorizontally();
    }
    /**
     * Act - do whatever the EBCTank wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        updateimage();
        attack();
        createHealthBar();
        perish();
        collisionReact();
        flipimage();
        alignImage();
    }    
    public void updateimage()
    {
        if(side == 1 && changealignment)
        {
            changealignment = false;
            getImage().mirrorHorizontally();
        }
        if(unitaction == 0)
        {
            if(enemyInSight())
            {
                unitaction = 3;
                frame = 1;
            }
            if(needchange)
            {
                if(side == 1)
                {
                    needchange = false;
                }
                else if(side == 2)
                {
                    needchange = false;
                }
            }
        }
        if(unitaction != 0)
        {
            framechange++;
            if(unitaction == 1)
            {
                if(framechange <= framechangerate)
                {
                    needchange = true;
                    framechange = 0;
                    frame ++;
                }
                if(realX() <= 0 || realX() >= wa.getWidth())
                {
                    unitaction = 0;
                }
                if(enemyInSight())
                {
                    unitaction = 3;
                    frame = 1;
                }
                else
                {
                if(frame > 1)
                {
                    frame = 1;
                }
                if(needchange)
                    {
                        needchange = false;
                    }
                }
            }
            else if(unitaction == 2 || unitaction == 4 || unitaction == 5)
            {
                if(framechange <= framechangerate)
                {
                    needchange = true;
                    framechange = 0;
                    frame ++;
                }
                if(realX() <= 0 || realX() >= wa.getWidth())
                {
                    unitaction = 0;
                }
                else
                {
                if(frame > 1)
                {
                    frame = 1;
                }
                if(needchange)
                    {
                        needchange = false;
                    }
                }
            }
            else if(unitaction == 3)
            {
                if(!enemyInSight())
                {
                    unitaction = prevact;
                    frame = 1;
                    needchange = true;
                }
                if(frame == 1)
                {
                    if(framechange >= reload - 3)
                    {
                        needchange = true;
                        framechange = 0;
                        frame ++;
                    }
                }
                    if(needchange)
                    {
                        needchange = false;
                    }
            }
        }
    }
    @Override public void flipimage()
    {
        if(dir == LEFT)
        {
            if(frame1 != frame1l)
            {
                frame1 = frame1l;
            }
        }
        if(dir == RIGHT)
        {
            if(frame1 != frame1r)
            {
                frame1 = frame1r;
            }
        }
    }
}
