import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.geom.*;

/**
 * Write a description of class Flame here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Flame  extends Weapons
{
    private FlamethrowerBaby fb;
    private int cooldown;
    private int frame = 1;
    private int framechange;
    private GreenfootImage frame1 = new GreenfootImage("Flame1.png");
    private GreenfootImage frame2 = new GreenfootImage("Flame2.png");
    private GreenfootImage frame3 = new GreenfootImage("Flame3.png");
    private GreenfootImage frame4 = new GreenfootImage("Flame4.png");
    public Flame(FlamethrowerBaby ini)
    {
        fb = ini;
    }
    public void addedToWorld(World w)
    {
        genmaches = (Battleground) w;
        wa = genmaches.array;
        if(fb.getSide() == 2)
        {
            frame1.mirrorHorizontally();
            frame2.mirrorHorizontally();
            frame3.mirrorHorizontally();
            frame4.mirrorHorizontally();
        }
    }
    /**
     * Act - do whatever the Flame wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        if(fb.firing)
        {
            switch(fb.getSide())
            {
                case 1: setLocation(fb.getX() + 50, fb.getY()); setRealLocation(fb.realX() + 50, fb.getY()); break;
                case 2: setLocation(fb.getX() - 50, fb.getY()); setRealLocation(fb.realX() - 50, fb.getY()); break;
            }
        }
        if(!fb.firing || fb.getWorld() == null)
        {
            getWorld().removeObject(this);
        }
        updateImage();
        framechange ++;
        if(cooldown > 0)
        {
            cooldown --;
        }
        if(cooldown < 0)
        {
            if(fb.getOwner().Upgrades[5] > 0)
            {
                cooldown = 6;
            }
            else
            {
                cooldown = 8;
            }
        }
        try
        {
            for(DestructibleObjects a : wa.Actors)
            {
                Point2D.Double argh = new Point2D.Double(a.realX(), a.realY());
                    if(collisionBox().contains(argh) && cooldown <= 0 && a.getGameHeight() < 5)
                    {
                        if(a instanceof Structures)
                        {
                            Structures b = (Structures) a;
                            b.giveAttacker(fb);
                        }
                        a.takedamage(2, 4);
                    }
                }
            }
                    catch(NullPointerException e)
        {
        }
    }    
    public void updateImage()
    {
        if(framechange >= framechangerate)
        {
            frame = Greenfoot.getRandomNumber(4) + 1;
            switch(frame)
            {
                case 1: setImage(frame1); break;
                case 2: setImage(frame2); break;
                case 3: setImage(frame3); break;
                case 4: setImage(frame4); break;
            }
            framechange = 0;
        }
    }
    public void setRealLocation(int x, int y)
    {
        mapX = x;
        mapY = y;
    }
}
