import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;

/**
 * Write a description of class FlamethrowerBaby here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class FlamethrowerBaby  extends Units
{
    private GreenfootImage frame1 = new GreenfootImage("FlamethrowerBaby.png");
    private GreenfootImage frame1l = new GreenfootImage("FlamethrowerBaby.png");
    private GreenfootImage frame1r = new GreenfootImage("FlamethrowerBaby.png");
    public boolean firing;
    public FlamethrowerBaby(int iniside, int ix, int iy)
    {
        side = iniside;
        maxhitpoints = 65;
        armortype = 1;
        armorquantity = 1;
        range = 60;
        hitpoints = 65;
        weapontype = 4;
        damage = 3;
        canhitground = true;
        speed = 2;
        mapX = ix;
        mapY = iy;
    }
    public FlamethrowerBaby(int iniside, Player pl, int ix, int iy)
    {
        side = iniside;
        maxhitpoints = 65;
        armortype = 1;
        armorquantity = 1;
        range = 60;
        hitpoints = 65;
        weapontype = 4;
        damage = 3;
        canhitground = true;
        speed = 2;
        mapX = ix;
        mapY = iy;
        owner = pl;
    }
    public void addedToWorld(World w)
    {
        id = 14;
        genmaches = (Battleground) w;
        wa = genmaches.array;
        if(side == 1)
        {
            frame1.mirrorHorizontally();
            setImage(frame1);
        }
        frame1r.mirrorHorizontally();
    }
    /**
     * Act - do whatever the FlamethrowerBaby wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        collisionReact();
        attackflame();
        createHealthBar();
        perish();
        updateimage();
        alignImage();
        flipimage();
    }    
    public void updateimage()
    {
        if(changealignment)
        {
            changealignment = false;
            frame1.mirrorHorizontally();
        }
        if(unitaction == 0)
        {
            if(enemyInSight())
            {
                prevact = 0;
                unitaction = 3;
                frame = 1;
            }
            if(needchange)
            {
                   setImage(frame1);
                   needchange = false;
            }
        }
        if(unitaction != 0)
        {
            if(unitaction == 1)
            {
                if(enemyInSight())
                {
                    prevact = 1;
                    unitaction = 3;
                    frame = 1;
                }
                if(needchange)
                {
                    setImage(frame1);
                    needchange = false;
                needchange = false;
                }
            }
            else if(unitaction == 2)
            {
                if(needchange)
                {
                    setImage(frame1);
                    needchange = false;
                }
            }
            else if(unitaction == 3)
            {        
                if(!enemyInSight())
                {
                    unitaction = prevact;
                    frame = 1;
                    needchange = true;
                }
                if(needchange)
                    {
                        needchange = false;
                        setImage(frame1);
                    }
            }
        }
    }
    public void attackflame()
    {
        if(firing && unitaction != 3)
        {
            firing = false;
        }
        try
        {
        for(Buff a : buffs)
        {
            if(a.dur <= 0)
            {
                buffs.remove(a);
            }
            else
            {
                a.apply();
                a.dur --;
            }
        }
        }
        catch(java.util.ConcurrentModificationException e)
        {
        }
        List pot = wa.Actors;
        for(int i = 0; i < pot.size(); i++)
        {
            DestructibleObjects a = (DestructibleObjects) pot.get(i);
            if(a.hitpoints > 0 && (a.side != 6) && (a.getX() > attackParameter().getX() && a.getX() <= attackParameter().getX()+attackParameter().getWidth()) && (a.realY() > attackParameter().getY() && a.realY() <= attackParameter().getY()+attackParameter().getHeight()))
            {
                if((side == 1 && a.side == 2) || (side == 2 && a.side == 1) && ((canhitair && a.flyer)||(canhitground && !a.flyer)))
                {
                target = a;
                }
            }
        }
        try
        {
            if(target.hitpoints > 0 && reload <= 0 && unitaction == 3 && (target.getX() > attackParameter().getX() && target.getX() <= attackParameter().getX()+attackParameter().getWidth()) && (target.realY() > attackParameter().getY() && target.realY() <= attackParameter().getY()+attackParameter().getHeight()) && !target.flyer)
            {
                if(!firing)
                {
                    getWorld().addObject(new Flame(this), getX(), getY());
                    firing = true;
                }
            }
            if(target.hitpoints <= 0 || target == null || (target.flyer && !canhitair) || (!target.flyer && !canhitground))
            {
                //removes the target IF target is elimnated.
                if(unitaction != 0)
                {
                    unitaction = 0;
                    needchange = true;
                }
                if(firing)
                {
                    firing = false;
                }
                target = null;
            }
        }
        catch(NullPointerException e)
        {
        }
    }
    @Override public void flipimage()
    {
        if(dir == LEFT)
        {
            if(frame1 != frame1l)
            {
                frame1 = frame1l;
            }
        }
        if(dir == RIGHT)
        {
            if(frame1 != frame1r)
            {
                frame1 = frame1r;
            }
        }
    }
}
