import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class GunTank here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class GunTank  extends Units
{
    GreenfootImage frame1 = new GreenfootImage("GunTank1.png");
    GreenfootImage frame2 = new GreenfootImage("GunTank2.png");
    GreenfootImage frame3 = new GreenfootImage("GunTank3.png");
    GreenfootImage frame1l = new GreenfootImage("GunTank1.png");
    GreenfootImage frame2l = new GreenfootImage("GunTank2.png");
    GreenfootImage frame3l = new GreenfootImage("GunTank3.png");
    GreenfootImage frame1r = new GreenfootImage("GunTank1.png");
    GreenfootImage frame2r = new GreenfootImage("GunTank2.png");
    GreenfootImage frame3r = new GreenfootImage("GunTank3.png");
    public GunTank(int iniside, int ix, int iy)
    {
        side = iniside;
        maxhitpoints = 200;
        attackimage = 1;
        armortype = 2;
        armorquantity = 0;
        range = 120;
        hitpoints = 200;
        weapontype = 1;
        damage = 4;
        delay = 8;
        canhitground = true;
        canhitair = true;
        speed = 3;
        mapX = ix;
        mapY = iy;
        cost = 75;
        id = 5;
        mechanical = true;
    }
    public GunTank(int iniside, Player pl, int ix, int iy)
    {
        side = iniside;
        maxhitpoints = 200;
        attackimage = 1;
        armortype = 2;
        armorquantity = 0;
        range = 120;
        hitpoints = 200;
        weapontype = 1;
        damage = 4;
        delay = 8;
        canhitground = true;
        canhitair = true;
        speed = 3;
        mapX = ix;
        mapY = iy;
        owner = pl;
        cost = 75;
        id = 5;
        mechanical = true;
    }
    public void addedToWorld(World w)
    {
        id = 5;
        genmaches = (Battleground) w;
        wa = genmaches.array;
        if(side == 1)
        {
            frame1.mirrorHorizontally();
            frame2.mirrorHorizontally();
            frame3.mirrorHorizontally();
        }
        frame1r.mirrorHorizontally();
        frame2r.mirrorHorizontally();
        frame3r.mirrorHorizontally();
    }
    /**
     * Act - do whatever the GunTank wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        updateImage();
        attack();
        createHealthBar();
        perish();
        collisionReact();
        flipimage();
        alignImage();
    }    
    public void updateImage()
    {
        if(unitaction == 0)
        {
            if(needchange)
            {
                if(side == 1)
                {
                    needchange = false;
                    setImage("GunTank1.png");
                    getImage().mirrorHorizontally();
                }
                else if(side == 2)
                {
                    needchange = false;
                    setImage("GunTank1.png");
                }
            }
        }
        if(unitaction != 0)
        {
            if(unitaction == 1)
            {
                if(realX() <= 0 || realX() >= wa.getWidth())
                {
                    unitaction = 0;
                }
                if(framechange <= framechangerate)
                {
                    needchange = true;
                    framechange = 0;
                    frame ++;
                }
                if(needchange)
                {
                    if(side == 1)
                    {
                        setImage("GunTank1.png");
                        getImage().mirrorHorizontally();
                    }
                    if(side == 2)
                    {
                        setImage("GunTank1.png");
                    }
                    needchange = false;
                }
            }
            else if(unitaction == 2)
            {
                if(realX() <= 0 || realX() >= wa.getWidth())
                {
                    unitaction = 0;
                }
                else
                {
                if(needchange)
                {
                    if(side == 1)
                    {
                        setImage("GunTank1.png");
                    }
                    if(side == 2)
                    {
                        setImage("GunTank1.png");
                        getImage().mirrorHorizontally();
                    }
                    needchange = false;
                }
                }
            }
            else if(unitaction == 3)
            {
                if(!enemyInSight())
                {
                    unitaction = prevact;
                    frame = 1;
                    needchange = true;
                }
                if(side == 1)
                {
                    if(needchange)
                    {
                        try
                        {
                        if(target.flyer)
                        {
                            setImage("GunTank3.png");
                            getImage().mirrorHorizontally();
                        }
                        else
                        {
                            setImage("GunTank2.png");
                            getImage().mirrorHorizontally();
                        }
                        needchange = false;
                        }
                        catch(NullPointerException e)
                        {
                        }
                    }
                }
                if(side == 2)
                {
                    if(needchange)
                    {
                        try
                        {
                        if(target.flyer)
                        {
                            setImage("GunTank3.png");
                        }
                        else
                        {
                            setImage("GunTank2.png");
                        }
                        needchange = false;
                        }
                        catch(NullPointerException e)
                        {
                        }
                    }
                }
                if(frame > 2)
                {
                }
            }
        }
    }
    @Override public void flipimage()
    {
        if(dir == LEFT)
        {
            if(frame1 != frame1l)
            {
                frame1 = frame1l;
            }
            if(frame2 != frame2l)
            {
                frame2 = frame2l;
            }
            if(frame3 != frame3l)
            {
                frame3 = frame3l;
            }
        }
        if(dir == RIGHT)
        {
            if(frame1 != frame1r)
            {
                frame1 = frame1r;
            }
            if(frame2 != frame2r)
            {
                frame2 = frame2r;
            }
            if(frame3 != frame3r)
            {
                frame3 = frame3r;
            }
        }
    }
    @Override public void playSound()
    {
        Greenfoot.playSound("SMG.wav");
    }
}
