import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.ArrayList;

/**
 * Write a description of class Harvester here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Harvester  extends Units
{
    GreenfootImage frame1 = new GreenfootImage("Harvester.png");
    GreenfootImage frame2 = new GreenfootImage("Harvester2.PNG");
    GreenfootImage frame1l = new GreenfootImage("Harvester.png");
    GreenfootImage frame2l = new GreenfootImage("Harvester2.PNG");
    GreenfootImage frame1r = new GreenfootImage("Harvester.png");
    GreenfootImage frame2r = new GreenfootImage("Harvester2.PNG");
    public int maxbag = 75;
    public int bag;
    private OreMine targ;
    private PosterityRefinery returnsite;
    private ArrayList<OreMine> nearest = new ArrayList<OreMine>();
    private ArrayList<PosterityRefinery> nearestreturn = new ArrayList<PosterityRefinery>();
    public Harvester(int iniside, int ix, int iy)
    {
        side = iniside;
        maxhitpoints = 60;
        attackimage = 1;
        armortype = 1;
        armorquantity = 0;
        range = 30;
        hitpoints = 60;
        weapontype = 7;
        damage = 2;
        delay = 15;
        canhitground = true;
        speed = 2;
        mapX = ix;
        mapY = iy;
        id = 27;
    }
    public Harvester(int iniside, Player pl, int ix, int iy)
    {
        owner = pl;
        side = iniside;
        maxhitpoints = 60;
        attackimage = 1;
        armortype = 1;
        armorquantity = 0;
        range = 30;
        hitpoints = 60;
        weapontype = 7;
        damage = 2;
        delay = 15;
        canhitground = true;
        speed = 2;
        mapX = ix;
        mapY = iy;
        id = 27;
    }
    public Harvester(int iniside, Player pl, int ix, int iy, int cfg)
    {
        bag = cfg;
        owner = pl;
        side = iniside;
        maxhitpoints = 60;
        attackimage = 1;
        armortype = 1;
        armorquantity = 0;
        range = 30;
        hitpoints = 60;
        weapontype = 7;
        damage = 2;
        delay = 15;
        canhitground = true;
        speed = 2;
        mapX = ix;
        mapY = iy;
        id = 27;
    }
    public void addedToWorld(World w)
    {
        id = 27;
        genmaches = (Battleground) w;
        wa = genmaches.array;
        frame1l.mirrorHorizontally();
        frame2l.mirrorHorizontally();
    }
    /**
     * Act - do whatever the Harvester wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        updateImage();
        createHealthBar();
        perish();
        getMine();
        flipimage();
        alignImage();
    }    
    public void updateImage()
    {
        framechange ++;
        if(framechange >= framechangerate)
        {
            framechange = 0;
            frame++;
            needchange = true;
        }
        if(frame > 4)
        {
            frame = 1;
        }
        if(needchange)
        {
            if(bag == 0)
            {
                setImage(frame1);
            }
            else
            {
                setImage(frame2);
            }
            needchange = false;
        }
    }
    /**
     * gets the nearest mine and sets the harvester working.
     */
    public void getMine()
    {
        for(DestructibleObjects n : wa.Actors)
        {
            if(n instanceof PosterityRefinery)
            {
                PosterityRefinery m = (PosterityRefinery) n;
                try
                {
                    if((Math.sqrt(Math.pow(m.realX() - realX(), 2) + Math.pow(m.realY() - realY(), 2)) < Math.sqrt(Math.pow(returnsite.realX() - realX(), 2) + Math.pow(returnsite.realY() - realY(), 2))) || returnsite == null)
                    {
                        returnsite = m;
                    }
                }
                catch(NullPointerException e)
                {
                    returnsite = m;
                }
            }
        }
        if(bag == 0)
        {
        for(OreMine a : wa.ResourceSource)
        {
            try
            {
                if((Math.sqrt(Math.pow(a.realX() - realX(), 2) + Math.pow(a.realY() - realY(), 2)) < Math.sqrt(Math.pow(targ.realX() - realX(), 2) + Math.pow(targ.realY() - realY(), 2))) || targ == null)
                {
                    nearest.add(a);
                    if(nearest.size() == 1)
                    {
                        targ = a;
                    }
                    else
                        {
                            int min = 0;
                            int slot = 0;
                            for(int i = 0; i < nearest.size(); i++)
                            {
                                OreMine p = nearest.get(i);
                                int distance = (int)(Math.sqrt(Math.pow(p.realX() - returnsite.realX(), 2) + Math.pow(p.realY() - returnsite.realY(), 2)));
                                if(min == 0 || distance < min)
                                {
                                    slot = i;
                                    min = distance;
                                }
                            }
                            targ = nearest.get(slot);
                        }
                }
            }
            catch(NullPointerException e)
            {
                targ = a;
            }
        }
        }
        if(bag == 0)
        {
        if(targ != null)
        {
            if((targ.realX() > realX() && targ.getX() <= realX()+getImage().getWidth()) && (targ.realY() > realY() && targ.realY() <= realY()+getImage().getHeight()) && bag < maxbag)
            {
                targ.occupant = this;
                targ.needchange = true;
            }
            try
            {
                if(targ.realX() > realX() && targ.realY() >  realY())
                {
                mapX += 1;
                mapY += 1;
                dir = RIGHT;
                }
                else if(targ.realX() > realX() && targ.realY() <  realY())
                {
                mapX += 1;
                mapY -= 1;
                dir = RIGHT;
                }
                else if(targ.realX() < realX() && targ.realY() >  realY())
                {
                mapX -= 1;
                mapY += 1;
                dir = LEFT;
                }
                else if(targ.realX() < realX() && targ.realY() <  realY())
                {
                mapX -= 1;
                mapY -= 1;
                dir = LEFT;
                }
                else if(targ.realX() > realX())
                {
                    mapX += 2;
                    dir = RIGHT;
                }
                else if(targ.realX() < realX())
                {
                    mapX -= 2;
                    dir = LEFT;
                }
                else if(targ.realY() > realY())
                {
                    mapY += 2;
                }
                else if(targ.realY() < realY())
                {
                    mapY -= 2;
                }
            }
            catch(NullPointerException e)
            {
            }
        }
        }
        if(bag >= maxbag)
        {
            if(bag > maxbag)
            {
                bag = maxbag;
            }
            try
            {
                if(returnsite.realX() > realX() && returnsite.realY() >  realY())
                {
                mapX += 1;
                mapY += 1;
                dir = RIGHT;
                }
                else if(returnsite.realX() > realX() && returnsite.realY() <  realY())
                {
                mapX += 1;
                mapY -= 1;
                dir = RIGHT;
                }
                else if(returnsite.realX() < realX() && returnsite.realY() >  realY())
                {
                mapX -= 1;
                mapY += 1;
                dir = LEFT;
                }
                else if(returnsite.realX() < realX() && returnsite.realY() <  realY())
                {
                mapX -= 1;
                mapY -= 1;
                dir = LEFT;
                }
                else if(returnsite.realX() > realX())
                {
                    mapX += 2;
                    dir = RIGHT;
                }
                else if(returnsite.realX() < realX())
                {
                    mapX -= 2;
                    dir = LEFT;
                }
                else if(returnsite.realY() > realY())
                {
                    mapY += 2;
                }
                else if(returnsite.realY() < realY())
                {
                    mapY -= 2;
                }
            }
            catch(NullPointerException e)
            {
            }
        }
        try
        {   
            if(!((targ.realX() > realX() && targ.realX() <= realX()+getImage().getWidth()) && (targ.realY() > realY() && targ.realY() <= realY()+getImage().getHeight())))
            {
                targ.clear();
            }
        }
            catch(NullPointerException e)
            {
            }
    }
    @Override public void flipimage()
    {
        if(dir == LEFT)
        {
            if(frame1 != frame1l)
            {
                frame1 = frame1l;
            }
            if(frame2 != frame2l)
            {
                frame2 = frame2l;
            }
        }
        if(dir == RIGHT)
        {
            if(frame1 != frame1r)
            {
                frame1 = frame1r;
            }
            if(frame2 != frame2r)
            {
                frame2 = frame2r;
            }
        }
    }
}
