import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.geom.*;

/**
 * Write a description of class InGameSprite here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class IngameSprite  extends Actor
{
    protected int x;
    protected int y;
    protected int mapX;
    protected int mapY;
    protected Battleground genmaches;
    protected WorldArray wa;
    protected static final int framechangerate = 6;
    protected boolean needchange;
    /**
     * Height. For air units and some particles.
     */
    protected int height;
    /**
     * Act - do whatever the InGameSprite wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
    }    
    public void addedToWorld(World w)
    {
        genmaches = (Battleground) w;
        wa = genmaches.array;
    }
    @Override public int getX()
    {
        return x;
    }
    @Override public int getY()
    {
        return y;
    }
    /**
     * The absolute x-coordinates of the unit.
     */
    public int realX()
    {
        return mapX;
    }
    /**
     * The absolute y-coordinates of the unit.
     */
    public int realY()
    {
        return mapY;
    }
    @Override public void setLocation(int x, int y)
    {
        this.x = x;
        this.y = y;
        super.setLocation(x, y-height);
    }
    public Rectangle2D.Double collisionBox()
    {
        return new Rectangle2D.Double(realX()-getImage().getWidth()/2, realY()-getImage().getHeight()/2, getImage().getWidth(), getImage().getHeight());
    }
    /**
     * Purely for reducing lag so that image only changes if the object is in the screen.
     */
    @Override public void setImage(java.lang.String filename)
    {
        if((getX() + getImage().getWidth() >= 0) || (getX() - getImage().getWidth() <= 800))
        {
            super.setImage(filename);
        }
    }
    /**
     * returns the z-coordinate (The actual height) of the unit.
     */
    public int getGameHeight()
    {
        return height;
    }
}
