import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class LightBomber here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class LightBomber  extends Flyer
{
    public int bombs = 2;
    public Helipad returnsite;
    private GreenfootImage frame1 = new GreenfootImage("LightBomber.png");
    private GreenfootImage frame1l = new GreenfootImage("LightBomber.png");
    private GreenfootImage frame1r = new GreenfootImage("LightBomber.png");
    public DestructibleObjects enemy;
    public LightBomber(int iniside, int ix, int iy)
    {
        side = iniside;
        maxhitpoints = 150;
        attackimage = 15;
        armortype = 2;
        armorquantity = 0;
        range = 20;
        hitpoints = 150;
        weapontype = 1;
        damage = 9;
        delay = 20;
        canhitground = true;
        flyer = true;
        speed = 2;
        mapX = ix;
        mapY = iy;
        cost = 60;
    }
    public LightBomber(int iniside, Player pl, int ix, int iy)
    {
        owner = pl;
        side = iniside;
        maxhitpoints = 150;
        attackimage = 15;
        armortype = 2;
        armorquantity = 0;
        range = 20;
        hitpoints = 150;
        weapontype = 1;
        damage = 3;
        delay = 20;
        canhitground = true;
        flyer = true;
        speed = 2;
        mapX = ix;
        mapY = iy;
    }
    public LightBomber(int iniside, Player pl, int ix, int iy, Helipad home)
    {
        owner = pl;
        side = iniside;
        maxhitpoints = 350;
        attackimage = 15;
        armortype = 3;
        armorquantity = 2;
        range = 20;
        hitpoints = 350;
        weapontype = 1;
        damage = 3;
        delay = 20;
        canhitground = true;
        flyer = true;
        speed = 2;
        mapX = ix;
        mapY = iy;
        returnsite = home;
    }
    public void addedToWorld(World w)
    {
        genmaches = (Battleground) w;
        wa = genmaches.array;
        if(side == 1)
        {
            frame1.mirrorHorizontally();
            setImage(frame1);
        }
        frame1r.mirrorHorizontally();
        needchange = true;
        id = 24;
    }
    /**
     * Act - do whatever the LightBomber wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        updateimage();
        attack();
        createHealthBar();
        perish();
        collisionReact();
        alignImage();
    }    
    public void updateimage()
    {
        if(height <= 80 && (unitaction != 0 && unitaction != 6))
        {
            height ++;
        }
        if(unitaction == 0)
        {
        }
        if(unitaction != 0 || unitaction != 6)
        {
            if(bombs <= 0)
            {
                unitaction = 6;
            }
            if(unitaction == 1)
            {
                if(enemyInSight())
                {
                    unitaction = 3;
                }
                }
            }
            else if(unitaction == 2)
            {
                if(needchange)
                {
                    needchange = false;
                }
            }
            else if(unitaction == 3)
            {           
                if(!enemyInSight())
                {
                    unitaction = 1;
                    needchange = true;
                }
                if(reload == 1 && enemyInSight())
                {
                    //Replace with bomb sound
                    //Greenfoot.playSound("Pistol.wav");
                }
                if(needchange)
                {
                    needchange = false;
                }
            }
        if(unitaction == 6)
        {
            try
            {
                if((int)(Math.sqrt(Math.pow(realX() - returnsite.realX(), 2) + Math.pow(realY() - returnsite.realY(), 2))) < 5 && height <= 0)
                {
                    unitaction = 0;
                }
                if(Math.abs(returnsite.realX() - realX()) < 100)
                {
                    if(height > 0)
                    {
                        height --;
                    }
                    if(height == 0 && side == 1)
                    {
                        if(dir == 2)
                        {
                            dir = 1;
                        }
                    }
                }
                if(returnsite.realX() > realX() && returnsite.realY() >  realY())
                {
                mapX += 1;
                mapY += 1;
                dir = 1;
                }
                else if(returnsite.realX() > realX() && returnsite.realY() <  realY())
                {
                mapX += 1;
                mapY -= 1;
                dir = 1;
                }
                else if(returnsite.realX() < realX() && returnsite.realY() >  realY())
                {
                mapX -= 1;
                mapY += 1;
                dir = 2;
                }
                else if(returnsite.realX() < realX() && returnsite.realY() <  realY())
                {
                mapX -= 1;
                mapY -= 1;
                dir = 2;
                }
                else if(returnsite.realX() > realX())
                {
                    mapX += 2;
                    dir = 1;
                }
                else if(returnsite.realX() < realX())
                {
                    mapX -= 2;
                    dir = 2;
                }
                else if(returnsite.realY() > realY())
                {
                    mapY += 2;
                }
                else if(returnsite.realY() < realY())
                {
                    mapY -= 2;
                }
            }
            catch(NullPointerException e)
            {
            }
        }
        if(unitaction == 7)
        {
            try
            {
                if(!(enemy.getX() > attackParameter().getX() && enemy.getX() <= attackParameter().getX()+attackParameter().getWidth()) || !(enemy.realY() > attackParameter().getY() && enemy.realY() <= attackParameter().getY()+attackParameter().getHeight()))
                {
                                    if(enemy.realX() > realX() && enemy.realY() >  realY())
                {
                mapX += 1;
                mapY += 1;
                dir = 1;
                }
                else if(enemy.realX() > realX() && enemy.realY() <  realY())
                {
                mapX += 1;
                mapY -= 1;
                dir = 1;
                }
                else if(enemy.realX() < realX() && enemy.realY() >  realY())
                {
                mapX -= 1;
                mapY += 1;
                dir = 2;
                }
                else if(enemy.realX() < realX() && enemy.realY() <  realY())
                {
                mapX -= 1;
                mapY -= 1;
                dir = 2;
                }
                else if(enemy.realX() > realX())
                {
                    mapX += 2;
                    dir = 1;
                }
                else if(enemy.realX() < realX())
                {
                    mapX -= 2;
                    dir = 2;
                }
                else if(enemy.realY() > realY())
                {
                    mapY += 2;
                }
                else if(enemy.realY() < realY())
                {
                    mapY -= 2;
                }
                if(enemy.hitpoints <= 0 && returnsite.auto)
                {
                    for(DestructibleObjects a : wa.Actors)
                    {
                        if(a.getSide() != getSide() && a.getSide() != 6)
                        {
                            enemy = a;
                        }
                    }
                }
            }
        }
        catch(NullPointerException e)
        {
            setBehavior(6);
        }
        }
    } 
    @Override public void flipimage()
    {
        if(dir == LEFT)
        {
            if(frame1 != frame1l)
            {
                frame1 = frame1l;
            }
        }
        if(dir == RIGHT)
        {
            if(frame1 != frame1r)
            {
                frame1 = frame1r;
            }
        }
    }
}
