import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class MaterialistHub here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class MaterialistHub  extends Structures
{
    private GreenfootImage frame1 = new GreenfootImage("MaterialistHub.PNG");
    private GreenfootImage build1 = new GreenfootImage("EBCStructureBuilding1.png");
    private GreenfootImage build2 = new GreenfootImage("EBCStructureBuilding2.png");
    private GreenfootImage build3 = new GreenfootImage("EBCStructureBuilding3.png");
    private GreenfootImage build4 = new GreenfootImage("EBCStructureBuilding4.png");
    private GreenfootImage build5 = new GreenfootImage("EBCStructureBuilding5.png");
    public MaterialistHub(int iniside, int ix, int iy)
    {
        side = iniside;
        maxhitpoints = 300;
        armortype = 4;
        armorquantity = 1;
        hitpoints = 300;
        mapX = ix;
        mapY = iy;
        cost = 125;
        progressmax = 1500;
        id = 9;
    }
    public MaterialistHub(int iniside, Player pl, int ix, int iy)
    {
        owner = pl;
        side = iniside;
        maxhitpoints = 300;
        armortype = 4;
        armorquantity = 1;
        hitpoints = 300;
        mapX = ix;
        mapY = iy;
        cost = 125;
        progressmax = 1500;
        id = 9;
    }
    public MaterialistHub(int iniside, Player pl, int ix, int iy, boolean te)
    {
        owner = pl;
        side = iniside;
        maxhitpoints = 300;
        armortype = 4;
        armorquantity = 1;
        hitpoints = 300;
        mapX = ix;
        mapY = iy;
        cost = 125;
        id = 9;
        deployed = te;
    }
    public void addedToWorld(World w)
    {
        buttoncooldown.add(0);
        genmaches = (Battleground) w;
        wa = genmaches.array;
    }
    /**
     * Act - do whatever the MaterialistHub wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        if(!deployed)
        {
            if(building >= 1500)
            {
                frame = 1;
                deployed = true;
                progress = 0;
                progressmax = 1;
                progressperc = 0;
                prodtype = 0;
                setImage(frame1);
            }
            else
            {
                if(building % 100 == 0 && getX() > -100 && getX() < 900 && building != 0)
                {
                    Greenfoot.playSound("handsaw2.wav");
                }
                progress = building;
                progressperc = progress/(double)progressmax;
                if(frame < 5)
                {
                    framechange ++;
                    if(framechange >= framechangerate)
                    {
                    frame ++;
                    switch(frame)
                    {
                        case 1: setImage(build1); break;
                        case 2: setImage(build2); break;
                        case 3: setImage(build3); break;
                        case 4: setImage(build4); break;
                        case 5: setImage(build5); break;
                    }
                    }
                }
            }
        }
        perish();
        createHealthBar();
        prepareStrike();
        produce();
        createProgressBar();
        provup();
    }    
    public void provup()
    {
        if(progress >= progressmax)
        {
            switch(prodtype)
            {
                case 10: getOwner().Upgrades[6] = 1; break;
                case 11: getOwner().Upgrades[7] = 1; break;
            }
            clearProduction();
        }
    }
}
