import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Nanoassembly Mainframe: the tech structure of the Posterity.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class NanoassemblyMainframe  extends Structures
{
    public NanoassemblyMainframe(int iniside, int ix, int iy)
    {
        side = iniside;
        maxhitpoints = 600;
        armortype = 4;
        armorquantity = 3;
        hitpoints = 600;
        mapX = ix;
        mapY = iy;
        cost = 250;
        id = 15;
    }
    public NanoassemblyMainframe(int iniside, Player ini, int ix, int iy)
    {
        owner = ini;
        side = iniside;
        maxhitpoints = 600;
        armortype = 4;
        armorquantity = 3;
        hitpoints = 600;
        mapX = ix;
        mapY = iy;
        cost = 250;
        id = 15;
    }
    public void addedToWorld(World w)
    {
        id = 15;
        deployed = true;
        buttoncooldown.add(0);
        buttoncooldown.add(0);
        genmaches = (Battleground) w;
        wa = genmaches.array;
        if(side == 2)
        {
            getImage().mirrorHorizontally();
        }
    }
    /**
     * Act - do whatever the NanoassemblyMainframe wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        createHealthBar();
        createProgressBar();
        produce();
        perish();
        prepareStrike();
        provup();
    }   
    public void provup()
    {
        if(progress >= progressmax)
        {
            switch(prodtype)
            {
                case 10: getOwner().Upgrades[8] = 1; break;
            }
            clearProduction();
        }
    }
}
