import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class NapalmBomber here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class NapalmBomber  extends Flyer
{
    public int bombs = 8;
    public Airfield returnsite;
    private GreenfootImage frame = new GreenfootImage("bomber.png");
    private boolean flip;
    private int prevdir;
    public DestructibleObjects enemy;
    public NapalmBomber(int iniside, int ix, int iy)
    {
        side = iniside;
        maxhitpoints = 350;
        attackimage = 15;
        armortype = 3;
        armorquantity = 2;
        range = 30;
        hitpoints = 350;
        weapontype = 1;
        damage = 9;
        delay = 20;
        canhitground = true;
        flyer = true;
        speed = 2;
        mapX = ix;
        mapY = iy;
        cost = 60;
    }
    public NapalmBomber(int iniside, Player pl, int ix, int iy)
    {
        owner = pl;
        side = iniside;
        maxhitpoints = 350;
        attackimage = 15;
        armortype = 3;
        armorquantity = 2;
        range = 30;
        hitpoints = 350;
        weapontype = 1;
        damage = 3;
        delay = 20;
        canhitground = true;
        flyer = true;
        speed = 2;
        mapX = ix;
        mapY = iy;
    }
    public NapalmBomber(int iniside, Player pl, int ix, int iy, Airfield home)
    {
        owner = pl;
        side = iniside;
        maxhitpoints = 350;
        attackimage = 15;
        armortype = 3;
        armorquantity = 2;
        range = 20;
        hitpoints = 350;
        weapontype = 1;
        damage = 3;
        delay = 20;
        canhitground = true;
        flyer = true;
        speed = 2;
        mapX = ix;
        mapY = iy;
        returnsite = home;
    }
    public void addedToWorld(World w)
    {
        genmaches = (Battleground) w;
        wa = genmaches.array;
        if(side == 1)
        {
            frame.mirrorHorizontally();
            setImage(frame);
        }
        needchange = true;
        id = 8;
    }
    /**
     * Act - do whatever the NapalmBomber wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        updateimage();
        attack();
        createHealthBar();
        perish();
    }    
    public void updateimage()
    {
        if(height <= 80 && (unitaction != 0 && unitaction != 6))
        {
            height ++;
        }
        if(unitaction == 0)
        {
        }
        if(unitaction != 0 || unitaction != 6)
        {
            if(bombs <= 0)
            {
                unitaction = 6;
            }
            if(unitaction == 1)
            {
                checkchange();
                if(enemyInSight())
                {
                    unitaction = 3;
                }
                }
            }
            else if(unitaction == 2)
            {
                checkchange();
                if(needchange)
                {
                    needchange = false;
                }
            }
            else if(unitaction == 3)
            {           
                checkchange();
                if(!enemyInSight())
                {
                    unitaction = 1;
                    needchange = true;
                }
                if(reload == 1 && enemyInSight())
                {
                    //Replace with bomb sound
                    //Greenfoot.playSound("Pistol.wav");
                }
                if(needchange)
                {
                    needchange = false;
                }
            }
        if(unitaction == 6)
        {
            try
            {
                if((int)(Math.sqrt(Math.pow(realX() - returnsite.realX(), 2) + Math.pow(realY() - returnsite.realY(), 2))) < 5 && height <= 0)
                {
                    unitaction = 0;
                }
                if(Math.abs(returnsite.realX() - realX()) < 100)
                {
                    if(height > 0)
                    {
                        height --;
                    }
                    if(height == 0 && side == 1)
                    {
                        if(dir == 2)
                        {
                            dir = 1;
                            checkchange();
                        }
                    }
                }
                checkchange();
                if(returnsite.realX() > realX() && returnsite.realY() >  realY())
                {
                mapX += 1;
                mapY += 1;
                dir = 1;
                }
                else if(returnsite.realX() > realX() && returnsite.realY() <  realY())
                {
                mapX += 1;
                mapY -= 1;
                dir = 1;
                }
                else if(returnsite.realX() < realX() && returnsite.realY() >  realY())
                {
                mapX -= 1;
                mapY += 1;
                dir = 2;
                }
                else if(returnsite.realX() < realX() && returnsite.realY() <  realY())
                {
                mapX -= 1;
                mapY -= 1;
                dir = 2;
                }
                else if(returnsite.realX() > realX())
                {
                    mapX += 2;
                    dir = 1;
                }
                else if(returnsite.realX() < realX())
                {
                    mapX -= 2;
                    dir = 2;
                }
                else if(returnsite.realY() > realY())
                {
                    mapY += 2;
                }
                else if(returnsite.realY() < realY())
                {
                    mapY -= 2;
                }
            }
            catch(NullPointerException e)
            {
            }
        }
        if(unitaction == 7)
        {
            checkchange();
            try
            {
                if(!(enemy.getX() > attackParameter().getX() && enemy.getX() <= attackParameter().getX()+attackParameter().getWidth()) || !(enemy.realY() > attackParameter().getY() && enemy.realY() <= attackParameter().getY()+attackParameter().getHeight()))
                {
                                    if(enemy.realX() > realX() && enemy.realY() >  realY())
                {
                mapX += 1;
                mapY += 1;
                dir = 1;
                }
                else if(enemy.realX() > realX() && enemy.realY() <  realY())
                {
                mapX += 1;
                mapY -= 1;
                dir = 1;
                }
                else if(enemy.realX() < realX() && enemy.realY() >  realY())
                {
                mapX -= 1;
                mapY += 1;
                dir = 2;
                }
                else if(enemy.realX() < realX() && enemy.realY() <  realY())
                {
                mapX -= 1;
                mapY -= 1;
                dir = 2;
                }
                else if(enemy.realX() > realX())
                {
                    mapX += 2;
                    dir = 1;
                }
                else if(enemy.realX() < realX())
                {
                    mapX -= 2;
                    dir = 2;
                }
                else if(enemy.realY() > realY())
                {
                    mapY += 2;
                }
                else if(enemy.realY() < realY())
                {
                    mapY -= 2;
                }
                if(enemy.hitpoints <= 0 && returnsite.auto)
                {
                    for(DestructibleObjects a : wa.Actors)
                    {
                        if(a.getSide() != getSide() && a.getSide() != 6)
                        {
                            enemy = a;
                        }
                    }
                }
            }
        }
        catch(NullPointerException e)
        {
            setBehavior(6);
        }
        }
    }   
    public void checkchange()
    {
        if(!flip && dir != prevdir)
        {
            flip = true;
            prevdir = dir;
        }
        if(flip)
        {
            flip = false;
            if(dir == 1)
            {
                setImage("bomber.png");
                getImage().mirrorHorizontally();
            }
            if(dir == 2)
            {
                setImage("bomber.png");
            }
        }
        else
        {
        }
    }
}
