import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class OfficerSphere here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class OfficerSphere  extends Units
{
    public int artillery = 1000;
    public int medkit;
    private int cast;
    private int maxcast = 1;
    private int casttype;
    protected ProgressBar pb;
    GreenfootImage frame1 = new GreenfootImage("OfficerSphere1.png");
    GreenfootImage frame2 = new GreenfootImage("OfficerSphere2.png");
    GreenfootImage frame3 = new GreenfootImage("OfficerSphere3.png");
    GreenfootImage frame4 = new GreenfootImage("OfficerSphere4.png");
    GreenfootImage frame5 = new GreenfootImage("OfficerSphere5.png");
    GreenfootImage frameReq = new GreenfootImage("OfficerSphereRequest.png");
    GreenfootImage frameMed = new GreenfootImage("OfficerSphereMedKit.png");
    GreenfootImage frame1l = new GreenfootImage("OfficerSphere1.png");
    GreenfootImage frame2l = new GreenfootImage("OfficerSphere2.png");
    GreenfootImage frame3l = new GreenfootImage("OfficerSphere3.png");
    GreenfootImage frame4l = new GreenfootImage("OfficerSphere4.png");
    GreenfootImage frame5l = new GreenfootImage("OfficerSphere5.png");
    GreenfootImage frameReql = new GreenfootImage("OfficerSphereRequest.png");
    GreenfootImage frameMedl = new GreenfootImage("OfficerSphereMedKit.png");
    GreenfootImage frame1r = new GreenfootImage("OfficerSphere1.png");
    GreenfootImage frame2r = new GreenfootImage("OfficerSphere2.png");
    GreenfootImage frame3r = new GreenfootImage("OfficerSphere3.png");
    GreenfootImage frame4r = new GreenfootImage("OfficerSphere4.png");
    GreenfootImage frame5r = new GreenfootImage("OfficerSphere5.png");
    GreenfootImage frameReqr = new GreenfootImage("OfficerSphereRequest.png");
    GreenfootImage frameMedr = new GreenfootImage("OfficerSphereMedKit.png");
    private int reg;
    public int grenade;
    public OfficerSphere(int iniside, int ix, int iy)
    {
        side = iniside;
        maxhitpoints = 180;
        attackimage = 1;
        armortype = 1;
        armorquantity = 1;
        range = 160;
        hitpoints = 180;
        weapontype = 1;
        damage = 6;
        delay = 15;
        canhitground = true;
        speed = 2;
        mapX = ix;
        mapY = iy;
        cost = 180;
    }
    public OfficerSphere(int iniside, Player ini, int ix, int iy)
    {
        owner = ini;
        side = iniside;
        maxhitpoints = 180;
        attackimage = 1;
        armortype = 1;
        armorquantity = 1;
        range = 160;
        hitpoints = 180;
        weapontype = 1;
        damage = 6;
        delay = 15;
        canhitground = true;
        speed = 2;
        mapX = ix;
        mapY = iy;
        cost = 180;
    }
    public void addedToWorld(World w)
    {
        id = 33;
        genmaches = (Battleground) w;
        wa = genmaches.array;
        if(side == 1)
        {
            frame1.mirrorHorizontally();
            frame2.mirrorHorizontally();
            frame3.mirrorHorizontally();
            frame4.mirrorHorizontally();
            frame5.mirrorHorizontally();
            frameMed.mirrorHorizontally();
            frameReq.mirrorHorizontally();
            setImage(frame1);
        }
        frame1r.mirrorHorizontally();
        frame2r.mirrorHorizontally();
        frame3r.mirrorHorizontally();
        frame4r.mirrorHorizontally();
        frame5r.mirrorHorizontally();
        frameMedr.mirrorHorizontally();
        frameReqr.mirrorHorizontally();
    }
    /**
     * Act - do whatever the OfficerSphere wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        updateimage();
        attack();
        createHealthBar();
        createProgressBar();
        perish();
        collisionReact();
        alignImage();
        flipimage();
        if(grenade > 0)
        {
            grenade --;
        }
        if(medkit > 0)
        {
            medkit --;
        }
        if(artillery > 0)
        {
            artillery --;
        }
    }    
    public void updateimage()
    {
        if(getOwner().Upgrades[1] > 0)
        {
            reg++;
            if(reg >= 40)
            {
                reg = 0;
                if(hitpoints < maxhitpoints)
                {
                    if((double)(maxhitpoints - hitpoints) < 1)
                    {
                        hitpoints = maxhitpoints;
                    }
                    else
                    {
                    hitpoints ++;
                    }
                }
            }
        }
        if(unitaction == 0)
        {
            if(needchange)
            {
                needchange = false;
                setImage(frame1);
            }
            if(casttype != 0)
            {
                switch(casttype)
                {
                    case 1: setBehavior(9); break;
                    case 2: setBehavior(10); break;
                }
            }
        }
        if(unitaction != 0)
        {
            framechange++;
            if(unitaction == 1)
            {
                if(framechange >= 3)
                {
                    needchange = true;
                    framechange = 0;
                    frame ++;
                }
                if(realX() <= 0 || realX() >= wa.getWidth())
                {
                    unitaction = 0;
                }
                if(frame > 3)
                {
                    frame = 1;
                }
                if(needchange)
                    {
                        needchange = false;
                        switch(frame)
                        {
                            case 1: setImage(frame1); break;
                            case 2: setImage(frame2); break;
                            case 3: setImage(frame3); break;
                        }
                    }
            }
            else if(unitaction == 2 || unitaction == 4 || unitaction == 5 || unitaction == 8)
            {
                if(framechange >= 3)
                {
                    needchange = true;
                    framechange = 0;
                    frame ++;
                }
                if(realX() <= 0 || realX() >= wa.getWidth())
                {
                    unitaction = 0;
                }
                else
                {
                if(frame > 3)
                {
                    frame = 1;
                }
                if(needchange)
                    {
                        needchange = false;
                        switch(frame)
                        {
                            case 1: setImage(frame1); break;
                            case 2: setImage(frame2); break;
                            case 3: setImage(frame3); break;
                        }
                    }
                }
            }
            else if(unitaction == 3)
            {
                if(!enemyInSight())
                {
                    unitaction = prevact;
                    frame = 1;
                    needchange = true;
                }
                if(grenade <= 0)
                {
                    getWorld().addObject(new Weapons(7, 30, realX(), realY(), getSide(), 3, target), getX(), getY());
                    grenade = 360;
                }
                if(frame == 1)
                {
                    if(framechange >= reload - 3)
                    {
                        needchange = true;
                        framechange = 0;
                        frame ++;
                    }
                }
                if(frame == 2)
                {
                    if(framechange >= framechangerate)
                    {
                        needchange = true;
                        framechange = 0;
                        frame ++;
                    }
                }
                    if(needchange)
                    {
                        needchange = false;
                        switch(frame)
                        {
                            case 1: setImage(frame4); break;
                            case 2: setImage(frame5); break;
                        }
                    }
                if(frame > 2)
                {
                    frame = 1;
                    needchange = true;
                }
            }
            if(getAction() == 9)
            {
                if(needchange)
                {
                    needchange = false;
                    setImage(frameReq);
                }
                cast ++;
                if(getCast() >= 1)
                {
                    getWorld().addObject(new ReinforcementAirlift(0, owner, realX(), realY()), getX(), getY());
                    cast = 0;
                    maxcast = 1;
                    casttype = 0;
                    setBehavior(0);
                }
            }
            if(getAction() == 10)
            {
                if(needchange)
                {
                    needchange = false;
                    setImage(frameMed);
                }
                cast ++;
                if(getCast() >= 1)
                {
                for(Units c : wa.Taxeis)
                                {
                                    if(Math.sqrt(Math.pow(realX() - c.realX(), 2) + Math.pow(realY() - c.realY(),2)) <= 200 && !c.isMechanical())
                                    {
                                        c.heal(c.getMaxHitpoints() / 5d);
                                    }
                                }
                cast = 0;
                maxcast = 1;
                casttype = 0;
                setBehavior(0);
                }
            }
        }
    }
    @Override public void flipimage()
    {
        if(dir == LEFT)
        {
            if(frame1 != frame1l)
            {
                frame1 = frame1l;
            }
            if(frame2 != frame2l)
            {
                frame2 = frame2l;
            }
            if(frame3 != frame3l)
            {
                frame3 = frame3l;
            }
            if(frame4 != frame4l)
            {
                frame4 = frame4l;
            }
            if(frame5 != frame5l)
            {
                frame5 = frame5l;
            }
            if(frameReq != frameReql)
            {
                frameReq = frameReql;
            }
            if(frameMed != frameMedl)
            {
                frameMed = frameMedl;
            }
        }
        if(dir == RIGHT)
        {
            if(frame1 != frame1r)
            {
                frame1 = frame1r;
            }
            if(frame2 != frame2r)
            {
                frame2 = frame2r;
            }
            if(frame3 != frame3r)
            {
                frame3 = frame3r;
            }
            if(frame4 != frame4r)
            {
                frame4 = frame4r;
            }
            if(frame5 != frame5r)
            {
                frame5 = frame5r;
            }
            if(frameReq != frameReqr)
            {
                frameReq = frameReqr;
            }
            if(frameMed != frameMedr)
            {
                frameMed = frameMedr;
            }
        }
    }
    @Override public void playSound()
    {
        if(getX() > -200 && getX() < 1000)
        {
            if(Greenfoot.getRandomNumber(2) == 1)
            {
                Greenfoot.playSound("SMG.wav");
            }
            else
            {
                Greenfoot.playSound("SMG2.wav");
            }
        }
    }
    /**
     * Gets the cast length.
     */
    public double getCast()
    {
        return cast/(double)maxcast;
    }
    /**
     * sets ability cast
     */
    public void castAbility(int type)
    {
        casttype = type;
        needchange = true;
        switch(type)
        {
            case 1: maxcast = 200; break;
            case 2: maxcast = 25; break;
        }
    }
    public void createProgressBar()
    {
        if(pb == null && meteron)
        {
                pb = new ProgressBar(this);
                getWorld().addObject(pb, getX(), getY());
                hasmeter = true;
        }
        try
        {
            if(pb.getWorld() == null && meteron)
            {
                getWorld().addObject(pb, getX(), getY());
                hasmeter = true;
            }
        }
        catch(NullPointerException e)
        {
        }
    }
}
