import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class OreMine here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class OreMine  extends Structures
{
    public Units occupant;
    public int ore;
    public int oremax = 200;
    /**
     * AI will check if this mine is "taken" by a refinery.
     */
    public boolean occupied;
    private GreenfootImage norm = new GreenfootImage("oremine.png");
    private GreenfootImage work = new GreenfootImage("oremineWork.png");
    private Structures nearest;
    public OreMine(int ix, int iy)
    {
        side = 6;
        maxhitpoints = 20000;
        hitpoints = 20000;
        armorquantity = 10;
        armortype = 4;
        needchange = true;
        mapX = ix;
        mapY = iy;
    }
    /**
     * Act - do whatever the OreMine wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        createHealthBar();
        updateImage();
        produceore();
        perish();
        checkOccupant();
    }    
    public void updateImage()
    {
        if(needchange)
        {
            if(occupant == null)
            {
                needchange = false;
                setImage(norm);
            }
            else
            {
                needchange = false;
                setImage(work);
            }
        }
        if(ore > 200)
        {
            ore = 200;
        }
    }
    public void produceore()
    {
        for(DestructibleObjects a : wa.Actors)
        {
            if(a instanceof WorkerSphere)
            {
                WorkerSphere b = (WorkerSphere) a;
                if((b.realX() >= realX() && b.realX() <= realX()+getImage().getWidth()) && (b.realY() >= realY() && b.realY() <= realY()+getImage().getHeight()))
                {
                    occupant = b;
                }
            }
            if(a instanceof Harvester)
            {
                Harvester b = (Harvester) a;
                if((b.realX() >= realX() && b.realX() <= realX()+getImage().getWidth()) && (b.realY() >= realY() && b.realY() <= realY()+getImage().getHeight()))
                {
                    occupant = b;
                }
            }
            if(a instanceof WorkerBaby)
            {
                WorkerBaby b = (WorkerBaby) a;
                if((b.realX() >= realX() && b.realX() <= realX()+getImage().getWidth()) && (b.realY() >= realY() && b.realY() <= realY()+getImage().getHeight()))
                {
                    occupant = b;
                }
            }
        }
            if(ore < oremax)
            {
                ore ++;
            }
        if(occupant != null)
        {
            ore ++;
            if(occupant instanceof WorkerSphere)
            {
                if(ore >= ((WorkerSphere)occupant).maxbag)
                {
                    ore -= ((WorkerSphere)occupant).maxbag - ((WorkerSphere)occupant).bag;
                    ((WorkerSphere)occupant).bag = ((WorkerSphere)occupant).maxbag;
                    occupant.needchange = true;
                    occupant = null;
                }
                else
                {
                    ((WorkerSphere)occupant).bag += ore;
                    ore -= ore;
                }
            }
            if(occupant instanceof Harvester)
            {
                if(ore >= ((Harvester)occupant).maxbag)
                {
                    ore -= ((Harvester)occupant).maxbag - ((Harvester)occupant).bag;
                    ((Harvester)occupant).bag = ((Harvester)occupant).maxbag;
                    occupant.needchange = true;
                    occupant = null;
                }
                else
                {
                    ((Harvester)occupant).bag += ore;
                    ore -= ore;
                }
            }
            else if(occupant instanceof WorkerBaby)
            {
                if(ore >= ((WorkerBaby)occupant).maxbag)
                {
                    ore -= ((WorkerBaby)occupant).maxbag - ((WorkerBaby)occupant).bag;
                    ((WorkerBaby)occupant).bag = ((WorkerBaby)occupant).maxbag;
                    occupant.needchange = true;
                    occupant = null;
                }
                else
                {
                    ((WorkerBaby)occupant).bag += ore;
                    ore -= ore;
                }
            }
        }
    }
    public void clear()
    {
        occupant = null;
        needchange = true;
    }
    public void checkOccupant()
    {
        for(Structures a : wa.Aedificium)
        {
                if(nearest == null && (a instanceof EBCRefinery || a instanceof Refinery || a instanceof PosterityRefinery))
                {
                    nearest = a;
                }
                try
                {
                if(Math.sqrt(Math.pow(nearest.realX() - getX(), 2) + Math.pow(nearest.realY() - realY(), 2)) > Math.sqrt(Math.pow(a.realX() - realX(), 2) + Math.pow(a.realY() - realY(), 2)) && (a instanceof EBCRefinery || a instanceof Refinery))
                {
                    nearest = a;
                }
                if(Math.sqrt(Math.pow(nearest.realX() - realX(), 2) + Math.pow(nearest.realY() - realY(), 2)) <= 220 && (a instanceof EBCRefinery || a instanceof Refinery || a instanceof PosterityRefinery))
                {
                   occupied = true;
                }
                if(Math.sqrt(Math.pow(nearest.realX() - realX(), 2) + Math.pow(nearest.realY() - realY(), 2)) > 220 && (a instanceof EBCRefinery || a instanceof Refinery || a instanceof PosterityRefinery))
                {
                   occupied = false;
                }
            }
            catch(NullPointerException e)
            {
            }
        }
    }
    public int returnDistance()
    {
        try
        {
            return (int)(Math.sqrt(Math.pow(nearest.realX() - realX(), 2) + Math.pow(nearest.realY() - realY(), 2)));
        }
        catch(NullPointerException e)
        {
            return 0;
        }
    }
}
