import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Class of the unit Pistoleer Baby (EBC)
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class PistoleerBaby  extends Units
{
    private GreenfootImage frame1 = new GreenfootImage("PistolBaby1.png");
    private GreenfootImage frame2 = new GreenfootImage("PistolBaby2.png");
    private GreenfootImage frame1l = new GreenfootImage("PistolBaby1.png");
    private GreenfootImage frame2l = new GreenfootImage("PistolBaby2.png");
    private GreenfootImage frame1r = new GreenfootImage("PistolBaby1.png");
    private GreenfootImage frame2r = new GreenfootImage("PistolBaby2.png");
    /**
     * Act - do whatever the PistoleerBaby wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public PistoleerBaby(int iniside, int ix, int iy)
    {
        side = iniside;
        maxhitpoints = 30;
        attackimage = 1;
        armortype = 1;
        armorquantity = 0;
        range = 95;
        hitpoints = 30;
        weapontype = 1;
        damage = 2;
        delay = 25;
        canhitground = true;
        speed = 2;
        mapX = ix;
        mapY = iy;
    }
    public PistoleerBaby(int iniside, Player pl, int ix, int iy)
    {
        side = iniside;
        maxhitpoints = 30;
        attackimage = 1;
        armortype = 1;
        armorquantity = 0;
        range = 95;
        hitpoints = 30;
        weapontype = 1;
        damage = 2;
        delay = 25;
        canhitground = true;
        speed = 2;
        mapX = ix;
        mapY = iy;
        owner = pl;
    }
    public void addedToWorld(World w)
    {
        id = 10;
        genmaches = (Battleground) w;
        wa = genmaches.array;
        if(side == 1)
        {
            frame1.mirrorHorizontally();
            frame2.mirrorHorizontally();
        }
        frame1r.mirrorHorizontally();
        frame2r.mirrorHorizontally();
    }
    public void act() 
    {
        // Add your action code here.
        updateimage();
        attack();
        createHealthBar();
        perish();
        collisionReact();
        alignImage();
        checkUpgrades();
    }    
    public void updateimage()
    {
        if(unitaction == 0)
        {
            if(needchange)
            {
                   setImage(frame1);
                   needchange = false;
            }
        }
        if(unitaction != 0)
        {
            if(unitaction == 1)
            {
                if(needchange)
                {
                    setImage(frame1);
                    needchange = false;
                needchange = false;
                }
            }
            else if(unitaction == 2)
            {
                if(!enemyInSight())
                {
                    unitaction = prevact;
                    frame = 1;
                    needchange = true;
                }
                else
                {
                if(needchange)
                {
                    setImage(frame1);
                    needchange = false;
                }
                }
            }
            else if(unitaction == 3)
            {           
                framechange ++;
                if(frame == 1)
                {
                    if(framechange >= reload - 3)
                    {
                        frame ++;
                        framechange = 0;
                        needchange = true;
                    }
                }
                else if(frame == 2)
                {
                    if(framechange >= 3)
                    {
                        frame ++;
                        framechange = 0;
                        needchange = true;
                    }
                }
                if(frame > 2)
                {
                    frame = 1;
                }
                    if(needchange)
                    {
                        needchange = false;
                        switch(frame)
                        {
                            case 1: setImage(frame1); break;
                            case 2: setImage(frame2); break;
                        }
                    }
            }
        }
    }
    @Override public void flipimage()
    {
        if(dir == LEFT)
        {
            if(frame1 != frame1l)
            {
                frame1 = frame1l;
            }
            if(frame2 != frame2l)
            {
                frame2 = frame2l;
            }
        }
        if(dir == RIGHT)
        {
            if(frame1 != frame1r)
            {
                frame1 = frame1r;
            }
            if(frame2 != frame2r)
            {
                frame2 = frame2r;
            }
        }
    }
    @Override public void playSound()
    {
        if(getX() > -100 && getX() < 900)
        {
            Greenfoot.playSound("Pistol.wav");
        }
    }
}
