import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class PosterityConstructionHubCarrier here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class PosterityConstructionHubCarrier  extends Units
{
    public PosterityConstructionHubCarrier(int iniside, int ix, int iy)
    {
        side = iniside;
        maxhitpoints = 600;
        armortype = 3;
        armorquantity = 4;
        hitpoints = 600;
        speed = 2;
        mapX = ix;
        mapY = iy;
        mechanical = true;
    }
    public PosterityConstructionHubCarrier(int iniside, Player pl, int ix, int iy)
    {
        owner = pl;
        side = iniside;
        maxhitpoints = 700;
        armortype = 3;
        armorquantity = 4;
        hitpoints = 700;
        speed = 2;
        mapX = ix;
        mapY = iy;
        mechanical = true;
    }
    public PosterityConstructionHubCarrier(int iniside, Player pl, int ix, int iy, PosterityConstructionHub cy)
    {
        owner = pl;
        side = iniside;
        maxhitpoints = 700;
        armortype = 3;
        armorquantity = 4;
        hitpoints = cy.hitpoints;
        speed = 2;
        mapX = ix;
        mapY = iy;
        mechanical = true;
    }
    public void addedToWorld(World w)
    {
        genmaches = (Battleground) w;
        wa = genmaches.array;
        if(side == 2)
        {
            getImage().mirrorHorizontally();
        }
    }
    /**
     * Act - do whatever the PosterityConstructionHubCarrier wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        updateImage();
        perish();
        createHealthBar();
    }    
    public void updateImage()
    {
        if(unitaction == 7)
        {
            framechange ++;
            if(frame == 0)
            {
                frame = 1;
            }
            if(framechange >= framechangerate)
            {
                framechange = 0;
                frame ++;
            }
            if(frame > 4)
            {
                getWorld().addObject(new PosterityConstructionHub(side, owner, realX(), realY(), this), getX(), getY());
                getWorld().removeObject(this);
            }
            else if(frame <= 4)
            {
                setImage("MobileConVehicleDeploy" + (frame + 1) + ".png");
            }
        }
    }   
}
