import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Refinery here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Refinery  extends Structures
{
    private GreenfootImage frame1 = new GreenfootImage("Refinery1.png");
    private GreenfootImage frame2 = new GreenfootImage("Refinery2.png");
    private GreenfootImage frame3 = new GreenfootImage("Refinery3.png");
    private GreenfootImage frame4 = new GreenfootImage("Refinery4.png");
    private GreenfootImage frame5 = new GreenfootImage("Refinery5.png");
    private GreenfootImage frame6 = new GreenfootImage("Refinery6.png");
    private GreenfootImage frame7 = new GreenfootImage("Refinery7.png");
    private GreenfootImage frame8 = new GreenfootImage("Refinery8.png");
    public Refinery(int iniside, int ix, int iy)
    {
        side = iniside;
        maxhitpoints = 400;
        armortype = 4;
        armorquantity = 2;
        hitpoints = 400;
        mapX = ix;
        mapY = iy;
        cost = 200;
        id = 1;
    }
    public Refinery(int iniside, Player pl, int ix, int iy)
    {
        owner = pl;
        side = iniside;
        maxhitpoints = 400;
        armortype = 4;
        armorquantity = 2;
        hitpoints = 400;
        mapX = ix;
        mapY = iy;
        cost = 200;
        id = 1;
    }
    /**
     * Act - do whatever the Refinery wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        if(!deployed)
        {
            deployed = true;
            getWorld().addObject(new WorkerSphere(side, owner, realX(), realY()), getX(), getY());
        }
        createHealthBar();
        createProgressBar();
        returnGood();
        produce();
        updateImage();
        perish();
    }    
    public void updateImage()
    {
        if(prodtype == 0)
        {
            if(frame != 1)
            {
                frame = 1;
                setImage(frame1);
            }
        }
        if(prodtype != 0)
        {
            framechange ++;
            if(framechange >= framechangerate)
            {
                frame ++;
                framechange = 0;
                switch(frame)
                {
                    case 1: setImage(frame1); break;
                    case 2: setImage(frame2); break;
                    case 3: setImage(frame3); break;
                    case 4: setImage(frame4); break;
                    case 5: setImage(frame5); break;
                    case 6: setImage(frame6); break;
                    case 7: setImage(frame7); break;
                    case 8: setImage(frame8); break;
                }
                if(frame > 7)
                {
                    frame = 1;
                }
            }
        }
    }
    public void returnGood()
    {
        for(DestructibleObjects a : wa.Actors)
        {
            if(a instanceof WorkerSphere)
            {
                WorkerSphere b = (WorkerSphere) a;
                if((b.realX() >= realX()-getImage().getWidth()/2 && b.realX() <= realX()+getImage().getWidth()/2) && (b.realY() >= realY()-getImage().getHeight()/2 && b.realY() <= realY()+getImage().getHeight()/2))
                {
                    if(prodtype == 0)
                    {
                        progressmax = b.bag * 2;
                        b.bag = 0;
                        b.needchange = true;
                        prodtype = 1;
                    }
                }
            }
        }
    }
    @Override public void produce()
    {
        if(prodtype != 0)
        {
            if(progress < progressmax)
            {
                progress ++;
                progressperc = (double) progress/progressmax;
                try
                {
                    if(progress % 2 == 0)
                    {
                        switch(prodtype)
                        {
                            case 1: owner.resources ++;
                        }
                    }
                }
                catch(NullPointerException e)
                {
                }
            }
        }
        if(prodtype != 0 && progress >= progressmax)
        {
            if(prodtype == 9)
            {
                getWorld().addObject(new WorkerSphere(side, owner, realX(), realY()), getX(), getY());
            }
            progressperc = 0;
            prodtype = 0;
            progress = 0;
            progressmax = 1;
        }
    }
}
