import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class ReinforcementAirlift here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class ReinforcementAirlift  extends Flyer
{
    private int cargo;
    private Airstrip dest;
    private boolean hasUnloaded;
    public ReinforcementAirlift(int ini, Airstrip sakarauka, int ix, int iy)
    {
        mapX = ix;
        mapY = iy;
        dest = sakarauka;
        cargo = ini;
        owner = sakarauka.getOwner();
        height = 400;
        flyer = true;
        hitpoints = 6000;
        maxhitpoints = 6000;
        armortype = 4;
        armorquantity = 50;
    }
    public ReinforcementAirlift(int ini, Player pl, int ix, int iy)
    {
        owner = pl;
        mapX = ix;
        mapY = iy;
        cargo = ini;
        height = 400;
        flyer = true;
        hitpoints = 6000;
        maxhitpoints = 6000;
        armortype = 4;
        armorquantity = 50;
    }
    /**
     * Act - do whatever the ReinforcementAirlift wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        if(!hasUnloaded)
        {
            height -= 2;
            if(owner != null && dest == null)
            {
                if(height <= 10)
                {
                    unload();
                    getWorld().addObject(new ArtilleryGun(owner.getSide(), owner, realX(), realY()), getX(), getY());
                }
            }
        }
        else
        {
            height += 2;
            if(height > 400)
            {
                getWorld().removeObject(this);
            }
        }
    }    
    public int getCargo()
    {
        return cargo;
    }
    public void unload()
    {
        hasUnloaded = true;
    }
    public boolean unloaded()
    {
        return hasUnloaded;
    }
}
