import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class RocketSphere here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class RocketSphere  extends Units
{
    private GreenfootImage frame1 = new GreenfootImage("RocketSphere1.png");
    private GreenfootImage frame2 = new GreenfootImage("RocketSphere2.png");
    private GreenfootImage frame1l = new GreenfootImage("RocketSphere1.png");
    private GreenfootImage frame2l = new GreenfootImage("RocketSphere2.png");
    private GreenfootImage frame1r = new GreenfootImage("RocketSphere1.png");
    private GreenfootImage frame2r = new GreenfootImage("RocketSphere2.png");
    private int reg;
    public RocketSphere(int iniside, int ix, int iy)
    {
        side = iniside;
        maxhitpoints = 40;
        attackimage = 3;
        armortype = 1;
        armorquantity = 0;
        range = 220;
        hitpoints = 40;
        weapontype = 3;
        damage = 24;
        delay = 100;
        canhitground = true;
        canhitair = true;
        speed = 2;
        mapX = ix;
        mapY = iy;
        cost = 45;
    }
    public RocketSphere(int iniside, Player pl, int ix, int iy)
    {
        side = iniside;
        maxhitpoints = 40;
        attackimage = 3;
        armortype = 1;
        armorquantity = 0;
        range = 220;
        hitpoints = 40;
        weapontype = 3;
        damage = 24;
        delay = 100;
        canhitground = true;
        canhitair = true;
        speed = 2;
        mapX = ix;
        mapY = iy;
        owner = pl;
        cost = 45;
    }
    public void addedToWorld(World w)
    {
        id = 2;
        genmaches = (Battleground) w;
        wa = genmaches.array;
        if(side == 1)
        {
            frame1.mirrorHorizontally();
            frame2.mirrorHorizontally();
            setImage(frame1);
        }
        frame1r.mirrorHorizontally();
        frame2r.mirrorHorizontally();
    }
    /**
     * Act - do whatever the RocketSphere wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    
    public void act() 
    {
        // Add your action code here.
        updateimage();
        attack();
        createHealthBar();
        perish();
        collisionReact();
        alignImage();
        flipimage();
    }    
    /**
     * updates image for the unit. All generic units have two action id (move = 1, stand = 0) (2 is retreat) and most units have attack id (3)
     */
    public void updateimage()
    {
        if(getOwner().Upgrades[1] > 0)
        {
            reg++;
            if(reg >= 40)
            {
                reg = 0;
                if(hitpoints < maxhitpoints)
                {
                    if((double)(maxhitpoints - hitpoints) < 1)
                    {
                        hitpoints = maxhitpoints;
                    }
                    else
                    {
                    hitpoints ++;
                    }
                }
            }
        }
        if(unitaction == 0)
        {
            if(frame != 1)
            {
                frame = 1;
                needchange = true;
            }
            else if(needchange)
            {
                if(side == 1)
                {
                    needchange = false;
                    setImage(frame1);
                }
                else if(side == 2)
                {
                    needchange = false;
                    setImage(frame1);
                }
            }
        }
        if(unitaction != 0)
        {
            framechange ++;
            if(framechange >= framechangerate)
            {
                needchange = true;
                framechange = 0;
                frame ++;
            }
            if(unitaction == 1)
            {
                    if(realX() <= 0 || realX() >= wa.getWidth())
                {
                    unitaction = 0;
                }
                if(frame > 2)
                {
                    frame = 1;
                }
                if(needchange)
                {
                    switch(frame)
                        {
                            case 1: setImage(frame1); break;
                            case 2: setImage(frame2); break;
                        }
                needchange = false;
                }
            }
            else if(unitaction == 2 || unitaction == 4 || unitaction == 5)
            {
                if(realX() <= 0 || realX() >= wa.getWidth())
                {
                    unitaction = 0;
                }
                else
                {
                if(frame > 2)
                {
                    frame = 1;
                }
                if(needchange)
                {
                        switch(frame)
                        {
                            case 1: setImage(frame1); break;
                            case 2: setImage(frame2); break;
                        }
                    needchange = false;
                }
                }
            }
            else if(unitaction == 3)
            {
                if(!enemyInSight())
                {
                    unitaction = prevact;
                    frame = 1;
                    needchange = true;
                }
                    if(needchange)
                    {
                        needchange = false;
                        setImage(frame1);
                    }
            }
        }
    }
    @Override public void flipimage()
    {
        if(dir == LEFT)
        {
            if(frame1 != frame1l)
            {
                frame1 = frame1l;
            }
            if(frame2 != frame2l)
            {
                frame2 = frame2l;
            }
        }
        if(dir == RIGHT)
        {
            if(frame1 != frame1r)
            {
                frame1 = frame1r;
            }
            if(frame2 != frame2r)
            {
                frame2 = frame2r;
            }
        }
    }
}
