import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Stance here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Stance  extends InGame
{
    private DestructibleObjects own;
    private int id;
    public Stance(DestructibleObjects ini, int cfg)
    {
        own = ini;
        id = cfg;
        switch(id)
        {
            case 1: setImage("SendOutBombers.bmp"); break;
            case 2: setImage("Recall.bmp"); break;
            case 3: setImage("HurlMolotov.bmp"); break;
        }
    }
    /**
     * Act - do whatever the Stance wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        if(Greenfoot.mousePressed(this))
        {
            switch(id)
            {
                case 1: 
                if(own instanceof Airfield)
                {
                    Airfield a = (Airfield) own; 
                    if(!a.auto)
                    {
                        a.auto = true;
                    }
                }
                else if(own instanceof Helipad)
                {
                    Helipad a = (Helipad) own;
                    if(!a.auto)
                    {
                        a.auto = true;
                    }
                }; break;
                case 2: 
                if(own instanceof Airfield)
                {
                    Airfield a = (Airfield) own;
                    if(a.auto)
                    {
                        a.auto = false;
                        if(a.getOccupant() != null)
                        {
                            a.getOccupant().setBehavior(6);
                        }
                    }
                }
                else if(own instanceof Helipad)
                {
                    Helipad a = (Helipad) own;
                    if(a.auto)
                    {
                        a.auto = false;
                        if(a.getOccupant() != null)
                        {
                            a.getOccupant().setBehavior(6);
                        }
                    }
                }; break;
            }
        }
        if(!hasbar)
        {
            makeHelpbar();
        }
    }    
    public void makeHelpbar()
    {
        if(!hasbar)
        {
        if(intersect())
        {
            switch(id)
            {
                case 1: getWorld().addObject(new HelpTab(this, "Send out Bombers", "Automatically sends the bomber should it be full of bombs to the enemy.", "Click to enable the Airfield to do so", ""), 650, 400); break;
                case 2: getWorld().addObject(new HelpTab(this, "Recall Bombers", "Recalls the bomber to rearm.", "Disables the automatic mission assignment",""), 650, 400); break;
            }
            hasbar = true;
        }
        }
    }
}
