import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * The MBT of the TIA.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class StandardArmor  extends Units
{
    private GreenfootImage frame1 = new GreenfootImage("ArmoredVehicle.png");
    private GreenfootImage frame1l = new GreenfootImage("ArmoredVehicle.png");
    private GreenfootImage frame1r = new GreenfootImage("ArmoredVehicle.png");
    private int sound;
    public StandardArmor(int iniside, int ix, int iy)
    {
        side = iniside;
        maxhitpoints = 250;
        attackimage = 2;
        armortype = 2;
        armorquantity = 2;
        range = 170;
        hitpoints = 250;
        weapontype = 2;
        damage = 10;
        delay = 30;
        canhitground = true;
        canhitair = false;
        speed = 2;
        mapX = ix;
        mapY = iy;
        cost = 110;
        id = 4;
        mechanical = true;
    }
    public StandardArmor(int iniside, Player pl, int ix, int iy)
    {
        side = iniside;
        owner = pl;
        maxhitpoints = 250;
        attackimage = 2;
        armortype = 2;
        armorquantity = 1;
        range = 170;
        hitpoints = 250;
        weapontype = 2;
        damage = 10;
        delay = 30;
        canhitground = true;
        canhitair = false;
        speed = 2;
        mapX = ix;
        mapY = iy;
        cost = 110;
        id = 4;
        mechanical = true;
    }
    public void addedToWorld(World w)
    {
        id = 4;
        genmaches = (Battleground) w;
        wa = genmaches.array;
        if(side == 1)
        {
            frame1.mirrorHorizontally();
        }
        frame1r.mirrorHorizontally();
    }
    /**
     * Act - do whatever the StandardArmor wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        updateImage();
        flipimage();
        alignImage();
        attack();
        createHealthBar();
        perish();
        collisionReact();
    }    
    public void updateImage()
    {
        if(unitaction == 0)
        {
            if(needchange)
            {
                if(side == 1)
                {
                    needchange = false;
                    setImage(frame1);
                }
                else if(side == 2)
                {
                    needchange = false;
                    setImage(frame1);
                }
            }
        }
        if(unitaction != 0)
        {
            if(framechange >= framechangerate)
            {
                 framechange = 0;
                 needchange = true;
            }
            if(unitaction == 1)
            {
                    if(realX() <= 0 || realX() >= wa.getWidth())
                {
                    unitaction = 0;
                }
                if(needchange)
                {
                if(side == 1)
                {
                    setImage(frame1);
                }
                if(side == 2)
                {
                    setImage(frame1);
                }
                needchange = false;
                }
                sound ++;
                if(sound >= 200)
                {
                    sound = 0;
                    if(getX() > -100 && getX() < 900)
                    {
                        Greenfoot.playSound("tank1.wav");
                    }
                }
            }
            else if(unitaction == 2)
            {
                if(realX() <= 0 || realX() >= wa.getWidth())
                {
                    unitaction = 0;
                }
                if(needchange)
                {
                if(side == 1)
                {
                    setImage(frame1);
                }
                if(side == 2)
                {
                    setImage(frame1);
                }
                needchange = false;
                }
                sound ++;
                if(sound >= 200)
                {
                    sound = 0;
                    if(getX() > -100 && getX() < 900)
                    {
                        Greenfoot.playSound("tank1.wav");
                    }
                }
            }
            else if(unitaction == 3)
            {           
                if(!enemyInSight())
                {
                    unitaction = prevact;
                    frame = 1;
                    needchange = true;
                }
                try
                {
                    if(target.realX() > realX())
                    {
                        if(needchange)
                        {
                            needchange = false;
                            setImage(frame1);
                        }
                    }
                    if(target.realX() < realX())
                    {
                        if(needchange)
                        {
                            needchange = false;
                            setImage(frame1);
                        }
                    }
                }
                catch(NullPointerException e)
                {
                }
            }
        }
    }
    @Override public void flipimage()
    {
        if(dir == LEFT)
        {
            if(frame1 != frame1l)
            {
                frame1 = frame1l;
            }
        }
        if(dir == RIGHT)
        {
            if(frame1 != frame1r)
            {
                frame1 = frame1r;
            }
        }
    }
}
