import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Structure here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Structure  extends InGame
{
    public ConstructionYard Com;
    public PosterityConstructionHub pch;
    public WorkerBaby eb;
    private int id;
    public Structure(ConstructionYard ini, int cfg)
    {
        Com = ini;
        id = cfg;
        switch(id)
        {
            case 0: setImage("Unpack.bmp"); techsufficient = true; break;
            case 1: setImage("Refinery.bmp"); techsufficient = true; break;
            case 2: setImage("TIADojo.bmp"); techsufficient = true; break;
            case 3: setImage("WarFactory.bmp"); if(Com.getOwner().Requirements[1] >0){techsufficient = true;} else{getImage().setTransparency(100);}; break;
            case 4: setImage("Airfield.bmp"); if(Com.getOwner().Requirements[1] >0){techsufficient = true;} else{getImage().setTransparency(100);}; break;
            case 5: setImage("StrategyCenter.bmp"); if(Com.getOwner().Requirements[3] >0){techsufficient = true;} else{getImage().setTransparency(100);}; break;
            case 31: setImage("Pack.bmp"); techsufficient = true; break;
        }
    }
    public Structure(PosterityConstructionHub ini, int cfg)
    {
        pch = ini;
        id = cfg;
        switch(id)
        {
            case 0: setImage("Unpack.bmp"); techsufficient = true; break;
            case 11: setImage("Refinery.bmp"); techsufficient = true; break;
            case 12: setImage("Airstrip.bmp"); if(pch.getOwner().Requirements[11] >0){techsufficient = true;} else{getImage().setTransparency(100);}; break;
            case 13: setImage("CommandPost.bmp"); if(pch.getOwner().Requirements[12] >0){techsufficient = true;} else{getImage().setTransparency(100);}; break;
            case 14: setImage("Helipad.bmp"); if(pch.getOwner().Requirements[13] >0){techsufficient = true;} else{getImage().setTransparency(100);}; break;
            case 15: setImage("NanoassemblyMainframe.bmp"); if(pch.getOwner().Requirements[13] >0){techsufficient = true;} else{getImage().setTransparency(100);}; break;
            case 16: setImage("MissileLaunchPad.bmp"); if(pch.getOwner().Requirements[15] >0){techsufficient = true;} else{getImage().setTransparency(100);}; break;
            case 31: setImage("Pack.bmp"); techsufficient = true; break;
        }
    }
    public Structure(WorkerBaby ini, int cfg)
    {
        eb = ini;
        id = cfg;
        switch(id)
        {
            case 6: setImage("Refinery.bmp"); techsufficient = true; break;
            case 7: setImage("BabyCamp.bmp"); techsufficient = true; break;
            case 8: setImage("CapitalistLodge.bmp"); if(eb.getOwner().Requirements[6] >0){techsufficient = true;} else{getImage().setTransparency(100);}; break;
            case 9: setImage("MaterialistHub.bmp"); if(eb.getOwner().Requirements[6] >0){techsufficient = true;} else{getImage().setTransparency(100);}; break;
            case 10: setImage("Factory.bmp"); if(eb.getOwner().Requirements[8] >0 && eb.getOwner().Requirements[9] > 0){techsufficient = true;} else{getImage().setTransparency(100);}; break;
        }
    }
    /**
     * Act - do whatever the Structure wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        if(Greenfoot.mousePressed(this))
        {
            if(Com != null  && Com.getWorld() != null && techsufficient)
            {
                if(Com.getProduction() == 0)
                {
                    switch(id)
                    {
                        case 1: if(Com.getOwner().resources >= 400){Com.setProdMax(900); Com.getOwner().resources -= 400; Com.setProduction(id);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 150), 400, 400);}; break;
                        case 2: if(Com.getOwner().resources >= 100){Com.setProdMax(400); Com.getOwner().resources -= 100; Com.setProduction(id);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 150), 400, 400);}; break;
                        case 3: if(Com.getOwner().resources >= 400){Com.setProdMax(1600); Com.getOwner().resources -= 400; Com.setProduction(id);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 150), 400, 400);}; break;
                        case 4: if(Com.getOwner().resources >= 200){Com.setProdMax(800); Com.getOwner().resources -= 200; Com.setProduction(id);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 150), 400, 400);}; break;
                        case 5: if(Com.getOwner().resources >= 250){Com.setProdMax(2000); Com.getOwner().resources -= 250; Com.setProduction(id);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 150), 400, 400);}; break;
                        case 31: Com.setProduction(6); break;
                    }
                }
                else if(Com.getProgress() >= 1 && id == 0)
                {
                    MouseInfo ms = Greenfoot.getMouseInfo();
                    getWorld().addObject(new GhostStructures(Com.getProduction(), Com, ((Battleground) getWorld()).array), ms.getX(), ms.getY());
                }
            }
            if(pch != null  && pch.getWorld() != null && techsufficient)
            {
                if(pch.getProduction() == 0)
                {
                    switch(id)
                    {
                        case 11: if(pch.getOwner().resources >= 450){pch.setProdMax(900); pch.getOwner().resources -= 450; pch.setProduction(id);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 150), 400, 400);}; break;
                        case 12: if(pch.getOwner().resources >= 200){pch.setProdMax(800); pch.getOwner().resources -= 200; pch.setProduction(id);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 150), 400, 400);}; break;
                        case 13: if(pch.getOwner().resources >= 200){pch.setProdMax(1600); pch.getOwner().resources -= 200; pch.setProduction(id);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 150), 400, 400);}; break;
                        case 14: if(pch.getOwner().resources >= 200){pch.setProdMax(900); pch.getOwner().resources -= 200; pch.setProduction(id);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 150), 400, 400);}; break;
                        case 15: if(pch.getOwner().resources >= 600){pch.setProdMax(2500); pch.getOwner().resources -= 250; pch.setProduction(id);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 150), 400, 400);}; break;
                        case 16: if(pch.getOwner().resources >= 200){pch.setProdMax(2000); pch.getOwner().resources -= 200; pch.setProduction(id);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 150), 400, 400);}; break;
                        case 31: pch.setProduction(6); break;
                    }
                }
                else if(pch.getProgress() >= 1 && id == 0)
                {
                    MouseInfo ms = Greenfoot.getMouseInfo();
                    getWorld().addObject(new GhostStructures(pch.getProduction(), pch, ((Battleground) getWorld()).array), ms.getX(), ms.getY());
                }
            }
            if(eb != null && eb.getWorld() != null && techsufficient)
            {
                MouseInfo ms = Greenfoot.getMouseInfo();
                switch(id)
                {
                    case 6: if(eb.getOwner().resources >= 300){getWorld().addObject(new GhostStructures(id, eb, ((Battleground) getWorld()).array), ms.getX(), ms.getY()); eb.getOwner().resources -= 300;} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 150), 400, 400);}; break;
                    case 7: if(eb.getOwner().resources >= 150){getWorld().addObject(new GhostStructures(id, eb, ((Battleground) getWorld()).array), ms.getX(), ms.getY()); eb.getOwner().resources -= 150;} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 150), 400, 400);}; break;
                    case 8: if(eb.getOwner().resources >= 250){getWorld().addObject(new GhostStructures(id, eb, ((Battleground) getWorld()).array), ms.getX(), ms.getY()); eb.getOwner().resources -= 250;} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 150), 400, 400);}; break;
                    case 9: if(eb.getOwner().resources >= 250){getWorld().addObject(new GhostStructures(id, eb, ((Battleground) getWorld()).array), ms.getX(), ms.getY()); eb.getOwner().resources -= 250;} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 150), 400, 400);}; break;
                    case 10: if(eb.getOwner().resources >= 250){getWorld().addObject(new GhostStructures(id, eb, ((Battleground) getWorld()).array), ms.getX(), ms.getY()); eb.getOwner().resources -= 250;} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 150), 400, 400);}; break;
                }
            }
        }
        checkDependency();
        makeHelpbar();
    }
    /**
     * Checks if the button becomes valid (e.g. building a war factory to unlock strategy center for TIA) or if it becomes invalid
     */
    public void checkDependency()
    {
        switch(id)
        {
            case 3: if(Com.getOwner().Requirements[1] >0){techsufficient = true; getImage().setTransparency(255);} else{techsufficient = false; getImage().setTransparency(100);}; break;
            case 4: if(Com.getOwner().Requirements[1] >0){techsufficient = true; getImage().setTransparency(255);} else{techsufficient = false; getImage().setTransparency(100);}; break;
            case 5: if(Com.getOwner().Requirements[3] >0){techsufficient = true; getImage().setTransparency(255);} else{techsufficient = false; getImage().setTransparency(100);}; break;
            case 8: if(eb.getOwner().Requirements[6] >0){techsufficient = true; getImage().setTransparency(255);} else{techsufficient = false; getImage().setTransparency(100);}; break;
            case 9: if(eb.getOwner().Requirements[6] >0){techsufficient = true; getImage().setTransparency(255);} else{techsufficient = false; getImage().setTransparency(100);}; break;
            case 10: if(eb.getOwner().Requirements[8] >0 || eb.getOwner().Requirements[9] >0){techsufficient = true; getImage().setTransparency(255);} else{techsufficient = false; getImage().setTransparency(100);}; break;
            case 12: if(pch.getOwner().Requirements[11] > 0){techsufficient = true; getImage().setTransparency(255);} else{techsufficient = false; getImage().setTransparency(100);}; break;
            case 13: if(pch.getOwner().Requirements[12] > 0){techsufficient = true; getImage().setTransparency(255);} else{techsufficient = false; getImage().setTransparency(100);}; break;
            case 14: if(pch.getOwner().Requirements[13] > 0){techsufficient = true; getImage().setTransparency(255);} else{techsufficient = false; getImage().setTransparency(100);}; break;
            case 15: if(pch.getOwner().Requirements[13] > 0){techsufficient = true; getImage().setTransparency(255);} else{techsufficient = false; getImage().setTransparency(100);}; break;
            case 16: if(pch.getOwner().Requirements[15] > 0){techsufficient = true; getImage().setTransparency(255);} else{techsufficient = false; getImage().setTransparency(100);}; break;
        }
    }
    public void makeHelpbar()
    {
        if(!hasbar)
        {
        if(intersect())
        {
            switch(id)
            {
                case 0: getWorld().addObject(new HelpTab(this, "Unpack", "Deploys finished building", "Place on suitable terrain", ""), 650, 400); break;
                case 1: getWorld().addObject(new HelpTab(this, "Refinery", "Resource Depot, Comes with Worker", "Cost: 400 ore", ""), 650, 400); break;
                case 2: getWorld().addObject(new HelpTab(this, "TIA Dojo Level 1", "Infantry Training Building", "Cost: 100 ore",""), 650, 400); break;
                case 3: getWorld().addObject(new HelpTab(this, "TIA War Factory", "Vehicle Production Facility", "Cost: 400 ore","Requirements: TIA Refinery"), 650, 400); break;
                case 4: getWorld().addObject(new HelpTab(this, "Airfield", "Aircraft Maintenance and Production", "Cost: 200 ore","Requirements: TIA Refinery"), 650, 400); break;
                case 5: getWorld().addObject(new HelpTab(this, "Strategy Center", "Tech Center/Special Structure", "Cost: 400 ore","Requirements: TIA War Factory"), 650, 400); break;
                case 6: getWorld().addObject(new HelpTab(this, "Refinery", "Resource Depot, Comes with Worker", "Cost: 300 ore", ""), 650, 400); break;
                case 7: getWorld().addObject(new HelpTab(this, "Baby Camp", "Infantry Training Building", "Cost: 150 ore", ""), 650, 400); break;
                case 8: getWorld().addObject(new HelpTab(this, "Capitalist Lodge", "Tech Structure", "Cost: 200 ore", "Requirements: EBC Refinery"), 650, 400); break;
                case 9: getWorld().addObject(new HelpTab(this, "Materialist Hub", "Tech Structure", "Cost: 250 ore", "Requirements: EBC Refinery"), 650, 400); break;
                case 10: getWorld().addObject(new HelpTab(this, "EBC Factory", "Vehicle Facility", "Cost: 250 ore", "Requirements: Materialist Lodge or Capitalist Lodge"), 650, 400); break;
                case 11: getWorld().addObject(new HelpTab(this, "Refinery", "Resource Depot. Comes with a Harvester", "Cost: 450 ore", ""), 650, 400); break;
                case 12: getWorld().addObject(new HelpTab(this, "Airstrip", "Vehicle Facility", "Cost: 300 ore", "Requirements: Posterity Refinery"), 650, 400); break;
                case 13: getWorld().addObject(new HelpTab(this, "Command Post", "Field Support/Tech Structure", "Cost: 200 ore", "Requirements: Posterity Airstrip"), 650, 400); break;
                case 14: getWorld().addObject(new HelpTab(this, "Helipad", "Aircraft Production", "Cost: 200 ore", "Requirements: Command Post"), 650, 400); break;
                case 15: getWorld().addObject(new HelpTab(this, "Nanoassembly Mainfrae", "Advanced Tech Facility", "Cost: 600 ore", "Requirements: Command Post"), 650, 400); break;
                case 16: getWorld().addObject(new HelpTab(this, "Missile Launch Pad", "Warhead Production", "Cost: 200 ore", "Requirements: Nanoassembly Mainframe"), 650, 400); break;
                case 31: getWorld().addObject(new HelpTab(this, "Pack", "Packs the Construction Hub to make it mobile", "Yields a Construction Hub Carrier", ""), 650, 400); break;
            }
            hasbar = true;
        }
        }
    }
}
