import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class TIAWarFactory here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class TIAWarFactory  extends Structures
{
    public TIAWarFactory(int iniside, int ix, int iy)
    {
        side = iniside;
        maxhitpoints = 400;
        armortype = 4;
        armorquantity = 2;
        hitpoints = 400;
        mapX = ix;
        mapY = iy;
        cost = 200;
        id = 3;
    }
    public TIAWarFactory(int iniside, Player pl, int ix, int iy)
    {
        owner = pl;
        side = iniside;
        maxhitpoints = 400;
        armortype = 4;
        armorquantity = 2;
        hitpoints = 400;
        mapX = ix;
        mapY = iy;
        cost = 200;
        id = 3;
    }
    public void addedToWorld(World w)
    {
        deployed = true;
        genmaches = (Battleground) w;
        wa = genmaches.array;
        if(side == 1)
        {
            getImage().mirrorHorizontally();
        }
    }
    /**
     * Act - do whatever the TIAWarFactory wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        createHealthBar();
        createProgressBar();
        produce();
        perish();
        createUnit();
    }    
    public void createUnit()
    {
        if(progressperc == 1)
        {
            int dx = 0;
            switch(side)
            {
                case 1: dx = 50; break;
                case 2: dx = -50; break;
            }
            switch(prodtype)
            {
                case 4: getWorld().addObject(new StandardArmor(side, owner, realX()+dx, realY()), getX()+dx, getY()); break;
                case 5: getWorld().addObject(new GunTank(side, owner, realX()+dx, realY()), getX()+dx, getY()); break;
                case 6: getWorld().addObject(new TankDestroyer(side, owner, realX()+dx, realY()), getX()+dx, getY()); break;
                case 19: getWorld().addObject(new SphereHoverCycle(side, owner, realX()+dx, realY()), getX()+dx, getY()); break;
                case 31: getWorld().addObject(new MobileConstructionVehicle(side, owner, realX()+dx, realY()), getX()+dx, getY()); break;
            }
            clearProduction();
        }
    }
}
