import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.ArrayList;

/**
 * Write a description of class UnitAbility here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class UnitAbility  extends InGame
{
    private ArrayList<DestructibleObjects> d;
    private int id;
    private WorldArray wa;
    private ButtonCreator bc;
    public UnitAbility(WorldArray ini, int cfg, ButtonCreator dat)
    {
        wa = ini;
        id = cfg;
        bc = dat;
        switch(cfg)
        {
            case 1: setImage("HurlMolotov.bmp"); break;
            case 2: setImage("Spikes.bmp"); break;
            case 3: setImage("DropArtillery.bmp"); break;
            case 4: setImage("MedKit.bmp"); break;
        }
    }
    /**
     * Act - do whatever the UnitAbility wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        getList();
        doAction();
        if(!hasbar)
        {
            makeHelpbar();
        }
    }    
    public void getList()
    {
        d = bc.kalos;
    }
    public void doAction()
    {
        if(Greenfoot.mousePressed(this))
        {
            MouseInfo ms = Greenfoot.getMouseInfo();
            if(ms.getButton() == 1)
            {
                switch(id)
                {
                    case 1:
                    for(DestructibleObjects a : d)
                    {
                        if(a instanceof VolunteerSphere)
                        {
                            VolunteerSphere b = (VolunteerSphere) a; 
                            int dirx = 0;
                                switch(b.dir)
                                {
                                    case 1: dirx = 2; break;
                                    case 2: dirx = 1; break;
                                }
                        if(b.molotov <= 0)
                        {
                            getWorld().addObject(new Weapons(6, 3, b.realX(), b.realY(), b.getSide(), b.getSide(), 3), a.getX(), a.getY());
                            b.molotov = 200;
                        }
                    }
                }; break;
                    case 2: for(DestructibleObjects a : d){if(a instanceof Ninja){Ninja b = (Ninja) a; if(b.spike <= 0){getWorld().addObject(new Spikes(b.realX(), b.realY()), a.getX(), a.getY()); b.spike = 200;}}}; break;
                    case 3: 
                    for(DestructibleObjects a : d)
                    {
                        if(a instanceof OfficerSphere)
                        {
                            OfficerSphere b = (OfficerSphere) a;
                            if(b.artillery <= 0)
                            {
                                if(b.owner.resources >= 100)
                                {
                                    b.owner.resources -= 100;
                                    b.artillery = 1000;
                                    b.setBehavior(9);
                                    b.castAbility(1);
                                }
                                else
                                {
                                    getWorld().addObject(new ErrorText("You've not enough ore: gather more ore.", 250), 400, 400);
                                }
                            }
                        }
                    }; 
                    break;
                    case 4: 
                    for(DestructibleObjects a : d)
                    {
                        if(a instanceof OfficerSphere)
                        {
                            OfficerSphere b = (OfficerSphere) a;
                            if(b.medkit <= 0)
                            {
                                b.setBehavior(10);
                                b.castAbility(2);
                                b.medkit = 500;
                            }
                        }
                    }; 
                    break;
                }
            }
        }
    }
    public void makeHelpbar()
    {
        if(!hasbar)
        {
        if(intersect())
        {
            switch(id)
            {
                case 1: getWorld().addObject(new HelpTab(this, "Molotov Cocktail", "Hurls a molotov cocktail.", "Can clear garrison.", "Incinerates all units"), 650, 400); break;
                case 2: getWorld().addObject(new HelpTab(this, "Spikes", "Lays an array of spikes to slow enemies down.", "Damages all units, including allies.", "Ninjas are immune to spikes"), 650, 400); break;
                case 3: getWorld().addObject(new HelpTab(this, "Call in Artillery Gun", "Calls an airlift to place an artillery gun.", "costs 100 ore.", "Attacks ground units. strong against vehicles."), 650, 400); break;
                case 4: getWorld().addObject(new HelpTab(this, "Medical Kit", "Officer uses an medical kit to heal allies.", "Heals all allied units, including teammates.", "Works in a small radius around the officer."), 650, 400); break;
            }
            hasbar = true;
        }
        }
    }
}
