import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

/**
 * Write a description of class Upgrade here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Upgrade  extends InGame
{
    private int id;
    private Player owner;
    private Structures origin;
    private boolean needchange = true;
    public Upgrade(int ini, Player cfg, Structures base, int inislot)
    {
        id = ini;
        owner = cfg;
        origin = base;
        switch(id)
        {
            case 1: setImage("GeneticRegeneration.bmp"); break;
            case 2: setImage("APRockets.bmp"); break;
            case 3: setImage("Upgrade.bmp"); break;
            case 4: setImage("BasicTraining.bmp"); break;
            case 5: setImage("BasicWeapons.bmp"); break;
            case 6: setImage("ImprovedWeapons.bmp"); break;
            case 7: setImage("VulcanGun.bmp"); break;
            case 8: setImage("HEShells.bmp"); break;
            case 9: setImage("AdvancedTechnology.bmp"); break;
            case 10: setImage("Upgrade.bmp"); break;
        }
    }
    public void act() 
    {
        // Add your action code here.
        if(Greenfoot.mousePressed(this) && origin.prodtype == 0)
        {
            switch(id)
            {
                case 1: if(origin.getOwner().resources >= 100 && origin.getOwner().Upgrades[1] == 0){origin.setProdMax(800); origin.getOwner().resources -= 100; origin.setProduction(10);} else if(origin.getOwner().Upgrades[1] > 0){getWorld().addObject(new ErrorText("You already have this upgrade.", 100), 400, 400);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 150), 400, 400);}; break;
                case 2: if(origin.getOwner().resources >= 50 && origin.getOwner().Upgrades[2] == 0){origin.setProdMax(400); origin.getOwner().resources -= 50; origin.setProduction(10);} else if(origin.getOwner().Upgrades[2] > 0){getWorld().addObject(new ErrorText("You already have this upgrade.", 100), 400, 400);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 150), 400, 400);}; break;
                case 3: if(origin.getOwner().resources >= 50 && origin.getOwner().Requirements[5] > 0){origin.setProdMax(600); origin.getOwner().resources -= 50; origin.setProduction(11);} else if(origin.getOwner().Requirements[5] <= 0){getWorld().addObject(new ErrorText("Get a Strategy Center, Comrade!", 100), 400, 400);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 150), 400, 400);}; break;
                case 4: if(origin.getOwner().resources >= 100 && origin.getOwner().Upgrades[3] == 0){origin.setProdMax(800); origin.getOwner().resources -= 100; origin.setProduction(10);} else if(origin.getOwner().Upgrades[3] > 0){getWorld().addObject(new ErrorText("You already have this upgrade.", 100), 400, 400);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 150), 400, 400);}; break;
                case 5: if(origin.getOwner().resources >= 100 && origin.getOwner().Upgrades[4] == 0){origin.setProdMax(800); origin.getOwner().resources -= 100; origin.setProduction(11);} else if(origin.getOwner().Upgrades[4] > 0){getWorld().addObject(new ErrorText("You already have this upgrade.", 100), 400, 400);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 150), 400, 400);}; break;
                case 6: if(origin.getOwner().resources >= 100 && origin.getOwner().Upgrades[5] == 0){origin.setProdMax(1000); origin.getOwner().resources -= 100; origin.setProduction(10);} else if(origin.getOwner().Upgrades[5] > 0){getWorld().addObject(new ErrorText("You already have this upgrade.", 100), 400, 400);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 150), 400, 400);}; break;
                case 7: if(origin.getOwner().resources >= 75 && origin.getOwner().Upgrades[6] == 0){origin.setProdMax(600); origin.getOwner().resources -= 75; origin.setProduction(11);} else if(origin.getOwner().Upgrades[3] > 0){getWorld().addObject(new ErrorText("You already have this upgrade.", 100), 400, 400);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 150), 400, 400);}; break;
                case 8: if(origin.getOwner().resources >= 100 && origin.getOwner().Upgrades[7] == 0){origin.setProdMax(750); origin.getOwner().resources -= 100; origin.setProduction(10);} else if(origin.getOwner().Upgrades[3] > 0){getWorld().addObject(new ErrorText("You already have this upgrade.", 100), 400, 400);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 150), 400, 400);}; break;
                case 9: if(origin.getOwner().resources >= 250 && origin.getOwner().Upgrades[8] == 0){origin.setProdMax(1500); origin.getOwner().resources -= 250; origin.setProduction(10);} else if(origin.getOwner().Upgrades[3] > 0){getWorld().addObject(new ErrorText("You already have this upgrade.", 100), 400, 400);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 150), 400, 400);}; break;
                case 10: if(origin.getOwner().resources >= 100 && origin.getOwner().Requirements[15] > 0){origin.setProdMax(750); origin.getOwner().resources -= 100; origin.setProduction(11);} else if(origin.getOwner().Requirements[15] <= 0){getWorld().addObject(new ErrorText("Get a Nanoassembly Mainframe.", 100), 400, 400);} else{getWorld().addObject(new ErrorText("You've not enough ore: gather more ore", 150), 400, 400);}; break;
            }
        }
        if(id != 3 && id != 10 && ((owner.Upgrades[id] <= 0 && id < 4) || (owner.Upgrades[id - 1] <= 0 && id > 5) || (((id == 4 && owner.Upgrades[3] <= 0)) || (id == 5 && owner.Upgrades[4] <= 0))))
        {
            getImage().clear();
            switch(id)
            {
                case 1: setImage("GeneticRegeneration.bmp"); break;
                case 2: setImage("APRockets.bmp"); break;
                case 4: setImage("BasicTraining.bmp"); break;
                case 5: setImage("BasicWeapons.bmp"); break;
                case 6: setImage("ImprovedWeapons.bmp"); break;
                case 7: setImage("VulcanGun.bmp"); break;
                case 8: setImage("HEShells.bmp"); break;
                case 9: setImage("AdvancedTechnology.bmp"); break;
            }
            if((origin.prodtype == 10 || origin.prodtype == 11) && !(id == 5 && origin.prodtype == 10 || id == 4 && origin.prodtype == 11) && !(id == 7 && origin.prodtype == 10 || id == 6 && origin.prodtype == 11))
            {
                Color b = new Color(0,0,0,150);
                getImage().setColor(b);
                getImage().fillRect(0,0,(int)(getImage().getWidth() * origin.getProgress()), getImage().getHeight());
            }
        }
        if(origin.prodtype == 11 && (id == 3 || id == 10))
        {
            getImage().clear();
            switch(id)
            {
                case 3: setImage("Upgrade.bmp"); break;
                case 10: setImage("Upgrade.bmp"); break;
            }
            Color b = new Color(0,0,0,150);
            getImage().setColor(b);
            getImage().fillRect(0,0,(int)(getImage().getWidth() * origin.getProgress()), getImage().getHeight());
        }
        if(((owner.Upgrades[id] > 0 && id != 4 && id != 5) || (((id == 4 && owner.Upgrades[3] > 0)) || (id == 5 && owner.Upgrades[4] > 0))) && id != 3 && needchange)
        {
            needchange = false;
            switch(id)
            {
                case 1: setImage("GeneticRegeneration.bmp"); break;
                case 2: setImage("APRockets.bmp"); break;
                case 4: setImage("BasicTraining.bmp"); break;
                case 5: setImage("BasicWeapons.bmp"); break;
                case 6: setImage("ImprovedWeapons.bmp"); break;
                case 7: setImage("VulcanGun.bmp"); break;
                case 8: setImage("HEShells.bmp"); break;
                case 9: setImage("AdvancedTechnology.bmp"); break;
            }
            Color b = new Color(0,0,0,150);
            getImage().setColor(b);
            getImage().fillRect(0,0,(int)(getImage().getWidth()), getImage().getHeight());
        }
        if(origin instanceof Dojo && ((Dojo)origin).upgraded && id == 3)
        {
            needchange = false;
            setImage("Upgrade.bmp");
            Color b = new Color(0,0,0,150);
            getImage().setColor(b);
            getImage().fillRect(0,0,(int)(getImage().getWidth()), getImage().getHeight());
        }
        if(!hasbar)
        {
            makeHelpbar();
        }
    }    
    public void makeHelpbar()
    {
        if(!hasbar)
        {
        if(intersect())
        {
            switch(id)
            {
                case 1: getWorld().addObject(new HelpTab(this, "Genetically Engineered Regeneration", "TIA Infantry regenerates hitpoints.", "100 Ore", "Ninjas do not benefit from this."), 650, 400); break;
                case 2: getWorld().addObject(new HelpTab(this, "AP Rockets", "Rocket Spheres get an additional rocket", "50 Ore", "Rockets do 10 more AT damage."), 650, 400); break;
                case 3: getWorld().addObject(new HelpTab(this, "Dojo Upgrade", "Allows the player to train Ninjas", "50 Ore, requires Strategy Center", "Provides other minor bonuses"), 650, 400); break;
                case 4: getWorld().addObject(new HelpTab(this, "Basic Training", "Tier 1 EBC infantry gains 20% more hit points.", "100 Ore", "Slightly raises their firing rate."), 650, 400); break;
                case 5: getWorld().addObject(new HelpTab(this, "Basic Weapons", "Increases attack power of Tier 1 EBC infantry.", "100 Ore", "Average damage raised approximately 12%."), 650, 400); break;
                case 6: getWorld().addObject(new HelpTab(this, "Advanced Weapons", "Tier 2 EBC infantry do moer damage.", "100 Ore", "Attack power increased by 25%."), 650, 400); break;
                case 7: getWorld().addObject(new HelpTab(this, "Vulcan Gun", "Troop Carriers fire 20% faster", "75 Ore", ""), 650, 400); break;
                case 8: getWorld().addObject(new HelpTab(this, "HE shells", "Artileries do 33% more damage", "100 Ore", ""), 650, 400); break;
                case 9: getWorld().addObject(new HelpTab(this, "Advanced Technology", "Provides benefits to Tier 3 units", "250 Ore", ""), 650, 400); break;
            }
            hasbar = true;
        }
        }
    }
}
